
__version__ = "1.2"

__doc__ = """ Install script to setup Kuzgun in CMF Site """


from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.Kuzgun import kuzgun_globals
from Products.CMFCore.CMFCorePermissions import View, ManagePortal

import os , shutil

from cStringIO import StringIO
import string

type_list = ['kuzgun_accessories','kuzgun_dbschedular','kuzgun_images',
             'kuzgun_scripts','kuzgun_styles','kuzgun_templates',
	     'kuzgun_task','kuzgun_tree']

# Kurulum baslamadan olmasi gereken veritaban objeleri
default_objects = ['DataBase','Authorization','Preferences','Tasks','Attachments','Archives']
alternate_objects = ['DataBase','DataBase','DataBase','DataBase','DataBase','Archives']
min_default_objects = ['DataBase','Archives']

configlet = { 'id'           : 'kuzgun_setup'
	      , 'name'       : 'Kuzgun Setup'
	      , 'action'     : 'string:${portal_url}/kuzgun_setup'              
	      , 'category'   : 'Products' 
	      , 'visible'    : 1
	      , 'appId'      : 'kuzgun_setup'
	      , 'permission' : ManagePortal
	      , 'imageUrl'   : 'kuzgun_small.gif'
	      }

memberactions = (
    {
	'id': 'kuzgun_main'
	, 'name' : 'Kuzgun Application'
	, 'action': 'string:$portal_url/KuzgunMain2'
	, 'permission': (View,)
	, 'condition' : 'python: member'
	, 'category'   : 'user'
	, 'visible'    : 1
	},
    {
	'id': 'kuzgun_security'
	, 'name' : 'Security'
	, 'action': 'string:$portal_url/kzUsers'
	, 'permission': (View,)
	, 'condition' : 'python: member'
	, 'category'   : 'kuzgun_tabs'
	, 'visible'    : 1
	},
    {
	'id': 'kuzgun_design'
	, 'name' : 'System Design'
	, 'action': 'string:$portal_url/DBDesign'
	, 'permission': (View,)
	, 'condition' : 'python: member'
	, 'category'   : 'kuzgun_tabs'
	, 'visible'    : 1
	},
    {
	'id': 'kuzgun_application'
	, 'name' : 'Application'
	, 'action': 'string:$portal_url/kuzgun_application'
	, 'permission': (View,)
	, 'condition' : 'python: member'
	, 'category'   : 'kuzgun_tabs'
	, 'visible'    : 1
	},
    {
	'id': 'kuzgun_reports'
	, 'name' : 'Reports'
	, 'action': 'string:$portal_url/kuzgun_reports'
	, 'permission': (View,)
	, 'condition' : 'python: member'
	, 'category'   : 'kuzgun_tabs'
	, 'visible'    : 1
	},
    )

memberactionids = []
for action in memberactions:
    memberactionids.append(action["id"])

def uninstall(self):
    out = StringIO()
    skinstool = getToolByName(self,'portal_skins')
    controlPanel = getToolByName(self,'portal_controlpanel')
    portalMembership = getToolByName(self,'portal_membership')
    
    # Unregistering Control Panel Configlet	
    try: controlPanel.unregisterConfiglet('kuzgun_setup')
    except: pass
    actions = list( portalMembership.listActions() )
    selections = []
    for action in actions:
	if action.id in memberactionids:
	    selections.append(actions.index(action))
    if selections:	    
	portalMembership.deleteActions(selections)

    #Uninstall the skins
    skins = skinstool.getSkinSelections()

    type_list.append('kuzgun_shared')
    type_list.append('kuzgun_accessories/local_info')

    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        for type in type_list:
            if type in path:
                try:
                    path.remove(type)
                    out.write('Deleted "%s" to "%s" skin\n' % (type,skin))
                except:
                    pass
            # endif
        # end for
        path = string.join(path,',')
        skinstool.addSkinSelection(skin, path)
    # end for
    
    if 'kuzgun_shared' in skinstool.objectIds():
	skinstool.manage_delObjects('kuzgun_shared')

    portal = skinstool.aq_inner.aq_parent  # plone portal objesi

    if 'Objects' in portal.Members.objectIds():
        portal.Members.manage_delObjects('Objects')
    # fi

    return out.getvalue()


def install(self):

    global CLIENT_HOME

    out = StringIO()

    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')
    controlPanel = getToolByName(self,'portal_controlpanel')
    portalMembership = getToolByName(self,'portal_membership')

    # Before Installation Tests
    if "kuzgun_shared" in skinstool.objectIds():
	skinstool.manage_delObjects('kuzgun_shared')

    portal    = skinstool.aq_inner.aq_parent
    db_ojects = []
    for i in range(len(default_objects)):
	obj_id = default_objects[i]
	if not hasattr(portal,obj_id):
	    if obj_id in min_default_objects:
		raise "Database connection %s was not found" % obj_id
	    else:
		obj_id = alternate_objects[i]
	db_ojects.append(obj_id)
	    
    # Registering Control Panel Configlet	
    controlPanel.registerConfiglet(**configlet)
    
    # Registering Member Actions
    for memberaction in memberactions:
	portalMembership.addAction(**memberaction)
	
    # Adding Directory Views
    for type in type_list:
        if type not in skinstool.objectIds():
            addDirectoryViews(skinstool, 'skins',kuzgun_globals)
            out.write('Added "%s" directory view to portal_skins\n' %type)
        else:
            out.write('Directory view "%s" already added to portal_skins\n' %type)

    type_list.append('kuzgun_accessories/local_info')
    type_list.append('kuzgun_shared')
    # Setup the skins
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        for type in type_list:
            if type not in path:
                try:
                    path.insert(1,type)
                except ValueError:
                    path.append(type)
                out.write('Added "%s" to "%s" skin\n' %(type, skin))
            else:
                out.write('Skipping "%s" skin, "%s" is already set up\n' %(skin, type))

        path = string.join(path,",")
        skinstool.addSkinSelection(skin, path)

    portal_id = skinstool.aq_inner.aq_parent.id
    
    # Referans Dosyalari Yaratilir
    container = skinstool.aq_inner.aq_parent
    
    # Control the existence of previous installed Kuzgun 
    kuzgunexists = "kuzgun" in container.objectIds()
   
    if not kuzgunexists:
	try: container.manage_addProduct['BTreeFolder'].manage_addBTreeFolder('kuzgun')
	except: container.manage_addProduct['CMFPlone'].addPloneFolder('kuzgun','')
        # Veri kismi yaratilir
        container = container.kuzgun
        container.manage_addProduct['CMFPlone'].addPloneFolder('DATA','')
        container = container.DATA
        container.manage_addProduct['CMFPlone'].addPloneFolder('g0','')
        container = container.g0
        container.setTitle("Kuzgun")
        container.manage_addProperty("tagname","group","string")
        container.manage_addProperty("isleaf"  ,"F","string")
        container.manage_addProperty("activate","1","string")
        container.manage_addProperty("order"   ,"1","string")
	container.manage_addProperty("deleted","0","string")
	
	# Kuzgun icin yetkilendirmeler ayarlaniyor
	kuzgun = skinstool.aq_inner.aq_parent.kuzgun
	kuzgun.manage_permission('Add portal content', roles=["Authenticated"], acquire=1)
	kuzgun.manage_permission('Modify portal content', roles=["Authenticated"], acquire=1)
	kuzgun.manage_permission('Delete objects', roles=["Authenticated"], acquire=1)
    
    # Members/Objects yaratiliyor	
    container = skinstool.aq_inner.aq_parent.Members
    if "Objects" not in container.objectIds():
	try: container.manage_addProduct['BTreeFolder'].manage_addBTreeFolder('Objects')
	except: container.manage_addProduct['CMFPlone'].addPloneFolder('Objects','')

    # Kuzgun Shared
    skinstool.manage_addProduct['CMFPlone'].addPloneFolder('kuzgun_shared','')

    #Form Yardmlar icin Sqlite Database alan olutur
    try: os.makedirs("%s/sqlite" % (CLIENT_HOME))
    except: pass
    
    container = skinstool.kuzgun_shared
    
    DBPath  = "kuzgun/DATA"

    # RefData ekle
    container.manage_addProduct['kzReference'].manage_addProduct(id='RefData', title='',BasePath=DBPath)
    
    # kzAuthSQL ekle
    container.manage_addProduct['kzAuthSQL'].manage_addProduct(id='kzAuthSQL', 
							       title='',
							       qdata     = db_ojects[0],
							       qauth     = db_ojects[1],
							       qpref     = db_ojects[2],							       
							       qtask     = db_ojects[3],
							       qattach   = db_ojects[4],
							       qarchives = db_ojects[5])
        
    # Task Manager
    container.manage_addProduct['kzTask'].manage_addTool('kzTaskManager')

    # UserManagement
    container.manage_addProduct['kzUserManagement'].manage_addTool('kzUserManagement')
    
    # kzQueryTool ekle
    container.manage_addProduct['kzQueryTool'].manage_addTool('kzQueryTool')
    
    # MenuCreator
    container.manage_addProduct['kzMenuCreator'].manage_addProduct(id='kzMenuCreatorTool', title='MENU')
    
    # kzFileManager
    container.manage_addProduct['kzFileManager'].manage_addTool('kzFileManager')
    
    
    def getConnectionID(id):
	index = default_objects.index(id)
	return db_ojects[index]
    
    # gecici bir ZSQL Method yaratlr
    container.manage_addProduct['ZSQLMethods'].manage_addZSQLMethod(id="temp",
                                                                    title="",
                                                                    connection_id=getConnectionID("Preferences"),
                                                                    arguments="query",
                                                                    template="<dtml-var query>")
    # Form Kisiselletirmesi icin tablo oluturuluyor
    try:
	container.temp(query="create table form (userid varchar(250),tableid varchar(250),"\
			   + "row integer,col integer,PRIMARY KEY (userid,tableid))" )
    except:
	if not kuzgunexists:
	    raise "Table 'form' exists in the database"

    # Yetkilendirme icin tablo oluturulur
    try:
	container.temp.connection_id = getConnectionID("Authorization")
	container.temp(query="create table auth (userid varchar(250),nodeid varchar(250),"\
		       + "level integer,mode varchar(20),PRIMARY KEY (userid,nodeid))" )
    except:
	if not kuzgunexists:
	    raise "Table 'auth' exists in the database"	
    
    # Gorevlendirme icin tablo olusturulur
    try:
	container.temp.connection_id = getConnectionID("Tasks")
	container.temp(query="CREATE TABLE tasks (id varchar(250) primary key,title varchar(250),description text,"\
		       + "priority integer,starttime varchar(250),deadtime varchar(250),destination text,"\
		       + "owner varchar(250),mode varchar(250),relatedtable varchar(250),relatedrecno varchar(250))" )
    except:
	if not kuzgunexists:
	    raise "Table 'tasks' exists in the database"	
    
    # Attachment icin tablo oluturulur
    try:
	container.temp.connection_id = getConnectionID("Attachments")
	sqlobj = container.kzAuthSQL.getsqlobject()
	blobtype = sqlobj.getblobtype()
	container.temp(query="CREATE TABLE files (id varchar(250) PRIMARY KEY,groupid varchar(250),recno integer,"\
		       + "name varchar(250),type varchar(250),arch varchar(1),auth integer,content %s );"%(blobtype))
    except:
	if not kuzgunexists:
	    raise "Table 'files' exists in the database"	

    # Yaratilan gecici Z SQL Method silinir
    container.manage_delObjects("temp")


    # Form Yardimlari 
    container.manage_addProduct['ZSQLiteDA'].manage_addZSQLiteConnection(id="Accessories",
                                                                         title="Form Yardimlari",
                                                                         connection="Accessories",
                                                                         check="YES")

    container.manage_addProduct['ZSQLMethods'].manage_addZSQLMethod(id="query",
                                                                    title="",
                                                                    connection_id="Accessories",
                                                                    arguments="query",
                                                                    template="<dtml-var query>")

    container.manage_addProduct['ZSQLMethods'].manage_addZSQLMethod(id="select_all",
                                                                    title="",
                                                                    connection_id="Accessories",
                                                                    arguments="table_name",
                                                                    template="select * from <dtml-var table_name>")

	
    return out.getvalue()
