
__version__ = "1.0.1"

__doc__ = """ Install script to setup Kuzgun in CMF Site """


from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.Kuzgun import kuzgun_globals
import os , shutil

from cStringIO import StringIO
import string
type_list = ['kuzgun_accessories','kuzgun_db','kuzgun_images',
             'kuzgun_parameter','kuzgun_scripts','kuzgun_styles',
             'kuzgun_templates','kuzgun_task','kuzgun_dbschedular']

# Kurulum baslamadan olmasi gereken veritaban objeleri
default_objects = ['DataBase','Authorization','Preferences','Tasks','Attachments','Archives']
alternate_objects = ['DataBase','DataBase','DataBase','DataBase','DataBase','Archives']
min_default_objects = ['DataBase','Archives']

def uninstall(self):
    out = StringIO()
    skinstool = getToolByName(self,'portal_skins')

    #Uninstall the skins
    skins = skinstool.getSkinSelections()

    type_list.append('kuzgun_shared')
    type_list.append('kuzgun_templates/ui_slots')
    type_list.append('kuzgun_accessories/local_info')
    type_list.append('kuzgun_db/Parameter')

    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        for type in type_list:
            if type in path:
                try:
                    path.remove(type)
                    out.write('Deleted "%s" to "%s" skin\n' % (type,skin))
                except:
                    pass
            # endif
        # end for
        path = string.join(path,',')
        skinstool.addSkinSelection(skin, path)
    # end for

    portal = skinstool.aq_inner.aq_parent  # plone portal objesi

    if 'Objects' in portal.Members.objectIds():
        portal.Members.manage_delObjects('Objects')
    # fi

    portal_id = portal.id
    try:
        path = "%s/%s" %(CLIENT_HOME,portal_id)
        shutil.rmtree(path)
    except:
        out.write("%s not removed\n" %(path))

    return out.getvalue()

def install(self):

    global CLIENT_HOME

    out = StringIO()

    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')

    # Before Installation Tests
    if "kuzgun_shared" in skinstool.objectIds():
	skinstool.manage_delObjects('kuzgun_shared')

    portal    = skinstool.aq_inner.aq_parent
    db_ojects = []
    for i in range(len(default_objects)):
	obj_id = default_objects[i]
	if not hasattr(portal,obj_id):
	    if obj_id in min_default_objects:
		raise "Database connection %s was not found" % obj_id
	    else:
		obj_id = alternate_objects[i]
	db_ojects.append(obj_id)
	    

    # Adding Directory Views
    for type in type_list:
        if type not in skinstool.objectIds():
            addDirectoryViews(skinstool, 'skins',kuzgun_globals)
            out.write('Added "%s" directory view to portal_skins\n' %type)
        else:
            out.write('Directory view "%s" already added to portal_skins\n' %type)

    type_list.append('kuzgun_templates/ui_slots')
    type_list.append('kuzgun_accessories/local_info')
    type_list.append('kuzgun_db/Parameter')
    type_list.append('kuzgun_shared')
    # Setup the skins
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        for type in type_list:
            if type not in path:
                try:
                    path.insert(1,type)
                except ValueError:
                    path.append(type)
                out.write('Added "%s" to "%s" skin\n' %(type, skin))
            else:
                out.write('Skipping "%s" skin, "%s" is already set up\n' %(skin, type))

        path = string.join(path,",")
        skinstool.addSkinSelection(skin, path)

    portal_id = skinstool.aq_inner.aq_parent.id
    
    # Referans Dosyalari Yaratilir
    container = skinstool.aq_inner.aq_parent
   
    if "kuzgun" not in container.objectIds():
	try: container.manage_addProduct['BTreeFolder'].manage_addBTreeFolder('kuzgun')
	except: container.manage_addProduct['CMFPlone'].addPloneFolder('kuzgun','')
        # Veri kismi yaratilir
        container = container.kuzgun
        container.manage_addProduct['CMFPlone'].addPloneFolder('DATA','')
        container = container.DATA
        container.manage_addProduct['CMFPlone'].addPloneFolder('g0','')
        container = container.g0
        container.setTitle("Kuzgun")
        container.manage_addProperty("tagname","group","string")
        container.manage_addProperty("isleaf"  ,"F","string")
        container.manage_addProperty("activate","1","string")
        container.manage_addProperty("order"   ,"1","string")
	container.manage_addProperty("deleted","0","string")
	
    # Kuzgun icin yetkilendirmeler ayarlaniyor
    kuzgun = skinstool.aq_inner.aq_parent.kuzgun
    kuzgun.manage_permission('Add portal content', roles=["Authenticated"], acquire=1)
    kuzgun.manage_permission('Modify portal content', roles=["Authenticated"], acquire=1)
    kuzgun.manage_permission('Delete objects', roles=["Authenticated"], acquire=1)
    
    # Members/Objects yaratiliyor	
    container = skinstool.aq_inner.aq_parent.Members
    if "Objects" not in container.objectIds():
	try: container.manage_addProduct['BTreeFolder'].manage_addBTreeFolder('Objects')
	except: container.manage_addProduct['CMFPlone'].addPloneFolder('Objects','')

    # Kuzgun Shared
    skinstool.manage_addProduct['CMFPlone'].addPloneFolder('kuzgun_shared','')

    #Form Yardmlar icin GadFly Database alan olutur
    try: os.makedirs("%s/sqlite" % (CLIENT_HOME))
    except: pass
    os.chdir("%s/sqlite" % (CLIENT_HOME))

    container = skinstool.kuzgun_shared
    
    DBPath  = "kuzgun/DATA"
    container.manage_addProduct['kzQueries'].manage_addProduct(id="Queries",
							       title="Kuzgun Sabitleri",
                                                               DBPath=DBPath)
    Queries = getattr(container,'Queries')

    # RefData ekle
    container.manage_addProduct['kzReference'].manage_addProduct(id='RefData', title='',BasePath=Queries.DBPath)
    
    # kzAuthSQL ekle
    container.manage_addProduct['kzAuthSQL'].manage_addProduct(id='kzAuthSQL', 
							       title='',
							       qdata     = db_ojects[0],
							       qauth     = db_ojects[1],
							       qpref     = db_ojects[2],							       
							       qtask     = db_ojects[3],
							       qattach   = db_ojects[4],
							       qarchives = db_ojects[5])
        
    # Task Manager
    container.manage_addProduct['kzTask'].manage_addTool('kzTaskManager')

    # UserManagement
    container.manage_addProduct['kzUserManagement'].manage_addTool('kzUserManagement')
    
    # kzQueryTool ekle
    container.manage_addProduct['kzQueryTool'].manage_addTool('kzQueryTool')
    
    # MenuCreator
    container.manage_addProduct['kzMenuCreator'].manage_addProduct(id='kzMenuCreatorTool', title='MENU')
    
    # kzFileManager
    container.manage_addProduct['kzFileManager'].manage_addTool('kzFileManager')
    
    
    def getConnectionID(id):
	index = default_objects.index(id)
	return db_ojects[index]
    
    # gecici bir ZSQL Method yaratlr
    container.manage_addProduct['ZSQLMethods'].manage_addZSQLMethod(id="temp",
                                                                    title="",
                                                                    connection_id=getConnectionID("Preferences"),
                                                                    arguments="query",
                                                                    template="<dtml-var query>")
    # Form Kiiselletirmesi i�n tablo oluturuluyor
    container.temp(query="create table form (userid varchar(250),tableid varchar(250),"\
                       + "row integer,col integer,PRIMARY KEY (userid,tableid))" )

    # Yetkilendirme i�n tablo oluturulur
    container.temp.connection_id = getConnectionID("Authorization")
    container.temp(query="create table auth (userid varchar(250),nodeid varchar(250),"\
                       + "level integer,mode varchar(20),PRIMARY KEY (userid,nodeid))" )
    
    # G�evlendirme i�n tablo olusturulur
    container.temp.connection_id = getConnectionID("Tasks")
    container.temp(query="CREATE TABLE tasks (id varchar(250) primary key,title varchar(250),description text,"\
    		   + "priority integer,starttime varchar(250),deadtime varchar(250),destination text,"\
    		   + "owner varchar(250),mode varchar(250),relatedtable varchar(250),relatedrecno varchar(250))" )
    
    # Attachment i�n tablo oluturulur
    container.temp.connection_id = getConnectionID("Attachments")
    sqlobj = container.kzAuthSQL.getsqlobject()
    blobtype = sqlobj.getblobtype()
    container.temp(query="CREATE TABLE files (id varchar(250) PRIMARY KEY,groupid varchar(250),recno integer,"\
		   + "name varchar(250),type varchar(250),arch varchar(1),auth integer,content %s );"%(blobtype))

    # Yaratlan ge�ci Z SQL Method silinir
    container.manage_delObjects("temp")


    # Form Yard�lar�i�n
    container.manage_addProduct['ZGadflyDA'].manage_addZGadflyConnection(id="Accessories",
                                                                         title="Form Yardimlari",
                                                                         connection="Accessories",
                                                                         check="YES")

    container.manage_addProduct['ZSQLMethods'].manage_addZSQLMethod(id="query",
                                                                    title="",
                                                                    connection_id="Accessories",
                                                                    arguments="query",
                                                                    template="<dtml-var query>")

    container.manage_addProduct['ZSQLMethods'].manage_addZSQLMethod(id="select_all",
                                                                    title="",
                                                                    connection_id="Accessories",
                                                                    arguments="table_name",
                                                                    template="select * from <dtml-var table_name>")


    container.kuzgun_scripts.addAllPortalUsers()
    
    return out.getvalue()
