# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
from OFS import Moniker
from Acquisition import aq_base, aq_inner, aq_parent

CopyError='Copy Error'

"""
srcCnt = source container
dstCnt = destination container
ids    = object ids

"""

class kzCutCopyPaste:

  def __init__(self):
    pass
    
  def sanity_check(self, c, ob):
    # This is called on cut/paste operations to make sure that
    # an object is not cut and pasted into itself or one of its
    # subobjects, which is an undefined situation.
    ob = aq_base(ob)
    while 1:
      if aq_base(c) is ob:
        return 0
      inner = aq_inner(c)
      if aq_parent(inner) is None:
        return 1
      c = aq_parent(inner)
  
  def copyPaste(self, srcCont, dstCont, ids):
  
    """
    """
    
    #copy    
    if type(ids) is type(''):
      ids = [ids]
    oblistt = []
    for id in ids:
      ob=srcCont._getOb(id)
      if not ob.cb_isCopyable():
          raise CopyError, eNotSupported % id
      m=Moniker.Moniker(ob)
      oblistt.append(m.dump())
      
    # paste      
    result = []
    oblist = []
    app    = dstCont.getPhysicalRoot()
    
    for mdata in oblistt:
      m = Moniker.loadMoniker(mdata)
      try: ob = m.bind(app)
      except: raise CopyError, eNotFound
      #dstCont._verifyObjectPaste(ob)
      oblist.append(ob)
       
    for ob in oblist:
      if not ob.cb_isCopyable():
          raise CopyError, eNotSupported % ob.getId()
      try:    ob._notifyOfCopyTo(dstCont, op=0)
      except: raise CopyError, MessageDialog(
          title='Copy Error',
          message=sys.exc_info()[1],
          action ='manage_main')
      ob=ob._getCopy(dstCont)
      orig_id=ob.getId()
      id=dstCont._get_id(ob.getId())
      result.append({'id':orig_id, 'new_id':id})
      ob._setId(id)
      dstCont._setObject(id, ob)
      ob = dstCont._getOb(id)
      ob.manage_afterClone(ob)  
    return result
  
  
  def cutPaste(self, srcCont, dstCont, ids):
  
    """
    """
    
    # cut
    if type(ids) is type(''):
      ids = [ids]
    oblistt = []
    for id in ids:
      ob=srcCont._getOb(id)
      if not ob.cb_isMoveable():
          raise CopyError, eNotSupported % id
      m=Moniker.Moniker(ob)
      oblistt.append(m.dump())
    
    # paste
    oblist = []
    result = []
    app    = dstCont.getPhysicalRoot()
    
    for mdata in oblistt:
        m = Moniker.loadMoniker(mdata)
        try: ob = m.bind(app)
        except: raise CopyError, eNotFound
        #dstCont._verifyObjectPaste(ob)
        oblist.append(ob)
    
    for ob in oblist:
      id=ob.getId()
      if not ob.cb_isMoveable():
        raise CopyError, eNotSupported % id
      try:    ob._notifyOfCopyTo(dstCont, op=1)
      except: raise CopyError, MessageDialog(
          title='Move Error',
          message=sys.exc_info()[1],
          action ='manage_main')
      if not self.sanity_check(dstCont, ob):
        raise CopyError, 'This object cannot be pasted into itself'
    
      # try to make ownership explicit so that it gets carried
      # along to the new location if needed.
      ob.manage_changeOwnershipType(explicit=1)
    
      aq_parent(aq_inner(ob))._delObject(id)
      ob = aq_base(ob)
      orig_id=id
      id=dstCont._get_id(id)
      result.append({'id':orig_id, 'new_id':id })
      ob._setId(id)
    
      dstCont._setObject(id, ob, set_owner=0)
    
      # try to make ownership implicit if possible
      ob=dstCont._getOb(id)
      ob.manage_changeOwnershipType(explicit=0)        
  
    return result
