# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
#  Project Name     :Kuzgun E- Platformu
#  Modul   Name     :kzNumeric
#  Hedefleri        :Numeric snfn oluturmak
#  Developer        :Okan Akbulut
#  Copyright        :Anka Bilgi Teknolojileri 2002
#  Kullanm Haklar :Her Hakk Sakldr
#  Conditions       :
#  Files            :
#---------------------------------------------------------------------
#  History          :  Date  Version   Developer   Deiiklikler

import string
import math
import sys

class kzNumeric:	

    
    def __init__(self,data,Language = 'english'): 
        "ilk deer verme"
        try:
            self.input(data)
            if Language == 'turkce':
                import turkce
                self.loc = turkce
            else:
                import english
                self.loc = english
        except:
            raise '|kzNumeric.__init__:'        

    def __str__(self):
        return str(self.data)	
    
    def input(self,data):
        "say girii"				
        try:
            self.data = float(data)
        except:
            raise '|kzNumeric.input:Hatal giri'	
                            
    def out(self,format='NUMERIC',space=' '):
        try :
            if format == 'NUMERIC':
                return str(self.data)
            else :#STRING                
                return self.loc.write(self.data,space)             
        except:
            raise sys.exc_type + '|kzNumeric.out:'

    def fix(self,digs):# digs noktadan sonraki hane duyarll
        try:
            import fpformat
            self.data = fpformat.fix(self.data,digs)
        except:
            raise 'kzNumeric.fix:'
        
    def hexal(self):
        "hexal karl"
        return hex(long(self.data))
    
    def binary(self):
        "binary karl"
        binary = long(self.data)
        result = ''
        while(binary > 0):
            remaind = binary % 2
            binary  = binary >> 1
            result  = str(remaind)[0] + result 
        return result	
    
    def octal(self):	
        "octal karl"
        return oct(long(self.data))	
    
    def ceil(self): 
        "kendinden bir byk, tamsayya dntrr"
        try:
            import math
            self.data = math.ceil(self.data)
        except:
            raise sys.exc_type + 'kzNumeric.ceil:'
        
    def __int__(self):
        return int(self.data)
    
    def __cmp__(self,other):
        try:
            return cmp( self.data , float(other) )
            
        except:			
            raise str(sys.exc_type)+"|kzNumeric.__cmp__:"
        
    def __float__(self):		
        return float(self.data)
    
    def __neg__(self):
        return  -self.data
        
    
    def __add__(self,other):
        try :
            return  self.data + float(other)
            
        except:
            raise 'kzNumeric.__add__:Tip hatas'
        
    def __sub__(self,other)	:
        try:			
            return self.data - float(other)
            
        except:
            raise 'kzNumeric.__sub__:Tip hatas'
        
    def __mul__(self,other):
        try :			
            return  self.data * float(other) 
            
        except:
            raise 'kzNumeric.__mull__:Tip hatas'
        
    def __div__(self,other):
        try:			
            return  self.data / float(other)
        except:
            raise 'kzNumeric.__div__:Tip hatas'
        
    def __mod__(self,other):
        try:
            return self.data % float(other)
        except:
            raise sys.exc_type + 'kzNumeric.__mod__:'
            
    def __pow__(self,other):
        try:
            return pow(self.data,float(other))
             
        except:
            raise sys.exc_type + 'kzNumeric.__pow__:'
        
    def __abs__(self):	
        return abs(self.data)
    
    def add(self,other):
        self.data = self + other

    def sub(self,other):
        self.data = self - other
    
    def mull(self,other):	
        self.data = self * other
    
    def div(self,other):		
        self.data = self / other
    
    def pow(self,other):		
        self.data = self ** other 
    
    def abs(self):
        self.data = abs(self)
    
    def mod(self,other):
        self.data = self % other
    
    def int(self):
        self.data = int(self)
        return self
    
    def negative(self):
        return -self
    
    def percent(self,per):
        try:
            per = float(per)
            if not( 0 < per <= 100):
                raise 'kzNumeric.percent:yzde  0-100 aralnda olmal'
            return (self / 100.0) * per
        except:
            raise sys.exc_type + 'kzNumeric.percent:'
        
    def pi(self): # pi saysn dndrr
        try:			
            return str(math.pi)
        except:
            raise sys.exc_type + 'kzNumeric.pi:'
        
    def e(self): # e saysn dndrr 
        try:			
            return str(math.e)
        except :
            raise sys.exc_type + 'kzNumeric.e:'
        
    def log(self): # Doal Logaritma
        try:			
            return math.log(self.data)
        except:
            raise sys.exc_type + 'kzNumeric.log:'
    def log10(self): 	
        try:			
            return math.log10(self.data)
        except:
            raise sys.exc_type + 'kzNumeric.log10:'

    def sqrt(self):
        try:			
            return math.sqrt(self.data)
        except:
            raise sys.exc_type + 'kzNumeric.sqrt:'
if __name__=='__main__':
    
    d = kzNumeric(100.0)
    #print d.mull(2.0)
    print d.percent(45)
    print d.binary()
    #d.ceil()
    print d.out()
    d.int()
    print d.out()
    print d.log()
    print d.log10()
    print d.sqrt()
    print d.mod(9.91)
    d.pow(3)
    d.add(123)
    print d.out()
    i = raw_input()


