# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
from reportlab.platypus import Table,TableStyle,XPreformatted,Paragraph
from reportlab.platypus import SimpleDocTemplate
from reportlab.lib.units import inch
from reportlab.lib import colors

from reportlab.pdfbase import pdfmetrics
from reportlab.pdfbase.ttfonts import TTFont
from reportlab.lib.fonts import addMapping
import os
from DateTime import DateTime
from reportlab.lib.styles import ParagraphStyle
from reportlab.lib.styles import getSampleStyleSheet

# pdf üretirken dosya yerine kullanmak için
from cStringIO import StringIO

headBackgroundColor = colors.white
headTextColor = colors.black
RowDarkBackgroundColor = colors.white
RowDarkTextColor = colors.black
RowLightBackgroundColor = colors.white
RowLightTextColor = colors.black
PAGE_SIZE = 30
font_size = 8

font = TTFont('KuzgunFont','luxiserif.ttf')
pdfmetrics.registerFont(font)

addMapping('KuzgunFont', 0, 0, 'KuzgunFont')
addMapping('KuzgunFont', 0, 1, 'KuzgunFont')
addMapping('KuzgunFont', 1, 0, 'KuzgunFont')
addMapping('KuzgunFont', 1, 1, 'KuzgunFont')
# sayfadaki satr sys
stylesheet = getSampleStyleSheet()
normalStyle = stylesheet['Normal']
rowColor = [[RowDarkBackgroundColor,RowDarkTextColor],\
	    [RowLightBackgroundColor,RowLightTextColor]]


def createPDF():
    trueColor = 0 
    pdfFile = StringIO()

    if trueColor:	
	headTextColor = colors.blue #self.GetColor(styleFile,"div.kzQueryInterface thead"," color")
	headBackgroundColor = colors.yellow #self.GetColor(styleFile,"div.kzQueryInterface thead","background-color")
	RowLightBackgroundColor = colors.yellow #self.GetColor(styleFile,"div.kzQueryInterface tr.light","background-color")
	RowLightTextColor = colors.blue #self.GetColor(styleFile,	"div.kzQueryInterface tr.light"," color")
	RowDarkBackgroundColor = colors.blue #self.GetColor(styleFile,"div.kzQueryInterface tr.dark","background-color")
	RowDarkTextColor = colors.blue #self.GetColor(styleFile,"div.kzQueryInterface tr.dark"," color")
    else:
	headBackgroundColor = colors.white
	headTextColor = colors.black
	RowLightBackgroundColor = colors.white
	RowLightTextColor = colors.black
	RowDarkBackgroundColor = colors.white
	RowDarkTextColor = colors.black
    #fi
    
    pStyle = ParagraphStyle('normal')
    ListType = type([])
    StringType = type('string')
    viewedHeads=copy.deepcopy(request.SESSION['kzQueryTool']['indexedFields'])
    init_row=request.SESSION['kzQueryTool']['min_row']
    rowcount=request.SESSION['kzQueryTool']['ViewedRows']
    minCol=int(request.get('min_col','0'))
    maxCol=int(request.get('max_col','0'))
    
    viewedHeads+=copy.deepcopy(request.SESSION['kzQueryTool']['notIndexedFields'][minCol:maxCol])
    
    head=[]
    for i in range(len(viewedHeads)):
	head.append(request.SESSION['kzQueryTool']["field_ids"][viewedHeads[i]][2])
	
    leng=len(request.SESSION['kzQueryTool']['Records'])
    rows=[]
    for row in range(init_row,init_row+rowcount):
	data=''  
	index=[]
	for tagid in viewedHeads:
	    data=request.SESSION['kzQueryTool']['Records'][row%leng][tagid]
	    if data != '' and data != None:
		index.append(data)
	    else:
		index.append('-')
	rows.append(index)
		
    doc = SimpleDocTemplate(pdfFile)		
    lst = []
    t ,sum = createTable(head,rows)
    lst.append(t)
    if sum > 590 :
	doc.pagesize = (doc.height,doc.width)
    #fi			
    doc.build(lst)
    f  = open('/tmp/deneme.pdf','w')
    f.write(pdfFile.read())
    f.close()
    self.aq_parent.temp_folder.manage_addFile(id=fileName,title='grid auto generate',file=pdfFile)
    request.SESSION['kzQueryTool']['PDF'] = fileName
    request.SESSION['kzQueryTool']['PDF_flag'] = 1		
    
    

    
    
    
def createTable(head,data):     
    

    head = headConvert(head)
    cCount = len( head ) # column size
    td_size = []         # maximum column(s) size
    result = []
    tableStyle = TableStyle()
    lineCount = 0
    for tr in data:				
	table_tr = []
	col = 0
	for td_cell in tr:
	    
	    text = '<font name="KuzgunFont" size="%s">%s</font>' %(font_size,td_cell)
	    table_tr.append( Paragraph(text,normalStyle) )
	    tableStyle.add('LEFTPADDING',(col,lineCount),(col-1,lineCount-1),2)
	    tableStyle.add('RIGHTPADDING',(col,lineCount),(col-1,lineCount-1),2)
	    col += 1
	#endfor
	if not lineCount:             # (lineCount % PAGE_SIZE):
	    result.append( head )
	    tableStyle.add('TEXTCOLOR' ,(0,lineCount),(cCount-1,lineCount),headTextColor) 
	    tableStyle.add('BACKGROUND',(0,lineCount),(cCount-1,lineCount),headBackgroundColor)
	    lineCount += 1
	#fi
	result.append( table_tr )
	tableStyle.add('BACKGROUND',(0,lineCount),(cCount-1,lineCount),rowColor[lineCount % 2][0])
	tableStyle.add('TEXTCOLOR' ,(0,lineCount),(cCount-1,lineCount),rowColor[lineCount % 2][1])				
	lineCount += 1
    #endfor	
    rCount = lineCount
    tableStyle.add('GRID',(0,0),(cCount-1,rCount-1),1,colors.black)								
    table = Table(result)
    table.setStyle(tableStyle)
    c = 0
    sum = 0
    for size in getColumnSize(result):
	sum += size * 0.4
	table._argW[c] = size * 0.4
	c +=1
    #endfor
    return table , sum	    
        
def headConvert(head):
    thead = []
    for th in head:
	text = '<font name="KuzgunFont" size="%s"><b>%s</b></font>' %(font_size,th)
	pdf_size = font.stringWidth(text,10)
	thead.append( Paragraph(text,normalStyle) )
    #end for
    return thead

def getColumnSize(data):
    cCount = len( data[0] )				
    column_size = cCount*[0]
    for row in data:
	for column in range(cCount):
	    cellPara = row[column]
	    size = font.stringWidth(cellPara.text,font_size)
	    if size > column_size[column]:column_size[column] = size
	    
    return column_size



if __name__ == '__main__':
    head = ["head1","head2","head3","head4"]
    data = [
	["R1D1","R1D2","R1D3","R1D4"],
	["R2D1","R2D2","R2D3","R2D4"],
	["R3D1","R3D2","R3D3","R3D4"],
	["R4D1","R4D2","R4D3","R4D4"],	
	]
    
    fileName = 'grid%s.pdf' %(str(float(DateTime())).replace('.','_'))
    tmpFolder        = os.path.join('/','tmp',fileName)
    doc = SimpleDocTemplate(tmpFolder)		
    lst = []
    t ,sum = createTable(head,rows)
    lst.append(t)
    if sum > 590 :
	doc.pagesize = (doc.height,doc.width)
    #fi			
    doc.build(lst)
    pdfFile = open(tmpFolder)		
    self.aq_parent.temp_folder.manage_addFile(id=fileName,title='grid auto generate',file=pdfFile)
    request.SESSION['kzQueryTool']['PDF'] = fileName
    request.SESSION['kzQueryTool']['PDF_flag'] = 1		
    pdfFile.close()
    
