# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
import copy
from types import *



def minor(matrix,j,k):# j:satir,k:sutun
    newMatrix =[]
    n = len(matrix[0]) # matrisin boyu
    rangeList = range(n)
    rangeList.remove(j)
    for i in rangeList:
        newMatrix.append(matrix[i][:k] + matrix[i][k+1:])        
    #endfor  
    return determinant(newMatrix)

  
def determinant(matrix):
    "nxn bir matrisin determinantini hesaplar"
    if len(matrix[0]) == 2:
        return matrix[0][0]*matrix[1][1] - matrix[0][1]*matrix[1][0]
    elif len(matrix[0]) > 2 :
        row  = matrix[0]
        det  = 0
        n    = len(row) #
        for i in range(n):              
            det = det + row[i] * cofactor(matrix,0,i)
        #endfor
    else:
        return matrix[0][0]
        
    return det
        
        
def cofactor(matrix,j,k):#j:satir,k:sutun
    "matrisin (j,k) elemanini kofaktrn hesaplar"
    return pow(-1,j+k)*minor(matrix,j,k)

def transpoze(matrix):
    "mxn bir matrisin satirlarini sutun, sutunlarini satir yapar"
    m         = len(matrix)
    try:
        n         = len(matrix[0])
    except:
        if type([]) != type(matrix[0]):
            n= 1
            liste = []
            for l in matrix:
                liste.append([l])
            #endfor
            matrix = liste
        else:
            raise
    transpoze = []
    for i in range(n): # n*0 bir matris olusturur
        transpoze.append([])
    #endfor
    for i in range(m):
        for j in range(n):
            transpoze[j].append(matrix[i][j])
        #endfor
    #endfor
    return transpoze

def scalermull(scaler,matrix):
    n = len(matrix)
    for i in range(n):
        for j in range(n):
            matrix[i][j] = scaler * matrix[i][j]
        #endfor
    #endfor
    return matrix

def mull(A_xy,B_yz):
    """"x*y lik bir matris ile y*z lik bir matrisi 
    arpar sonuc x*z lik bir matris olur"""
    x = len(A_xy)
    y = len(A_xy[0])
    z = len(B_yz[0])
    
    mullMatrix = []
    for i in range(x):
        mullMatrix.append([])
        
        for j in range(z):
            tmp = 0
            
            for k in range(y):
                tmp = tmp + A_xy[i][k] * B_yz[k][j]
            #endfor
            mullMatrix[i].append(tmp)
        #endfor
    #endfor
    return mullMatrix

def inverseMatrix(matrix):
    n = len(matrix[0])
    inverseMatrix = []
    det = determinant(matrix)
    for j in range(n):
        inverseMatrix.append([])
        for k in range(n):
            inverseMatrix[j].append(cofactor(matrix,j,k))
        #endfor
    #endfor
    inverseMatrix = scalermull(1/float(det),transpoze(inverseMatrix))
    return inverseMatrix        
            
def reduceAnEquation(A,B):
    """A * X = B denklemini zer
    a1*x1 + b1*x2 + c1*x3 ... = y1
    a2*x2 + b2*x2 + c2*x3 ... = y2
    ......
    ...    
    A: katsayi matrisi
    B: yi matrisi"""
    invA    = inverseMatrix(A)
    xMatrix = mull(invA,B)
    return xMatrix

def matrix1(n,m):
    "nxm lik tm elemanlari 1 olan matris"
    result = []
    for i in range(n):
        result.append([])
        for j in range(m):
            result[i].append(1)
    #endfor
    return result

def diffMatrix(Matrix1,Matrix2):    
    " mxn lik iki matris arasinda ikarma ilemi yapar"
    m = len(Matrix1)
    n = len(Matrix1[0])
    resultMatrix = []
    for i in range(m):
        resultMatrix.append([])
        for j in range(n):
            diff = Matrix1[i][j] - Matrix2[i][j]
            resultMatrix[i].append(diff)
        #endfor
    #endfor
    return resultMatrix





class matrix:
    "_m listesinin her elemani bir satir"
    #_matrix = []
    
    def __init__(self,*rows):#liste=[[colon1],[colon2],[colon3],..]
        "listenin her elemani bir kolon ve boylari esit"
        self._matrix = list()
        self.colCount = 0
        self.rowCount = 0
        
        if len(rows) != 0:
            for row in rows:
                self.addRow(row)
            #endfor
        #fi        
                                                                                         
    def set(self,row,column,value):        
        try:
            temp = float(value)  # sayisal deger olmasi gerekir
        except:
            raise 'Type Error'
        
        self._matrix[row][column] = value
        
    def get(self,row,column):        
        return self._matrix[row][column]
    
    def transpoze(self):
        transpozeMatrix = matrix()
        for j in range(self.colCount):
            transpozeMatrix.addRow(self.getColumn(j))
        #endfor
        return transpozeMatrix
        
    def addColumn(self,column): 
        if len(column) == self.rowCount : 
            if type(column) == ListType:
                for i in range(self.rowCount):
                    self._matrix[i].append(column[i])
                #endfor
                self.colCount += 1
            else:
                raise             
        elif self.rowCount == 0:
            for i in range(len(column)):
                self._matrix.append(list())
            #endfor
            self.rowCount = len(column)
            self.addColumn(column)
        else:
            raise
        
    def addRow(self,row):
        if len(row) == self.colCount:
            if type(row) == ListType:
                self._matrix.append(row)
                self.rowCount += 1
            else:
                raise            
        elif self.colCount == 0:
            self.colCount = len(row)
            self.addRow(row)
        else:
            raise
        #fi
        
    def getRow(self,i):
        if i < self.rowCount:
            return copy.deepcopy(self._matrix[i])                   
        #fi          
    def getColumn(self,j):
        if j < self.colCount:
            column = list()
            for i in range(self.rowCount):
                column.append(self.get(i,j))
            #endfor
            return column
        #fi                                               
        else:
            raise
        
    def __add__(self):
        pass
    def __mull__(self,other):
        pass
    def __sub__(self):
        pass
    def inverse(self):
        pass
    def scalerMull(self,scaler):
        pass
    def mull(self,other):
        if self.colCount == other.rowCount :
            mullMatrix = matrix()
            for i in range(self.rowCount):
                row = list()
                for oj in range(other.colCount):
                    x = 0
                    for j in range(other.rowCount):
                        x += self.get(i,j) * other.get(j,oj)
                    #endfor
                    row.append(x)
                #endfor
                mullMatrix.addRow(row)
            #endfor
            return mullMatrix
        else:
            raise

    def diff(self,other):
        pass    
    def cofactor(self,r,c):
        pass
    def determinant(self):
        pass
    def minor(self,r,c):
        pass
    def transpoze(self):
        pass
    
    
    
    
    
    
if __name__ == "__main__":
    m1 = matrix([1,2,3],[4,5,6])
    m2 = matrix([1,1],[1,1],[1,1])
    m3 = m1.mull(m2)
    print m3.getRow(0)
    print m3.getRow(1)
    i = raw_input()
