# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
import copy
from types import *


         
def reduceAnEquation(A,B):
    """A * X = B denklemini zer
    a1*x1 + b1*x2 + c1*x3 ... = y1
    a2*x2 + b2*x2 + c2*x3 ... = y2
    ......
    ...    
    A: katsayi matrisi
    B: sonu matrisi"""
    invA    = A.inverse() #inverseMatrix(A)
    xMatrix = invA * B
    return xMatrix

def matrix1(n,m):
    "nxm lik tm elemanlari 1 olan matris"
    result = matrix()
    for i in range(n):
        row = [1] * m
        result.addRow(row)        
    #endfor
    return result

class matrix:
    "_matrix listesinin her elemani bir satir"
    

    def __init__(self,*rows):#liste=[[row1],[row2],[row3],..]
        "listenin her elemani bir satir ve boylari esit"
        self._matrix = list('')
        self.colCount = 0
        self.rowCount = 0
        
        if len(rows) != 0:
            for row in rows:
                self.addRow(row)
            #endfor
        #fi        

    def __add__(self,other):
        if type(self) == type(other)       and \
           self.rowCount == other.rowCount and \
           self.colCount == other.colCount:
            sumMatrix = matrix()
            for i in range(self.rowCount):
                row = list('')
                for j in range(self.colCount):
                    row.append(self.get(i,j)+other.get(i,j))
                #endfor
                sumMatrix.addRow(row)
            #endfor
            return sumMatrix
        else :
            raise                                                   
    
    def __mul__(self,other):
        if type(other) == type(self):
            return self.mull(other)
        else:
            return self.scalerMull(other)
        
    def __sub__(self,other):
        if type(self) == type(other)       and \
           self.rowCount == other.rowCount and \
           self.colCount == other.colCount:
            diffMatrix = matrix()
            for i in range(self.rowCount):
                row = list('')
                for j in range(self.colCount):
                    row.append(self.get(i,j)-other.get(i,j))
                #endfor
                diffMatrix.addRow(row)
            #endfor
            return diffMatrix
        else:
            raise
       
        
        
    def set(self,row,column,value):        
        try:
            temp = float(value)  # sayisal deger olmasi gerekir
        except:
            raise 'Type Error'
        
        self._matrix[row][column] = value
        
    def get(self,row,column):        
        return self._matrix[row][column]
    
        
    def addColumn(self,column): 
        if len(column) == self.rowCount : 
            if type(column) == ListType:
                for i in range(self.rowCount):
                    self._matrix[i].append(column[i])
                #endfor
                self.colCount += 1
            else:
                raise             
        elif self.rowCount == 0:
            for i in range(len(column)):
                self._matrix.append(list(''))
            #endfor
            self.rowCount = len(column)
            self.addColumn(column)
        else:
            raise
        
    def addRow(self,row):
        if len(row) == self.colCount:
            if type(row) == ListType:
                self._matrix.append(row)
                self.rowCount += 1
            else:
                raise            
        elif self.colCount == 0:
            self.colCount = len(row)
            self.addRow(row)
        else:
            raise
        #fi
        
    def getRow(self,i):
        if i < self.rowCount:
            return copy.deepcopy(self._matrix[i])                   
        #fi    
    def delRow(self,i):
        del self._matrix[i]
        self.rowCount -= 1
    def getColumn(self,j):
        if j < self.colCount:
            column = list('')
            for i in range(self.rowCount):
                column.append(self.get(i,j))
            #endfor
            return column
        #fi                                               
        else:
            raise
        
    def delColumn(self,j):
        for i in range(self.rowCount):
            del self._matrix[i][j]
        #endfor    
        self.colCount -= 1
        
    def transpoze(self):
        transpozeMatrix = matrix()
        for j in range(self.colCount):
            transpozeMatrix.addRow(self.getColumn(j))
        #endfor
        return transpozeMatrix
        
        
        
        
        
        
    def cofactor(self,i,j):
        return pow(-1,i+j)*self.minor(i,j)
    
    def minor(self,i,j):
        minorMatrix = matrix()
        rowList = range(self.rowCount)
        del rowList[i]
        for i in rowList:
            row = self.getRow(i)
            del row[j]
            minorMatrix.addRow(row)
        #endfor
        return minorMatrix.determinant()
            
    def determinant(self):
        if self.rowCount == self.colCount:
            if self.rowCount == 2:
                return self.get(0,0)*self.get(1,1) - (self.get(0,1)*self.get(1,0))
            elif self.rowCount > 2:
                i   = 1 #0. satir iin islem yapilacak
                det = 0
                for j in range(self.colCount):
                    xij = self.get(i,j)
                    c   = self.cofactor(i,j)
                    det += xij * c
                #endfor
                return det
            elif self.rowCount==1:
                return self.get(0,0)
            else:
                raise
                
                
        else:
            raise
    def inverse(self):
        inverseMatrix = matrix()
        det = self.determinant()
        if det != 0:
            for i in range(self.rowCount):
                row = list('')
                for j in range(self.colCount):
                    row.append(self.cofactor(i,j))
                #endfor
                inverseMatrix.addRow(row)
            #endfor
            return inverseMatrix.transpoze() * (1/float(det))
        else:
            raise           
            
            
        return self * (-1/float(det))
    def scalerMull(self,scaler):
        scalerMatrix = matrix()
        for i in range(self.rowCount):
            row = list('')
            for j in range(self.colCount):
                row.append(self.get(i,j)*scaler)
            #endfor
            scalerMatrix.addRow(row)
        #endfor
        return scalerMatrix
        
    def mull(self,other):
        if self.colCount == other.rowCount :
            mullMatrix = matrix()
            for i in range(self.rowCount):
                row = list('')
                for oj in range(other.colCount):
                    x = 0.0
                    for j in range(other.rowCount):
                        x += float(self.get(i,j)) * other.get(j,oj)
                    #endfor
                    row.append(x)
                #endfor
                mullMatrix.addRow(row)
            #endfor
            return mullMatrix
        else:
            raise

   
  
    
    
    
    
    
    
    
if __name__ == "__main__":
    m1 = matrix([1,3],[5,2])
    m2 = m1.determinant()
    i = raw_input()
