# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
import kzStatistics 
import kzMath
import math
def y(x,b0,b1):
    return b0 + b1*x 

def simpleRegression(xList,yList):
  """basit regresyon: x ve y arasindaki 
  iliskiyi veren denklemi bulmak"""
  xbar = kzStatistics.mean(xList)
  ybar = kzStatistics.mean(yList)
  b1 = 0
  b0 = 0
  xDeviation = 0
  xy = 0
  #b1:dogrunun egimi
  for i in range(len(xList)):
    tempx = xList[i] - xbar 
    tempy = yList[i] - ybar
    xy = xy + tempx * tempy
    xDeviation = xDeviation + pow(tempx,2.0)
  #endfor
  b1    = xy / float(xDeviation)
  b0    = ybar - b1 * xbar    
  # bizim uretecegimiz y fonksiyonu 
  
  
  error = []
  for i in range(len(xList)):
    xi = xList[i]
    yi = yList[i]
    error.append(y(xi,b0,b1)-yi)       
  
  return (b0,b1,error) # y = b0 + b1 X 

def SSR(xList,yList):
  """sum of squares of regression
  Variability explained by the model"""
  
  b0 , b1 ,error = simpleRegression(xList,yList)
 
  
  ybar  = kzStatistics.mean(yList)
  ssr   = 0
  for x in xList:
    ssr  = ssr + pow((y(x,b0,b1)-ybar),2.0)
    
  return ssr

def SSE(xList,yList):
  """sum of squares of error
 Variability unexplained by the model """
  
  error = simpleRegression(xList,yList)[2] 
  sse = 0
  for e in error:
    sse = sse + pow(e,2.0)
  
  return sse


def SST(xList,yList):
  """sum of squares of total
 Total variation in response """
  
  return SSR(xList,yList) + SSE(xList,yList)

def MSE(xList,yList):
  """Mean square error"""
  
  n = len(yList)
  v = n -2 
  sse = SSE(xList,yList)
  
  return sse / float(v )

def MSR(xList,yList):
  """Mean square regression """
  
  v = 1
  ssr = SSR(xList,yList)
  
  return ssr / v

def sum_of_sq_deviation(List):
  "x - xbar in kareleri toplami"
  
  temp = 0
  xbar = kzStatistics.mean(List)
  for x in List:
    temp  = temp + pow((x-xbar),2.0),
    
  return temp

def varianceb1(xList , sigma2=None):
  """b1 in varyansi """
  
  if sigma2 == None :
    sigma2 = kzStatistics.variance(xList)
    
  xbar  = kzStatistics.mean(xList)
  
  varianceb1 = sigma2 / float(sum_of_sq_deviation(xList))
  
  return varianceb1


def varianceb1Hat(xList,yList):
  """ """
  mse = MSE(xList,yList)
  return  mse / sum_of_sq_deviation(xList)


def tTest(xList,yList,tail,alfa,beta1=0):
  ""
  var_b1_hat = varianceb1Hat(xList,yList)
  b1 = simpleRegression(xList,yList)[1]
  n  = len(xList)
  v  = n -2
  t  = (b1 - beta1)/pow(var_b1_hat,0.5)
  if tail == "!=": # ift ynl ise
    return abs(t) <= kzStatistics.tTable(alfa/2.0,v)
  
  elif tail == "<" :
    return t >= kzStatistics.tTable(alfa,v)
  
  elif tail == ">" :
    return t < kzStatistics.tTable(alfa,v)
  else :
    raise "regression.tTest:yn belirtmelisiniz"
  
  
  
def correlation(xList,yList):
  return pow( SSR(xList,yList)/SST(xList,yList) ,0.5)

# denklem listesi
# 2x 3y 8z = 1
# x  9y 3z = 4 
# 4x 5y 2z = 5

def unknownParameters(denklem):  
  return 1,2,3


def multipleLinearRegression(x1List,x2List,yList):
  "y = b0 + b1*X + b2*Z denklemini zer" 
  
  X11  = len(yList)
  X12 = kzStatistics.listSum(x1List)
  X13 = kzStatistics.listSum(x2List)
  Y1  = kzStatistics.listSum(yList)
  X21 = X11 
  X22 = 0
  X23 = 0
  Y2  = 0
  Y3  = 0
  X31 = kzStatistics.listSum(x2List)
  X32 = 0 
  X33 = 0
  
  for i in range(len(x1List)):
    X22 = X22 + pow(x1List[i],2.0)
    X23 = X23 + x1List[i] * x2List[i]
    Y2  = Y2  + x1List[i] * yList[i]
    Y3  = Y3  + x2List[i] * yList[i]
    X33 = X33 + pow(x2List[i],2.0)
  #endfor  
  X32 = X23 
  
  denklem = [[X11,X12,X13,Y1],[X21,X22,X23,Y2],[X31,X32,X33,Y3]]
  #..... denklemler girilecek
    
  b0 , b1 ,b2 = unknownParameters(denklem)
  return (b0,b1,b2)


def secondOrderFunction(xList,yList):
  n   = len(yList)
  Y1  = kzStatistics.listSum(yList)
  X11 = n
  X12 = kzStatistics.listSum(xList)
  X13 = 0
  Y2  = 0
  X21 = X12
  X22 = 0
  X23 = 0 
  Y3  = 0
  X31 = 0
  X32 = 0
  X33 = 0 
  
  for i in range(n):
    x1  = xList[i]
    y1  = yList[i]
    x2  = pow(x1,2.0)
    x3  = pow(x1,3.0)
    x4  = pow(x1,4.0)
    X13 = X13 + x2
    Y2  = x1 * y1
    X23 = X23 + x3
    X33 = X33 + x4
    Y3  = Y3 + x2 * y1
  #endfor  
  X22 = X13
  X31 = X22 
  X32 = X23
  
  denklem = [[X11,X12,X13,Y1],[X21,X22,X23,Y2],[X31,X32,X33,Y3]]
  b0 , b1 , b2 = unknownParameters(denklem)
  return (b0,b1,b2)
  
def rationalfunction1(xList,yList):
  "y = 1 /(b0+ b1*X)"
  for i in range(len(yList)):
    if yList[i] == 0:
      del yList[i]
      del xList[i]
    else:
      yList[i] = 1.0/yList[i]
  b0,b1,error = simpleRegression(xList,yList)
  return b0,b1

def rationalfunction2(xList,yList):
  "y = b /(a + X) "
  for i in range(len(yList)):
    if yList[i] == 0:
      del yList[i]
      del xList[i]
    else:
      yList[i] = 1.0/yList[i]
  #endfor
  b0,b1,error = simpleRegression(xList,yList)
  b = 1 / float(b1)
  a = b0/float(b1)
  return a,b

def exponentialfunction(xList,yList):
  "y=a*x^b"
  n = len(yList)
  F = 0 # F[i] =log(yi)
  G = 0 # G[i] =log(xi)  
  G2= 0 #G kare
  GF= 0 # G[i]*F[i]
  for i in range(n): 
    yi = math.log10(yList[i])
    xi = math.log10(xList[i])
    F  = F + yi
    G  = G + xi
    GF = GF+ xi*yi  
    G2 = G2+ pow(xi,2.0)
  #endfor
  A = [[n,G],[G,G2]]
  B = [[F],[GF]]
  result = kzMath.reduceAnEquation(A,B)
  #print result
  k = result[0][0]
  b = result[1][0]
  a = pow(10,float(k))
  return a,b

def exponentialfunction2(xList,yList):
  "y=a*b^x"
  n = len(xList)  
  F = 0
  FX= 0
  X2= 0	
  X = 0
  for i in range(n):
    xi = xList[i]
    yi = yList[i]
    fi = math.log10(yi)
    F  = F + fi #math.log10(yi)
    FX = FX + xi * fi
    X2 = X2 + pow(xi,2.0)
    X  = X + xi
  A = [[n,X],[X,X2]]
  B = [[F],[FX]]
  result = kzMath.reduceAnEquation(A,B)
  k = result[0][0]
  m = result[1][0]
  a = pow(10,float(k))
  b = pow(10,float(m))
  return a,b

def fTest(xList,yList):
  msr = MSR(xList,yList)
  mse = MSE(xList,yList)
  return msr/float(mse)

  
  
  
if __name__ == "__main__":
  xList = [1,2,3,4,5]
  yList = [105.6,111.8,118,124.9,131.7]
  print exponentialfunction2(xList,yList)
  
  
  
  
