# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
import kzStatistics
import kzRegression
import kzMath
import kzMatrix
import copy
x0=[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]
x1=[15.57,44.02,20.42,18.74,49.20,44.92,55.48,59.28,94.39,128.02,96.00,131.42,127.21,252.90,409.20,463.70,510.22]
x2=[2463,2048,3940,6505,5723,11520,5779,5969,8461,20106,13313,10771,15543,36194,34703,39204,86533]
x3=[472.92,1339.75,620.25,568.33,1497.60,1365.83,1687,1639.92,2872.33,3655.08,2912,3921,3865.67,7684.1,12446.33,14098.40,15524]
x4=[18,9.5,12.8,36.7,35.7,24,43.3,46.7,78.7,180.5,60.9,103.7,126.8,157.7,169.4,331.4,371.6]
x5=[4.45,6.92,4.28,3.9,5.5,4.6,5.62,5.15,6.18,6.15,5.88,4.88,5.5,7,10.78,7.05,6.35]
y =[566.52,696.82,1033.15,1603.62,1611.37,1613.27,1854.17,2160.55,2305.58,3503.93,3571.89,3741.4,4026.52,10343.81,11732.17,15414.94,18854.45]


#xList=[[x1Column],[x2column],....]
#yList=[y0,y1,y2,...,yi]
#i : y 'yi en ok etkileyen x lerin sayisi
def SSR(x,y):
  
  #x = xMatrix
  #y = yMatrix
  n = x.rowCount
  xt    = x.transpoze()
  xtx   = xt * x
  xtxi  = xtx.inverse()
  btemp = xtxi * xt
  b     = btemp * y
  bt    = b.transpoze()
  yt    = y.transpoze()
  j     = kzMatrix.matrix1(n,n)
  
  btxt  = bt * xt
  btxty = btxt * y
  ytj   = yt * j
  ytjy  = ytj * y
  
  ssr   = btxty - (ytjy*(1/float(n)) ) 
  return ssr.get(0,0)

def SSE(x,y):  
  #x = xMatrix
  #y = yMatrix
  yt = y.transpoze()
  xt = x.transpoze()  
  xtx= xt * x
  xtxi =xtx.inverse()
  btemp = xtxi * xt
  b  = btemp * y
  bt = b.transpoze()
  
  yty  = yt * y
  btxt = bt * xt
  btxty= btxt * y
  
  sse  = yty - btxty
  return sse.get(0,0)

def sequentialSSR(xMatrix,yMatrix):
  ''' xMatrix = [1,x1,x3] :  x1 varken x3'n modele katkisi
                [1,x1,x3,x5] x1 ve x3 varken x5 in modele katkisi '''
  
  c= xMatrix.colCount
  selectedMatrix = kzMatrix.matrix()
  for col in range(c-1):
    selectedMatrix.addColumn(xMatrix.getColumn(col))
  #endfor  
  
  
  
  if c == 3:    
    sse_selected = kzRegression.SSE(xMatrix.getColumn(1),yMatrix.getColumn(0)) 
  else:
    sse_selected = SSE(selectedMatrix,yMatrix)
  #fi  
  sse_option   = SSE(xMatrix,yMatrix)
  result  = sse_selected - sse_option  
  return result



def SSTO(xMatrix,yMatrix):
  n   = len(yMatrix)
  x   = xMatrix
  y   = yMatrix
  yt  = kzMath.transpoze(y)
  yty = kzMath.mull(yt,y)
  j   = kzMath.matrix1(n,n)
  ytj = kzMath.mull(yt,j)
  ytjy= kzMath.mull(ytj,y)
  ssto= kzMath.diff(yty,kzMath.scalermull(1/float(n),ytjy))
  return ssto
  
def MSR(xMatrix,yMatrix,p) : # x lerin sayisinin bir fazlasi
  return SSR(xMatrix,yMatrix)/float(p-1)

def MSE(xMatrix,yMatrix,p):
  #n = len(yMatrix)
  n = xMatrix.rowCount
  return SSE(xMatrix,yMatrix)/float(n-p)


def fTest(xMatrix,yMatrix):
  #p = len(xMatrix)
  p = xMatrix.colCount
  return MSR(xMatrix,yMatrix,p)/float(MSE(xMatrix,yMatrix,p))

def fStar(xMatrix,yMatrix):
  ssr = sequentialSSR(xMatrix,yMatrix)  
  sse = SSE(xMatrix,yMatrix)
  n   = xMatrix.rowCount
  c   = xMatrix.colCount -1
  result = (ssr * (n-c))/float(sse)
  return result
  
def selection(xMatrix,yMatrix,function='max'):
  F = []
  n = yMatrix.rowCount
  y = yMatrix.getColumn(0)
  for i in range(1,xMatrix.colCount):
    #xi =kzMatrix.matrix()
    xi  = xMatrix.getColumn(i)
    #xi.addColumn(xMatrix.getColumn(i))
    
    f=kzRegression.fTest(xi,y)
    print f
    F.append(f)
  if function == 'max':
    Fselected = max(F)
  else:
    Fselected = min(F)
  #fi  
  index = F.index(Fselected)+1  
  return {'index':index,'value':Fselected}

def multiSelection(xMatrix,yMatrix,selected=[]):
  testMatrix = kzMatrix.matrix()
  other      = range(xMatrix.colCount)
  for col in selected:
    testMatrix.addColumn(xMatrix.getColumn(col))
    other.remove(col) #seili olanlar listeden ikariliyor
  #endfor
  values  = []
  
  for selectCol in other:
    selectMatrix = copy.deepcopy(testMatrix)
    selectMatrix.addColumn(xMatrix.getColumn(selectCol))
    values.append(fStar(selectMatrix,yMatrix))
  #endfor
  Fmax  = max(values)
  index = other[values.index(Fmax)]
  return {'index':index,'value':Fmax}
  
def forwardSelection(xMatrix,yMatrix):
  
  f = selection(xMatrix,yMatrix,'max')  
  
  selected = [0]
  while(f['value'] >= 4):
    selected.append(f['index'])
    f = multiSelection(xMatrix,yMatrix,selected)
  #endWhile
  selected.remove(0)
  return selected
  result=[]
  for c in range(xMatrix.colCount ):
    if c != index:
      x = []
      for r in range(xMatrix.rowCount):
        line = [xMatrix.get(r,c),xMatrix.get(r,index)]
        if c > index:                  
          line.reverse()
          
        x.append(line)
      #endfor              
      result.append(f)
      
      
def elimination(xMatrix,yMatrix):
  values = []
  for select in range(1,xMatrix.colCount):
    testMatrix = copy.deepcopy(xMatrix)
    selectColumn = testMatrix.getColumn(select)
    testMatrix.delColumn(select)
    testMatrix.addColumn(selectColumn)
    values.append(fStar(testMatrix,yMatrix))
    
  t = 1   #buraya kadar dogru
  
def backwardSelection(xMatrix,yMatrix):
  '''en az katkisi olan x'ler modelden atilir'''
  f = selection(xMatrix,yMatrix,'min')
  option = f['index']
  selected = range(1,xMatrix.colCount)  
  selected.remove(option)
  testMatrix = copy.deepcopy(xMatrix)
  optionValues = testMatrix.getColumn(option)
  testMatrix.delColumn(option)
  testMatrix.addColumn(optionValues)
  
  if fStar(testMatrix,yMatrix) < 4.0:
    xMatrix.delColumn(option)
  #fi  
  elimination(xMatrix,yMatrix)
   
                  
 

def stepWiseSelection(xList,yList):  
  pass




if __name__ == "__main__":
  xMatrix = kzMatrix.matrix()
  
  xList = [x0,x1,x2,x3,x4,x5]

  for column in xList:
    xMatrix.addColumn(column)    
  #endfor
  yMatrix = kzMatrix.matrix()
  yMatrix.addColumn(y)
#  print forwardSelection(xMatrix,yMatrix)

  print backwardSelection(xMatrix,yMatrix) #,1,[0,3])

#  w1= SSE(x01,y0),SSR(x01,y0),fTest(x01,y0)
#  w2= SSE(x02,y0),SSR(x02,y0),fTest(x02,y0)
#  w3= SSE(x04,y0),SSR(x04,y0),fTest(x04,y0)
#  w4= SSE(x05,y0),SSR(x05,y0),fTest(x05,y0)
#  print w1,w2,w3,w4
  


  i = raw_input()
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
