# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
########################################################################
#  Proje Ad          :Kuzgun E-IS Platformu
#  Modl Ad          :Attachment
#  Hedefleri          :
#                     
#                      
#                      
#  Gelistiren         :idris aykun
#  Copyright          :ANKA Bilgi Teknolojileri 2002
#  Kullanm Haklar    :Her Hakk Sakldr
#  Gerekenler         :
#                                         
#  Dosyalar           :kzAttachment.py
#                      __init__.py
#                      ./dtml/kzAttachmentAddForm.dtml
#                      kzAttachment.gif
#                     :readme.txt
#-----------------------------------------------------------------------
#  TARIH              : Versiyon        Gelistiren         Degisiklikler

########################################################################

from Globals import DTMLFile
from AccessControl.Role import RoleManager
from OFS.SimpleItem import Item
from OFS.PropertyManager import PropertyManager
from OFS.FindSupport import FindSupport
from Products.Kuzgun.kzSort import kzSort   
from Products.ZSQLMethods.SQL import SQL
import copy, string, time
from AccessControl import ClassSecurityInfo

from OFS.ObjectManager   import ObjectManager
from OFS.SimpleItem      import SimpleItem

from kzPostgresql import *
from kzMysql import *




class kzAuthSQL(PropertyManager, SimpleItem, ObjectManager):
  "kzAuthSQL Object"
  
  meta_type="Kuzgun IASSP"

  _properties = ({'id' : 'title', 'type' : 'string', 'mode' : 'w'},
                 {'id' : 'qdataID', 'type' : 'string', 'mode' : 'r'},
                 {'id' : 'qauthID', 'type' : 'string', 'mode' : 'r'},
                 {'id' : 'qtaskID', 'type' : 'string', 'mode' : 'r'})

  manage_options = (
      PropertyManager.manage_options
      +RoleManager.manage_options
      +Item.manage_options
      +FindSupport.manage_options
      )
  
  security = ClassSecurityInfo()

  def __init__(self, id, title):
    "create instance"

    self.id         = id
    self.title      = title  
    self.qdata      = None    # User DB
    self.qpref      = None    # Pref DB
    self.qauth      = None    # Data DB
    self.qtask      = None    # Task DB
    self.qattach    = None    # File DB
    self.qarchieve  = None    # Archieve DB
    self.qdataID    = ""
    self.qprefID    = ""
    self.qauthID    = ""
    self.qtaskID    = ""
    self.qattachID  = ""
    self.qarchieveID= ""
    self.authLevel  = "level"
    self.groupId    = "nodeid"
    self.authId     = "userid"
    self.authTable  = "auth"   
    self.modeId     = "mode"
    
    self.DBType     = None 
    self.connType   = None
    
    
  security.declarePublic("getsqlobject")  
  def getsqlobject(self):
    try:
      return eval("%s(self.aq_inner)" % (self.DBType))
    except: 
      raise "kzDBInterface : DB %s is not supported" % (self.DBType)
    
  def setDBType(self):
    if self.DBType is None:
      try:
        self.qdata(query="show databases")
        self.DBType = "kzMysql"
      except:
        try:
          self.qdata(query="select * from pg_user")
          self.DBType = "kzPostgresql"
        except:
          self.DBType = None
    
    
  def sqlselectrecords(self,tablename,fields=['*'],cond=(),orderby='',groupby='',offset=None,limit=None,auth=1):
    sqlobj = self.getsqlobject()
    sqlobj.selectrecords(tablename,fields,cond,orderby,groupby,offset,limit,auth)
    return self.results_qdata(sqlobj)
  
  def sqlinsertrecords(self,tablename,dic={}):
    if len(dic):
      sqlobj = self.getsqlobject()
      sqlobj.insertrecords(tablename,dic)
      return self.results_qdata(sqlobj)
      
  def sqlupdaterecords(self,tablename,dic={},cond=(),auth=1): 
    sqlobj = self.getsqlobject()
    sqlobj.updaterecords(tablename,dic,cond,auth)
    return self.results_qdata(sqlobj)
  
  def sqldeleterecords(self,tablename,cond,auth=1):
    sqlobj = self.getsqlobject()
    sqlobj.deleterecords(tablename,cond,auth)
    return self.results_qdata(sqlobj)
  
  def results(self,query_name,sqlobj):
    sql_l = sqlobj.get_l()
    rec = []
    for sql in sql_l:
      rec = getattr(self,query_name)(query = sql)
    
    if rec == []:
      return []
    elif "dictionaries" in dir(rec):
      return rec.dictionaries() 
    else:
      items = rec.__items__
      data  = []
      for r in rec:
        temp = []
        for i in range(len(r)):
          temp.append(r[i])          
        data.append(tuple(temp))
      from Shared.DC.ZRDB.Results import Results  
      rec = Results((items,data))
      return rec.dictionaries()  
      
      
  security.declarePublic("results_qdata")  
  def results_qdata(self,sqlobj):
    # Yapilan sorgular islenir
    self.qdata.max_rows_=0
    return self.results("qdata",sqlobj)
  
  security.declarePublic("results_qauth")  
  def results_qauth(self,sqlobj):
    # Yapilan sorgular islenir
    return self.results("qauth",sqlobj)
  
  security.declarePublic("results_qpref")  
  def results_qpref(self,sqlobj):
    # Yapilan sorgular islenir
    return self.results("qpref",sqlobj)
  
  security.declarePublic("results_qtask")  
  def results_qtask(self,sqlobj):
    # Yapilan sorgular islenir
    return self.results("qtask",sqlobj)
  
  security.declarePublic("results_qattach")  
  def results_qattach(self,sqlobj):
    # Yapilan sorgular islenir
    return self.results("qattach",sqlobj)
  
  security.declarePublic("results_qarchieve")  
  def results_qarchives(self,sqlobj):
    # Yapilan sorgular islenir
    return self.results("qarchives",sqlobj)

  security.declarePublic("checkauth")  
  def checkauth(self,cond,where):
    # Yetkiye bakilir
    user   = str(self.aq_inner.aq_parent.portal_membership.getAuthenticatedMember())
    auth   = self.getAuth(user,where)
    # Musteri yetkisi
    if auth == 0:
      if len(cond):
        return (cond,'and',('owner_name',user))
      else:
        return ('owner_name',user)
    else:  
      if len(cond):
        return (cond,'and',('authority','<=',int(auth)))
      else:
        return ('authority','<=',int(auth) )
    
    
  security.declarePublic("getAuth")    
  # Evrim wrote
  def getAuth(self, who, where,mode=0):
    self.modeId="mode"
    user = self.aq_inner.aq_parent.portal_membership.getAuthenticatedMember()
    if str(user) == who:
      if 'Manager' in user.getRolesInContext(self.aq_inner.aq_parent):
        if mode: return 5,"Read/Write"
        else: return 5
      
    elif who == "admin":
      if mode: return 5,"Read/Write"
      else: return 5
    
    acl  = self.aq_inner.aq_parent.acl_users
    user = acl.getUser(who)
    user_hierarchy = user.getGroups()    
      
    where  = str(where)
    cond   = ()
    i      = len(user_hierarchy)
    
    hierarchy = []
    for item in user_hierarchy:
      hierarchy.append(item)
    hierarchy.append(who)  
    
    cond_list = []

    while i >= 0:
      tempwhere = where
      while len(tempwhere):
        tempcond = ((self.authId,hierarchy[i]),'and',(self.groupId,tempwhere))
        cond_list.append( (hierarchy[i],tempwhere) )
        if len(cond):
          cond = (cond,"or",tempcond)
        else:
          cond = tempcond
        # Bir st veri grubuna ge�
        if tempwhere.find("_") > -1:
          tempwhere = tempwhere[:tempwhere.rfind("_")]
        else:
          tempwhere = ""  
      # Bir st kullanici grubuna ge� 
      i = i -1
      
    # Sorgu hazirlaniyor
    orderby="%s,%s" % (self.groupId,self.authId)
    self.modeId = "mode" # SILINECEK
    sqlobj = self.getsqlobject()
    sqlobj.selectrecords(self.authTable,[self.authId,self.groupId,self.authLevel,self.modeId],cond,orderby=orderby,auth=0)
    rec = self.results_qauth(sqlobj)
    
    if len(rec):
      for cond in cond_list:
        for r in rec:
          if r[self.authId] == cond[0] and r[self.groupId] == cond[1]:
            if mode: return r[self.authLevel],r[self.modeId]
            else: return r[self.authLevel]
            
    if mode:        
      return -1,"R"
    else:
      return -1
    

  security.declarePublic("getAuthList")  
  def getAuthList(self, where=[]):

    authList  = []
    newList   = []

    who = str(self.aq_inner.aq_parent.portal_membership.getAuthenticatedMember())
    
    if type(where) is "":
      where = [where]

    for x in where:
      auth = self.getAuth(who, x)
      authList.append(auth)
    
    lenAuth = len(authList) - 1
    control = 0
    
    for i in range(lenAuth):
      if authList[i] >= control:
        newList.append(where[i])
      
    return newList
  
  
#########################################################################
#########################################################################
  
  
addProductForm = DTMLFile('./dtml/kzAuthSQLAddForm', globals())


def manage_addProduct(self, id, title, qdata, qauth, qpref, qtask, qattach, qarchives, RESPONSE=None):
  
  "Add a Minimal to a folder."  
  if (id=="") or (qdata=="") or (qauth=="") or (qtask==""):
    RESPONSE.redirect(addProductForm)
  else:
    temp  = kzAuthSQL(id, title)
    
    # Authorization Database
    methodID = "qauth"
    setattr(temp,methodID,SQL(methodID,"",qauth,"query","<dtml-var query>"))
    temp.qauthID = qauth
    temp.qauth.max_rows_=10000000
    
    # Data Database
    methodID = "qdata"
    setattr(temp,methodID,SQL(methodID,"",qdata,"query","<dtml-var query>"))
    temp.qdataID = qdata
    temp.qdata.max_rows_=10000000
    
    # Data Database
    methodID = "qpref"
    setattr(temp,methodID,SQL(methodID,"",qpref,"query","<dtml-var query>"))
    temp.qprefID = qpref
    temp.qpref.max_rows_=10000000
    
    # Task Database
    methodID = "qtask"
    setattr(temp,methodID,SQL(methodID,"",qtask,"query","<dtml-var query>"))
    temp.qtaskID = qtask
    temp.qtask.max_rows_=10000000
    
    # Task Database
    methodID = "qattach"
    setattr(temp,methodID,SQL(methodID,"",qattach,"query","<dtml-var query>"))
    temp.qattachID = qattach
    temp.qattach.max_rows_=10000000
    
    # Archive Database
    methodID = "qarchives"
    setattr(temp,methodID,SQL(methodID,"",qarchives,"query","<dtml-var query>"))
    temp.qarchivesID = qarchives
    temp.qarchives.max_rows_=10000000
    
    self._setObject(id, temp)
    temp = getattr(self,id)
    
    database = getattr(self,qdata,None)
    if database is not None:
      dbtype = getattr(database,"database_type",None)
      if dbtype in [None,"ODBC","mxODBC"]:
        temp.setDBType()
        temp.connType = "ODBC"
      else:
        if dbtype in ['MySQL']:
          temp.DBType = "kzMysql"
        elif dbtype in ['Postgresql','psycopg','Psycopg']:
          temp.DBType = "kzPostgresql"
        else:
          temp.DBType = None
        temp.connType = "Adaptor"
    
   
    if RESPONSE!=None:
       RESPONSE.redirect('manage_workspace')
