# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
# POSTGRESQL 7.3

from OFS.SimpleItem      import SimpleItem
import string
from kzSql import kzSql,dict_str,cond_str

try:
  from MySQLdb import Binary
except:
  pass

class kzMysql(SimpleItem,kzSql):
  # Interface for MySQL 4.015 Databases
  
  def fieldstr(self,field={}):
    # Alan zelliklerinden ekleme katari olusturur
    # fields: { name , type(integer-varchar-auto) , primary , foreign }
    try:
      name = field["name"]
      # TYPE
      if field["type"] == "auto":
        type = "INT AUTO_INCREMENT PRIMARY KEY"
      else:
        type = field["type"]
      # PRIMARY KEY  
      if field.has_key("primary"):
        primary = "PRIMARY KEY"
      else:
        primary = ""
      # FOREIGN KEY : referans olarak belirtilen tablonun primary key'i
      if field.has_key("foreign"):
        if len(field["foreign"]["tablename"]):
          foreign = "REFERENCES %s(%s) ON UPDATE CASCADE ON DELETE CASCADE" % (field["foreign"]["tablename"],field["foreign"]["fieldname"])
        else:
          foreign = ""
      else:
        foreign = ""
      # EXTRA
      if field.has_key("extra"):
        extra = field["extra"]
      else:
        extra = ""
      # SQL String
      
      s = "%s %s %s %s %s" % (name,type,primary,foreign,extra)
      return s

    except:
      raise "kzMySql : field attr error %s" % (field)
    
  def getblobtype(self):
    return "blob"
    
  def setBinary(self,temp):
    #return Binary(temp)
    from psycopg import Binary
    return ( Binary(temp) ,)
    #return (temp,)
  
  
  def create_table(self,tablename,fields=[]):
    kzSql.create_table(self,tablename,fields)
    sql = self.sql[len(self.sql)-1] 
    self.sql[len(self.sql)-1] = "%s TYPE=INNODB " % sql
    
  def begin_transaction(self):
    # Transaction baslat
    sql = "START TRANSACTION"
    self.add(sql)

    
  def end_transaction(self):
    # Transaction'u bitir
    sql = "COMMIT"
    self.add(sql)
    
    
  def isTableExists(self,tablename,qdb="qdata"):
    # Tablo varm
    sql = "show tables"
    rec = getattr(self.parent,qdb)(query = sql) 
    if len(rec):
      rec = rec.dictionaries()
      key = rec[0].keys()[0]
      for r in rec:
        if r[key] == tablename:
          return 1
    return 0
  
  
  def add_constraint(self,tablename,fieldname,constraint,other={}):
    if constraint == "primary":
      sql = "alter table %s alter column %s SET NOT NULL" % (tablename,fieldname)
      self.add(sql)
      sql = "alter table %s add PRIMARY KEY (%s)" % (tablename,fieldname)
      self.add(sql)      
    elif constraint == "foreign":
      foreigntable = other.get('tablename','')
      foreignfield = other.get('fieldname','')
      sql = "alter table %s add FOREIGN KEY (%s) REFERENCES %s(%s) ON UPDATE CASCADE ON DELETE CASCADE" % (tablename,fieldname,foreigntable,foreignfield)
      self.add(sql)  

    
  def getnextrecno(self,tablename,autofield="recno"):
    raise "method not implemented yet"

    
  def getcurrecno(self,tablename,autofield):
    raise "method not implemented yet"

    
