# -*- coding: utf-8 -*- 
import copy
from kzObjects import *
from kzTables import *


group_attr = ["title","alias","order","isleaf","activate","description",
              "defaultconds","defaultconsts","defaultgroup"]


class kzGroup:
  
  def __init__(self,qref,qdata,tagid,attr):
    "Grup nesnesi olusturur"
    
    self.tagname    = "group"
    self.tagid      = tagid
    self.qref       = qref
    self.qdata      = qdata
    self.attr       = self.control_attr(attr)
    self.menu_count = 1
    
    
  def create_db(self,parentID):
    # Veritabani yaratilirken yapilacak islem
    return 1
    
  def insert(self,parentID):
    # Yeni bir grup ekler
    self.tagid = self.insert_ref(parentID)
    self.insert_data(parentID)
    return self.tagid
    
  def insert_ref(self,parentID):
    # Yeni bir grup ekler
    # Referansa grubu ekle
    self.tagid = self.qref.insertNode(parentID,"group",self.attr)
    return self.tagid
  
  def insert_data(self,parentID):
    # Veritabani islemi yapar
    pass
  
  def update(self,attr):
    # Grubun ozeliklerini degistirir
    attr = control_attr(attr)
    defaultconds = attr.get("defaultconds","")
    attr["defaultconds"] = str(defaultconds).replace('"',"'")
    defaultconsts = attr.get("defaultconsts","")
    attr["defaultconsts"] = str(defaultconsts).replace('"',"'")
    # Grupta tip degistirmeye izin verme
    if attr.has_key("isleaf"):
      del attr["isleaf"]
    # Referansi guncelle
    self.qref.updateNode(self.tagid,attr)
    for key in attr.keys():
      self.attr[key] = attr[key]
  
  def delete(self):
    # Grubu sil
    self.delete_ref()
    
  def delete_ref(self):
    # Referanstan siler
    self.qref.delete(self.tagid)    
    
  def delete_data(self):
    pass  
  
  def control_attr(self,attr):
    # Grup ozelliklerini kontrol eder
    attr = copy.deepcopy(attr)
    keys = attr.keys()
    dic  = {}
    for item in cmp_list(keys,group_attr): 
      dic[item] = ""
      attr[item]= ""
    if len(dic): 
      self.qref.updateNode(self.tagid,dic)  
    attr["tagname"] = self.tagname
    attr["deleted"] = "0"
    defaultconds = attr.get("defaultconds","")
    attr["defaultconds"] = str(defaultconds).replace('"',"'")
    defaultconsts = attr.get("defaultconsts","")
    attr["defaultconsts"] = str(defaultconsts).replace('"',"'")
    return control_attr(attr)
  
  
  def copy(self,parentID):
    # Grubu baska bir grubun altina kopyala
    new_tagid = self.qref.copy(self.tagid,parentID)
    table_list= []
    table_list= self.find_tables(self.tagid,table_list)
    # Once Ozet tablosunu kopyala
    for table in table_list:
      if table["type"] == "m":
        temp = kzTable_m(self.qref,self.qdata,table["tagid"],table)
        tableid = temp.tagid
        new_tableid = new_tagid + tableid[len(self.tagid):]
        temp.copy_data(new_tableid,0)
    # Ozet tablosu haric diger tablolari kopyala    
    for table in table_list:
      control = 1
      if table["type"] == "1":
        temp = kzTable_1(self.qref,self.qdata,table["tagid"],table)  
      elif table["type"] == "n":
        temp = kzTable_n(self.qref,self.qdata,table["tagid"],table) 
      elif table["type"] == "d":
        temp = kzTable_nn(self.qref,self.qdata,table["tagid"],table)  
      else:
        control = 0
      if control:  
        tableid = temp.tagid
        new_tableid = new_tagid + tableid[len(self.tagid):]
        temp.copy_data(new_tableid,0)
    # Alt tablolari kopyala
    for table in table_list:
      if table["type"] == "s":
        temp = kzTable_s(self.qref,self.qdata,table["tagid"],table)
        tableid = temp.tagid
        new_tableid = new_tagid + tableid[len(self.tagid):]
        temp.copy_data(new_tableid,0)
      
    return new_tagid
  
  
  def find_tables(self,nodeid,list):
    # Grubun altindaki tablolar
    node = self.qref.getAttributes(nodeid)
    if node["tagname"] != "group":
      return list
    
    elif node["isleaf"] == "F":
      for child in self.qref.getChilds(nodeid,'group'):
        list = self.find_tables(child["tagid"],list)

    else:
      templist = []
      for child in self.qref.getChilds(nodeid,"table"):
        if child["type"] == "m": templist.insert(0,child)
        else: templist.append( child )
        for child2 in self.qref.getChilds(child["tagid"],"table"):
          templist.append( child2 )
         
        
      list += templist
      
    return list    
  
