# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
## kzObjects


#####################################################################################
############################# GENERAL FUNCTIONS #####################################
#####################################################################################

def control_attr(dic):
  # Nesnelere eklenecek zellikleri kontrol eder
  if dic.has_key("tagid"):
    del dic["tagid"]
  if dic.has_key("selected"):
    del dic["selected"]
  return dic  


def cmp_list(list1,list2):
  # list1 list2'yi ieriyor mu
  diff = []
  for item in list2:
    if not item in list1:
      diff.append(item) 
  return diff

def get_parent(tagid):
  # tagid'nin stndeki nesne id'sini dndrr
  index = tagid.rfind("_")
  return tagid[:index]

def add_dictionary(dict1,dict2):
  # Iki dictionary'i toplar
  temp = {}
  for key in dict1.keys():
    temp[key] = dict1[key]
  for key in dict2.keys():
    temp[key] = dict2[key]
  return temp  


#####################################################################################
############################# GENERAL FUNCTIONS #####################################
#####################################################################################



def print_entries(xml,attributes=[],getText=None):
  # Istenilen attribute'ler ekrana yazlir
  # attr = (input_type,visibility,name)

  parent = xml.parent
  
  for attr in attributes:
    
    if attr["type"] == "hidden":
      xml.append ("input", add_dictionary(
                            {"type":"hidden", "name": attr["name"],
                             "value": attr["value"]},attr["attr"]
                            ) 
                  )
    
    elif attr["type"] == "text":
      xml.setParent(parent)
      tr = xml.append ("tr")
      xml.setParent(tr)
      td = xml.append ("td",text=getText(attr["title"]) )
      td = xml.append ("td",text=attr["value"])  

    elif attr["type"] == "input":
      xml.setParent(parent)
      tr = xml.append ("tr")
      xml.setParent(tr)
      td = xml.append ("td",text=getText(attr["title"]) )
      td = xml.append ("td")
      xml.setParent(td)
      xml.append ("input", add_dictionary(
                           {"type":"text", "name": attr["name"],
                            "size":attr["length"]  ,
                            "value": attr["value"]
                            },attr["attr"]
                            )
                  )
      
    elif attr["type"] == "checkbox":  
      xml.setParent(parent)
      tr = xml.append ("tr")
      xml.setParent(tr)
      td = xml.append ("td",{"colspan":"2"})
      xml.setParent(td)
      if attr["value"] == "1":
        xml.append("input",add_dictionary(
                            {"type":"checkbox","name":attr["name"],
                            "checked":""},attr["attr"])
                   )
      else:
        xml.append("input",add_dictionary(
                            {"type":"checkbox","name":attr["name"]},attr["attr"])
                   )
      xml.append("span",text=getText(attr["title"]) )
      
      
    elif attr["type"] == "select":  
      xml.setParent(parent)
      tr = xml.append ("tr")
      xml.setParent(tr)  
      td = xml.append ("td",text=getText(attr["title"]) )
      td = xml.append ("td")
      xml.setParent(td)
      select = xml.append("select",add_dictionary(
                            {"name":attr["name"]},attr["attr"]) )
      xml.setParent(select)
      selected = attr["value"]
      if not type(selected) in [type([]),type(())]:
        selected = [selected]
      for value in attr["values"]:
        if value[0] in selected:
          xml.append("option",{"value":value[0],"selected":""},text=getText(value[1]))
        else:  
          xml.append("option",{"value":value[0]},text=getText(value[1]))
            
  


#####################################################################################
########################## SQL  DATABASE FUNCTIONS ##################################
#####################################################################################

class sql:
  
  def __init__(self,qdata):
    # Sql ve veritaban ilerini yapmay salar
    self.qdata      = qdata
    
  def create_table(self,tableid,fields):
    field_string = ""
    for field in fields:
      field_string = field_string + "%s %s," % (field[0],field[1])
    query = "create table %s (%s)" % (tableid,field_string[:-1])
    self.qdata.results(query=query)
    
  def drop_table(self,tableid):
    try:
      self.qdata.results(query = "drop table %s" % tableid)
      return 1
    except:
      return 0      
    
  def rename_table(self,oldtagid,newtagid):
    try:
      query = "alter table %s rename to %s" % (oldtagid,newtagid)
      self.qdata.results(query = query)
      return 1
    except:
      return 0
  
    
  def add_field(self,tableID,fieldID):
    " Belirtilen tabloya alan ekler"
    query = "alter table %s add %s varchar(250)" % (tableID,fieldID)
    try:
      self.qdata.results(query = query)
      self.qdata.update(tableID,{fieldID:""},{})
      return 1
    except:  
      return 0
    
    
  def rename_field(self,old_fieldid,new_fieldid,tableid=""):
    if old_fieldid == new_fieldid:
      return 1
    if tableid == "":
      index   = new_fieldid.rfind("_")
      tableid = new_fieldid[:index]
    query = "alter table %s rename %s to %s" % (tableid,old_fieldid,new_fieldid)
    self.qdata.results(query = query)
    

