# -*- coding: utf-8 -*-
from config import *
from AccessControl import ClassSecurityInfo
from Translateable import Translateable
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate
from Products.PythonScripts.PythonScript import PythonScript
import string
import sys,traceback
from AccessControl import User

superuser = User.system

BUTTON_TYPES = DisplayList((
    ('button', 'Form Button'),
    ('submit', 'Submit Button'),
    ))



schema = BaseSchema  + Schema((
  
    StringField('name',
		default_method='getId',
		schemata='default',
		widget=StringWidget(label_msgid="label_name",
				    description_msgid="help_name",
				    label='Name',
				    i18n_domain=i18n_domain),
		),
    
    StringField('value',
		schemata='default',
		widget=StringWidget(label_msgid="label_value",
				    description_msgid="help_value",
				    label='Value',
				    i18n_domain=i18n_domain),
		),
  
    StringField('tableid',
		schemata='default',
		widget=StringWidget(label_msgid="label_tableid",
				    description_msgid="help_tableid",
				    label='Table Id',
				    i18n_domain=i18n_domain),
		),
    
    StringField('type',
		required=1,
		default='button',
		schemata='default',
		vocabulary=BUTTON_TYPES,
		widget=SelectionWidget(label_msgid="label_type",
				       description_msgid="help_type",
				       label='Type',
				       i18n_domain=i18n_domain),
		),
    
    StringField('image',
		schemata='default',
		widget=StringWidget(label_msgid="label_image",
				    description_msgid="help_image",
				    label='Background Image',
				    i18n_domain=i18n_domain),
		),
    
    StringField('style',
		schemata='default',
		default='string:background-image:url(${image})${semicolon}width:${width}px${semicolon}${style}height:${height}px${semicolon}',
		widget=StringWidget(label_msgid="label_style",
				    description_msgid="help_style",
				    label='Style (css)',
				    i18n_domain=i18n_domain),
		),
    
    LinesField('conditionScriptParams',
	       schemata='PythonScript Attributes',
	       default=('tableobj',),
	       widget=LinesWidget(label_msgid="label_conditionscriptparams",
				   description_msgid="help_conditionscriptparams",
				   label='Condition Script Parameters',
				   i18n_domain=i18n_domain),
	       ),
    
    ReferenceField('conditionScript',
		   schemata='PythonScript Attributes',
		   relationship='KnowsAbout',
		   allowed_types=('kzPythonScript',),
		   widget=ReferenceWidget(label_msgid="label_conditionscript",
					  description_msgid="help_conditionscript",
					  label='Condition Script',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   ),
    
    
    LinesField('systemParams',
	       schemata='PythonScript Attributes',
	       widget=LinesWidget(label_msgid="label_sysparams",
				  description_msgid="help_sysparams",
				  label='System Parameters',
				  i18n_domain=i18n_domain),
	       ),
    
    LinesField('validationScriptParams',
	       schemata='PythonScript Attributes',
	       default=('tableobj',),
	       widget=LinesWidget(label_msgid="label_validationscriptparams",
				  description_msgid="help_validationscriptparams",
				  label='Validation Script Parameters',
				  i18n_domain=i18n_domain),
	       ),
    
    ReferenceField('validationScript',
		   schemata='PythonScript Attributes',
		   relationship='KnowsAbout0',
		   allowed_types=('kzPythonScript',),
		   widget=ReferenceWidget(label_msgid="label_validationscript",
					  description_msgid="help_sysparams",
					  label='Validation Script',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   ),
    
    LinesField('actionScriptParams',
	       schemata='PythonScript Attributes',
	       default=('tableobj',),
	       widget=LinesWidget(label_msgid="label_actionscriptparams",
				    description_msgid="help_actionscriptparams",
				    label='Action Script Parameters',
				    i18n_domain=i18n_domain),
		),
    
    ReferenceField('actionScript',
		   schemata='PythonScript Attributes',
		   relationship='KnowsAbout1',
		   allowed_types=('kzPythonScript',),
		   widget=ReferenceWidget(label_msgid="label_actionscript",
					  description_msgid="help_sysparams",
					  label='Action Script',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   ),
    
    StringField('javaScript_onclickParams',
	       schemata='JavaScript Attributes',
	       default="kzSubmitForm(this,'')",
	       widget=StringWidget(label_msgid="label_javascriptonclickparams",
				    description_msgid="help_actionscriptparams",
				    label='JavaScript - Onclick Parameters',
				    i18n_domain=i18n_domain),
		),
    
    ReferenceField('javaScript_onclick',
		   schemata='JavaScript Attributes',
		   relationship='KnowsAbout2',
		   allowed_types=('kzJavaScript',),
		   widget=ReferenceWidget(label_msgid="label_javascriptonclick",
					  description_msgid="help_javascriptonclick",
					  label='JavaScript - Onclick',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   ),
    
    StringField('javaScript_onchangeParams',
	       schemata='JavaScript Attributes',
	       widget=StringWidget(label_msgid="label_javascriptonchangeparams",
				    description_msgid="help_javascriptonchangeparams",
				    label='JavaScript - Onchange Parameters',
				    i18n_domain=i18n_domain),
		),
    
    ReferenceField('javaScript_onchange',
		   schemata='JavaScript Attributes',
		   relationship='KnowsAbout3',
		   allowed_types=('kzJavaScript',),
		   widget=ReferenceWidget(label_msgid="label_javascriptonchange",
					  description_msgid="help_javascriptonchange",
					  label='JavaScript - Onchange',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   ),
    
    StringField('javaScript_onfocusParams',
	       schemata='JavaScript Attributes',
	       widget=StringWidget(label_msgid="label_javascriptonfocusparams",
				    description_msgid="help_javascriptonfocusparams",
				    label='JavaScript - Onfocus Parameters',
				    i18n_domain=i18n_domain),
		),
    
    ReferenceField('javaScript_onfocus',
		   schemata='JavaScript Attributes',
		   relationship='KnowsAbout4',
		   allowed_types=('kzJavaScript',),
		   widget=ReferenceWidget(label_msgid="label_javascriptonfocus",
					  description_msgid="help_javascriptonfocus",
					  label='JavaScript - Onfocus',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   ),
    
    StringField('javaScript_onblurParams',
	       schemata='JavaScript Attributes',
	       widget=StringWidget(label_msgid="label_javascriptonblurparams",
				    description_msgid="help_javascriptonblurparams",
				    label='JavaScript - Onblur Parameters',
				    i18n_domain=i18n_domain),
		),
    
    ReferenceField('javaScript_onblur',
		   schemata='JavaScript Attributes',
		   relationship='KnowsAbout5',
		   allowed_types=('kzJavaScript',),
		   widget=ReferenceWidget(label_msgid="label_javascriptonblur",
					  description_msgid="help_javascriptonblur",
					  label='JavaScript - Onblur',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   ),
    
    StringField('javaScript_onmouseoverParams',
	       schemata='JavaScript Attributes',
	       widget=StringWidget(label_msgid="label_javascriptonmouseoverparams",
				    description_msgid="help_javascriptonmouseoverparams",
				    label='JavaScript - Onmouseover Parameters',
				    i18n_domain=i18n_domain),
		),
    
    ReferenceField('javaScript_onmouseover',
		   schemata='JavaScript Attributes',
		   relationship='KnowsAbout6',
		   allowed_types=('kzJavaScript',),
		   widget=ReferenceWidget(label_msgid="label_javascriptonmouseover",
					  description_msgid="help_javascriptonmouseover",
					  label='JavaScript - Onmouseover',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   ),
    
    StringField('javaScript_onmouseoutParams',
	       schemata='JavaScript Attributes',
	       widget=StringWidget(label_msgid="label_javascriptonmouseoutparams",
				    description_msgid="help_javascriptonmouseoutparams",
				    label='JavaScript - Onmouseout Parameters',
				    i18n_domain=i18n_domain),
		),
    
    ReferenceField('javaScript_onmouseout',
		   schemata='JavaScript Attributes',
		   relationship='KnowsAbout7',
		   allowed_types=('kzJavaScript',),
		   widget=ReferenceWidget(label_msgid="label_javascriptonmouseout",
					  description_msgid="help_javascriptonmouseout",
					  label='JavaScript - Onmouseout',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   ),
    
    StringField('javaScript_onkeypressParams',
	       schemata='JavaScript Attributes',
	       widget=StringWidget(label_msgid="label_javascriptonkeypressparams",
				    description_msgid="help_javascriptonkeypressparams",
				    label='JavaScript - Onkeypress Parameters',
				    i18n_domain=i18n_domain),
		),
    
    ReferenceField('javaScript_onkeypress',
		   schemata='JavaScript Attributes',
		   relationship='KnowsAbout8',
		   allowed_types=('kzJavaScript',),
		   widget=ReferenceWidget(label_msgid="label_javascriptonkeypress",
					  description_msgid="help_javascriptonkeypress",
					  label='JavaScript - Onkeypress',
					  show_content_type=True,
					  i18n_domain=i18n_domain),
		   )
    
  

  ))


class kzFormButton(BaseFolder,Translateable):
    """kzFormButton """
    
    schema = schema
    
    meta_type = 'kzFormButton'
    archetype_name = "Kuzgun Form Button"
   
    _properties = ({'id':'tagname','type':'string', 'mode':'w'},)
    
    tagname="formbutton"
    
    actions = (
	
	{
	    'id': 'formbutton_test',
	    'action': 'string:$object_url/kzformbutton_test',
	    },
	)
    
    global_allow = 1
    filter_content_types = 1
    allowed_content_types = ['Image','kzPythonScript','kzJavaScript']
    
    security = ClassSecurityInfo()
    
    def __init__(self, oid, tableid="", **kwargs):
        BaseFolder.__init__(self,oid,**kwargs)    
	
    def manage_afterAdd(self, item, container):
	BaseFolder.manage_afterAdd(self, item, container)
	
    def runCondition(self,tableobj):
	return self.calculate("condition", const_params=["tableobj"], param_values=[tableobj])

    def runValidation(self,tableobj):
	return self.calculate("validation", const_params=["tableobj"], param_values=[tableobj])
	
    def runAction(self,tableobj):
	return self.calculate("action", const_params=["tableobj"], param_values=[tableobj])
	
    def calculate(self, scriptname, const_params=[], param_values=[], superusermode=0):
      # Scriptin parametrelerini bulur ve hesaplar
      if scriptname == "condition":
	  scriptobj = self.getConditionScript()
	  scriptcall =  self.getConditionScriptParams()
      elif scriptname == "validation":
	  scriptobj = self.getValidationScript()
	  scriptcall = self.getValidationScriptParams()
      elif scriptname == "action":
	  scriptobj = self.getActionScript() 
	  scriptcall = self.getActionScriptParams() 
      else:
	  scriptobj = None
      
      if scriptobj is None:
	  return {"error" : ("file error","scriptobj %s is not found" % (self.getId()) ),
		  "result": ("","")}      
      elif scriptobj.getPythonScript() is None:
	  return {"error" : ("file error","script %s for %s is not found" % (scriptname,scriptobj.getId() ) ),
		  "result": ("","")}
      else:
	script = scriptobj.getPythonScript()
	scriptcall = ",".join(list(scriptcall))
	parameters = self.getKuzgunReference().getChilds(self.getTableid(),"param")
	
	variables = vars()
	for i in range(len(const_params)):
	  variables[const_params[i]] = param_values[i]
	  
	script_params_text = getattr(script,'_params')
	const_params_text  = string.join(const_params,",")
	control    = 0
	if len(script_params_text) == 0:
	  params = const_params_text
	  control = 1
	elif script_params_text.find(const_params_text) < 0:
	  params = "%s,%s" % (const_params_text,script_params_text)
	  control = 1
	  
	if control:
	  text = getattr(script,'_body')
	  script.ZPythonScript_edit(params, text)  
	  
	script_call_text = scriptcall
  
	for param in parameters:
	  paramname = param["paramid"]
	  fieldid   = param["fieldrelation"]
	  script_call_text = string.replace(script_call_text,
					    '$%s$' % (paramname),
					    "'%s'" % (fieldid) )
	  # Parametre degerlerini hesapla
	  if script_call_text.find('|%s|' % (paramname)) > -1:
	    try:
	      variables[paramname] = self.get_param(param)
	      script_call_text = string.replace(script_call_text,'|%s|' \
						% (paramname),"%s" % (paramname) )
	    except:
	      return {"error" : ("get_param","%s %s" % (getException(scriptname),param) ),
		      "result": ("","")}
  
	if superusermode:
	  securitymanager = getSecurityManager()
	  newSecurityManager(request={},user=superuser)     
	
	try: 
	  result = eval("script(%s)" % (script_call_text) )
	  error = ""
	except:
	  except_string = str(sys.exc_type) +":"+str(sys.exc_info)
	  error    = ("script error","<br />tagid=%s <br />params=%s <br />error= %s" \
		      % (self.getId(),script_call_text,getException(scriptname)) )
	  result   = ("","")
	
	if superusermode:
	  setSecurityManager(securitymanager)
  
	return {"error" : error,
		"result": result}
    
      
    def get_param(self,param):
      # Parametre tipine gore bir deger olusturur ve dondurur
      if param["paramtype"] == "0":
	return self.get_param_0(param["fieldrelation"])
      if param["paramtype"] == "1":
	return self.get_param_1(param["fieldrelation"])
      else:  
	return self.get_param_2(param["fieldrelation"])
	
    def get_param_0(self,fieldid):
      # Ayni tablo i�deki alan degerini alir
      if fieldid[:fieldid.rfind("_")] == self.tagid[:self.tagid.rfind("_")]:
	return self.kztable.get_field(fieldid)
      else:
	return [-1,-1]
    
    def get_param_1(self,fieldid):
      # Ayni grup i�deki alan degerini alir
      tableid    = fieldid[:fieldid.rfind("_")]
      masterrecno= self.kztable.essentials.masterrecno
      # Kendi alt tablosu mu diye bakiyor
      if self.kztable.subtable != None:
	if self.kztable.subtable.tableID == tableid:
	  masterrecno = self.kztable.essentials.recno
      # Alan �likleri aliniyor    
      field_attr = self.kztable.qref.getAttributes(fieldid)
      from kzFields import kzField
      field      = kzField(self.kztable,fieldid,field_attr)
      
      fields = []
      for name in field.names:
	fields.append(field.tagid+name)
      cond = ("masterrecno",int(masterrecno))  
      rec = self.kztable.qdata.sqlselectrecords(tableid,fields,cond=cond)
  
      result = []
      for r in rec:
	field.set(r)
	result.append(field.get_value())
      return result
    
    def get_param_2(self,fieldid):
      # T�n degerini alir
      tableid    = fieldid[:fieldid.rfind("_")]
      field_attr = self.kztable.qref.getAttributes(fieldid)
      from kzFields import kzField
      field      = kzField(self.kztable,fieldid,field_attr)
      
      fields = []
      for name in field.names:
	fields.append(field.tagid+name)
      rec = self.kztable.qdata.sqlselectrecords(tableid,fields)
  
      result = []
      for r in rec:
	field.set(r)
	result.append(field.get_value())
      return result
    
  
	
    def Schemata(self):
        schematas = BaseFolder.Schemata(self)
	return schematas
    
    def formButtonView(self):
	return {"name"    : self.getName(),
		"id"      : self.getId(),
		"text"    : self.Title(),
		"image"   : self.getImage(),
		"type"    : self.getType(),
		"onclick" : self.getJavaScript_onclickParams(),
		"value"   : "",
		"jscripts": self.getJavaScripts()
		}
    
    def getJavaScripts(self):
	return {"onclick"    : {"params": self.getJavaScript_onclickParams(),
				"script": self.getJavaScript_onclick()},
		"onchange"   : {"params": self.getJavaScript_onchangeParams(),
				"script": self.getJavaScript_onchange()},
		"onfocus"    : {"params": self.getJavaScript_onfocusParams(),
				"script": self.getJavaScript_onfocus()},
		"onblur"     : {"params": self.getJavaScript_onblurParams(),
				"script": self.getJavaScript_onblur()},
		"onmouseover": {"params": self.getJavaScript_onmouseoverParams(),
				"script": self.getJavaScript_onmouseover()},
		"onmouseout" : {"params": self.getJavaScript_onmouseoutParams(),
				"script": self.getJavaScript_onmouseout()},
		"onkeypress" : {"params": self.getJavaScript_onkeypressParams(),
				"script": self.getJavaScript_onkeypress()}
		}
	
    
registerType(kzFormButton, PROJECTNAME)

def getException(scriptname):
  etype, value, tb = sys.exc_info()
  exctype  = str(etype)
  excvalue = str(value)
  lines    = traceback.format_tb(tb)
  lineinfo = ""
  lines.reverse()
  for line in lines:
    if str(line).find("in %s" % scriptname) >= 0:
      lineinfo = str(line)
      break
  
  return "%s:%s:%s" % (exctype,excvalue,lineinfo) 
  