# -*- coding: utf-8 -*-
from config import *
from AccessControl import ClassSecurityInfo
from Translateable import Translateable
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate
from Products.PythonScripts.PythonScript import PythonScript
import string
import sys

schema = BaseSchema + Schema((
    
    StringField('scriptParams',
		widget=StringWidget(label_msgid="label_scriptparams",
				    description_msgid="help_scriptparams",
				    label='Script Parameters',
				    i18n_domain=i18n_domain),
		),
  
    StringField('scriptText',
	      widget=TextAreaWidget(label_msgid="label_scripttext",
				    description_msgid="help_scripttext",
				    label='Script Text',
				    rows=40,cols=60,
				    i18n_domain=i18n_domain),
	      ),
    ))

class kzPythonScript(BaseFolder,Translateable):
    """kzPythonScript """
    
    schema = schema
    
    _properties = ({'id':'tagname','type':'string', 'mode':'w'},)
    
    meta_type = 'kzPythonScript'
    archetype_name = "Kuzgun Python Script"
    tagname="pythonscript"
    scriptname="script"
    
    global_allow = 0
    filter_content_types = 1
    allowed_content_types = []
    
    security = ClassSecurityInfo()
	
    def manage_afterAdd(self, item, container):
    	BaseFolder.manage_afterAdd(self, item, container)
	self.setPythonScript()
	
    def setScriptParams(self, value, **kwargs):
	self.getField('scriptParams').set(self, value, **kwargs)
	self.setPythonScript()
	
    def setScriptText(self, value, **kwargs):
	self.getField('scriptText').set(self, value, **kwargs)
	self.setPythonScript()
	
    def Schemata(self):
        schematas = BaseFolder.Schemata(self)
	return schematas
    
    def execute(self,**kwargs):
	script = getattr(self,self.scriptname)
	return script(**kwargs)
	    
    def getPythonScript(self):
	return getattr(self,self.scriptname,None)
    
    def setPythonScript(self):
        scriptparams = self.getField("scriptParams").get(self) 
        scripttext = self.getField("scriptText").get(self)     
        if not self.scriptname in self.objectIds():
	    self._setObject(self.scriptname, PythonScript(id=self.scriptname))
	script = getattr(self,self.scriptname)
	scripttext = scripttext.replace('\r','')
        script.ZPythonScript_edit(scriptparams, scripttext)
	
    def getScriptErrors(self):
	if not self.scriptname in self.objectIds(): 
	    return ""
	else:
	    script = getattr(self,self.scriptname)
	    errors = getattr(script,"errors","")
	    if errors: return str(errors)
	    else: return ""

registerType(kzPythonScript, PROJECTNAME)