# -*- coding: utf-8 -*- 
import copy
import sys
from DateTime import DateTime
from kzScript import *
from kzExtraModules import *
from Products.Kuzgun.kzString import kzString
from Products.Kuzgun.kzMoney.kzMoney import *
from Products.Kuzgun.kzUnicode import *
from Products.kzDBDesign.kzDBDesign import get_object
from AccessControl  import ClassSecurityInfo
from Globals import InitializeClass

class kzEssentials:
  # Essential fields
  
  security = ClassSecurityInfo()
  
  security.declarePublic("masterrecno") 
  def __init__(self,parent):
    self.parent   = parent
    self.readonly = 0
    
    self.userAuth = -1
    self.userID   = -1
    self.authMode = "Read"
    
    self.authority   = -1
    self.date        = ""
    self.lastuser    = ""
    self.owner_name  = ""
    self.recno       = -1
    self.masterrecno = -1
    self.state       = ""
    
   
  def set(self,dic):  
    self.authority  = int(dic.get("authority",""))
    self.date       = dic.get("date","")
    self.lastuser   = dic.get("lastuser","")
    self.owner_name = dic.get("owner_name","")
    self.recno      = int(dic.get("recno",-1))
    self.masterrecno= int(dic.get("masterrecno",self.masterrecno))
   
      
  def reset(self):
    self.authority   = -1
    self.date        = ""
    self.lastuser    = ""
    self.recno       = -1
    self.owner_name  = ""
    self.readonly    = 1
    
  def set_new(self):
    self.recno       = self.parent.getcurrecno() + 1
    self.authority   = int(self.userAuth)
    self.lastuser    = self.parent.userID
    self.date        = getCurrentTime()
    self.owner_name  = self.parent.userID
    
  def add(self,request):
    self.recno       = self.parent.getnextrecno()
    self.authority   = int(request.get("authority",-1))
    self.lastuser    = self.parent.userID
    self.date        = getCurrentTime()  
    if self.parent.customerMode:
      self.owner_name = self.parent.userID
    else:  
      self.owner_name = request.get("owner_name",self.parent.userID)
    
  def update(self,request):
    self.authority   = int(request.get("authority",-1))
    self.lastuser    = self.parent.userID
    self.date        = getCurrentTime()
    if self.parent.customerMode:
      self.owner_name = self.parent.userID
    else:  
      self.owner_name = request.get("owner_name","")
      
  def prepareForSearching(self):
    self.temprecno = self.recno
    self.tempmasterrecno = self.masterrecno
    self.reset()
    
  def endSearching(self):
    records = self.parent.Records.records
    if self.temprecno in records:
      recno = self.temprecno
    elif len(records):
      recno = records[0]
    else:
      recno = -1
    self.recno = recno
    self.masterrecno = self.tempmasterrecno

    
  def get(self):
    return {"masterrecno":str(self.masterrecno),
           "recno"       :str(self.recno),
           "lastuser"    :str(self.lastuser),
           "authority"   :str(self.authority),
           "date"        :str(self.date),
           "owner_name"  :str(self.owner_name)}
  
  
InitializeClass(kzEssentials)
  


mapping = {"s" :[""],
           "i" :["_0","_1"],
           "d" :["_0","_1"],
           "dt":[""],
           "m" :["_0","_1"],
           "l" :[""],
           "a" :["_0","_1","_2","_3","_4"],
           "t" :["_0","_1","_2"],
           "p" :["_0","_1"],
           "v" :[""],
           "w" :[""],
           "e" :[""]}

data_types = {"s" :["string"],
              "i" :["numeric","string"],
              "d" :["string","string"],
              "dt":["datetime"],
              "m" :["numeric","string"],
              "l" :["string"],
              "a" :["string","string","string","string","string"],
              "t" :["string","string","string"],
              "p" :["string","string"],
              "v" :["string"],
              "w" :["string"],
              "e" :["string"]}

defaults = {"s" :[""],
            "i" :["","item"],
            "d" :["","dmy"],
            "dt":[""],
            "m" :["","tr_lira"],
            "l" :["1"],
            "a" :["","","","",""],
            "t" :["90","",""],
            "p" :["","50"],
            "v" :[""],
            "w" :[""],
            "e" :[""]}


class kzField:
  #Base field
  
  security = ClassSecurityInfo()
  
  def __init__(self,parent,tagid,attr):
    self.tagid      = tagid
    self.attr       = copy.deepcopy(attr)
    self.names      = mapping[self.attr["type"]]
    self.data_types = data_types[self.attr["type"]]
    self.defaults   = []    
    self.parent     = parent
    self.aq_parent  = None

    self.mode       = ""
    self.error      = [] # (err key, err defn)
    
    self.script_changed = 0
    
    self.storage1 = []
    self.storage2 = []

    self.reset()
    self.setdefaults()
    
    self.tempattr        = {}

    # Alanin hesaplama methodunun ne oldugunu belirtir
    self.calculate_str = ""
    if self.attr["source"] == "default":
      setattr(self,"calculate_str","self.default")
    elif self.attr["source"] == "select":
      setattr(self,"calculate_str","self.selection")  
    elif self.attr["source"] == "script":
      setattr(self,"calculate_str","self.script")
    else:
      setattr(self,"calculate_str","self.default")
      
      
  def getFieldData(self,container):
    dic = self.getFieldInfo(container)
    dic.update(self.getFieldStorages())
    dic.update({"jscripts" : self.getJavaScripts()})
    return dic    
      
  
  def getFieldInfo(self,container):
    self.set_style()
    return { 
      "id"       : self.tagid,
      "attr"     : self.getFieldAttr(container),
      "error"    : self.getError(),
      "mode"     : self.mode,
      }
  
  def getFieldAttr(self,container):
    field = get_object(container,container,self.attr,container)
    return {
      "id" : self.tagid,
      "title":field.validateTitle(self.getTitle()),
      "widget":field.validateWidget(self.getWidget()),
      "enable":self.attr["enable"],
      "description":self.attr["description"],
      "separator":field.validateSeparator(self.attr.get("separator","0")),
      "separatortext":field.validateSeparatortext(self.attr.get("separatortext","")),
      "reference":self.attr["reference"],
      "min":self.attr["min"],
      "default":self.attr["default"],
      "max":self.attr["max"],
      "length":self.getLength(),
      "essential":self.attr["essential"],
      "source":self.attr["source"],
      "readonly":str(self.isReadonly()),
      "tagname":self.attr["tagname"],
      "indexed":self.attr["indexed"],
      "required":field.validateRequired(self.attr.get("required","0")),
      "type":self.attr["type"],
      "order":self.attr["order"],
      "parts":field.validateParts(self.attr.get("parts","")),
      "backstyle":self.attr.get("backstyle",""), 
      "fieldstyle":self.attr.get("fieldstyle","") 
      }
  
  
  def getFieldStorages(self):
    return { 
      "storage1" : self.getStorage1(),
      "storage2" : self.getStorage2()
      }
  
  def getJavaScripts(self):
    jscriptlist = self.parent.qref.getChilds(self.tagid,'javascript')
    params      = self.parent.qref.getChilds(self.tagid,"param")    
    jscriptdic  = {}
    for jscript in jscriptlist:
      tagid  = jscript["tagid"]
      script = self.parent.qref.getContainer(tagid)
      event  = tagid[len(self.tagid)+1:]
      call   = getattr(script,'call')#paramNameToIds(getattr(script,'call'),params)
      jscriptdic[event] = {"call"  :call,
                           "params":getattr(script,'title'),
                           "text"  :getattr(script,'raw')}
    return jscriptdic


  def getError(self):
    err = self.error
    self.error=[]
    return err

  
  def getFieldsForOrder(self):
    # Tablo icinde siralama yapmasi icin tuple listesi dondurur 
    fieldlist = []
    if self.attr["indexed"] == "1":
      for name in self.getSearchableIds():
        fieldlist.append( name )
    return fieldlist
  
  def prepareForSearching(self):
    self.reset()
    
  def endSearching(self):
    pass
  
  def getSearchableValues(self,dic):
    # Tabloda arama yaparken alan degerlerini alir
    cond = ()
    fieldids = self.getSearchableIds()
    control  = 0
    for i in range(len(self.names)):
      name = self.tagid + self.names[i]

      if name in fieldids:
        value = dic.get(name,'')
        
        if self.data_types[i] == 'numeric':
          value = number_test(value)
          if len(value):
            temp = (name,"%s" % (value))
            control = 1
          else:
            temp = ()

        else:
          temp  = (name,'like','%s%s%s' % (chr(37),value,chr(37)))
          if len(value): control = 1
        
        if len(temp):
          if len(cond):
            cond = (cond,'and',temp)
          else:
            cond = temp

    return control,cond
      
  
  
  def set(self,dic):
    # Dictionary'e g�set eder
    i = 0
    for name in self.names:
      value = dic.get(self.tagid+name,self.defaults[i])
      if value is None:
        value = self.defaults[i]
      # Bulunan degeri listeye ekle 
      if self.data_types[i] == "numeric":
        value = str(value).replace(",","")
      value=value.replace("&quot;",'"')  
      insert(self.storage1,i,str(value))
      i = i + 1  
      
    if self.attr["source"] == "script":
      if dic.get(self.tagid+"_s",'0') == '1':
        self.script_changed = 1
      else:
        self.script_changed = 0

          
  def setnew(self):
    # Yeni kayit eklemek i� degerlerini ayarlar
    self.storage1 = []
    self.storage2 = []
    for i in range(len(self.names)):
      value = self.defaults[i]
      insert(self.storage1,i,str(value))
      insert(self.storage2,i,str(value))
    
  def setdefaults(self):
    # Alanlarin default degerlerini ayarlar
    user_defined_defaults = self.attr["default"]
    self.defaults = copy.deepcopy(defaults[self.attr["type"]])
    if self.attr["type"] == "t":
      self.defaults[2] = user_defined_defaults
    else:
      self.defaults[0] = user_defined_defaults

#########################################################################
######################### TEMP ATTRIBUTES    ############################
#########################################################################

  def clearTempAttributes(self):
    self.tempattr = {}
    
  def setTempAttributes(self):
    triggerobj = kzScript(self.parent,self.tagid,"dynamicprops")
    triggerobj.calculate(["kzobject"],[self])
    
    
  security.declarePublic("setTempTitle")            
  def setTempTitle(self,value):
    self.tempattr["title"] = value
    
  security.declarePublic("getTitle")            
  def getTitle(self):
    return self.tempattr.get("title",self.attr["title"])
  
  security.declarePublic("setTempLength")            
  def setTempLength(self,value):
    try: self.tempattr["length"] = int(value)
    except: pass
    
  security.declarePublic("getLength")            
  def getLength(self):
    return self.tempattr.get("length",self.attr["length"])
  
  security.declarePublic("setTempWidget")            
  def setTempWidget(self,value):
    #ftype = self.attr["type"]
    #if value in widgets.get(ftype,[]):
    self.tempattr["widget"] = value
    
  security.declarePublic("getWidget")            
  def getWidget(self):
    return self.tempattr.get("widget",self.attr["widget"])
  
  security.declarePublic("setTempReadonly")            
  def setTempReadonly(self):
    self.tempattr["readonly"] = 1
    
  security.declarePublic("unsetTempReadonly")            
  def unsetTempReadonly(self):
    self.tempattr["readonly"] = 0
    
  security.declarePublic("isReadonly")            
  def isReadonly(self):
    return str(self.tempattr.get("readonly",self.attr.get("readonly","0")))
  
  security.declarePublic("isRequired")            
  def isRequired(self):
    return self.tempattr.get("required",self.attr.get("required","0")) in [1,"1"]
  
  security.declarePublic("setTempStorage1")            
  def setTempStorage1(self,value):
    temp = []
    temp = self.setStorage(temp,value)
    if temp:
      self.tempattr["storage1"] = temp
         
  def setStorage1(self,value):
    self.storage1 = self.setStorage(self.storage1,value)
    
  security.declarePublic("getStorage1")            
  def getStorage1(self):
    value = self.tempattr.get("storage1",self.storage1) 
    result = []
    for i in range(len(self.names)):
      if i < len(value):
        result.append(value[i])
      elif i < len(self.storage1):
        result.append(self.storage1[i])
      else:
        result.append('')
    return result
    
  security.declarePublic("setTempStorage2")            
  def setTempStorage2(self,value):
    self.tempattr["storage2"] = value
    
  def setStorage2(self,value):
    self.storage2 = value
   
  security.declarePublic("getStorage2")            
  def getStorage2(self):
    return self.tempattr.get("storage2",self.storage2) 
  
  def setStorage(self,storage,value):
    if type(value) is type([]):
      storage = []
      i = 0
      while (i < len(value)) and (i < len(self.names)):
          insert(storage,i,str(value[i]))
          i = i + 1  
    return storage      

################################################################################
################################################################################

  def controlRequired(self):
    if self.isRequired():
      value = self.getStorage1()
      if not value[0]:
        self.error.append( ("field required","This field must be filled out") )
        return 0
    return 1



################################################################################
################################################################################  
  
  def control_auth(self):
    # Yetkisi varmi diye kontrol et
    return self.parent.essentials.userAuth > 1 
      

  def set_style(self):
    # Alanin stili belirlenir
    if self.parent.searchMode == 1:
      self.mode = "edit"
    elif self.parent.readonlyMode == 1:
      self.mode = "view"
    elif self.parent.essentials.authMode == "Read":
      self.mode = "view"
    elif self.isReadonly() == "1":
      self.mode = "view"    
    elif self.parent.recordMode:
      self.mode = "edit"    
    elif self.parent.essentials.masterrecno < 0:
      if self.parent.essentials.recno >= 0:
        self.mode = "edit"
      else:
        self.mode = "view"
    elif self.parent.essentials.recno < 0:
      self.mode = "view"
    elif self.parent.tableType == "m":
      if self.attr["essential"] == "0":
        self.mode = "edit"
      elif self.attr["reference"] == "":
        self.mode = "edit"
      else:
        self.mode = "view"
    else:
        self.mode = "edit"

     
  def reset(self):
    # Alanlarin i�i bosaltir
    for i in range(len(self.names)):
      insert(self.storage1,i,"")
    self.storage2 = []

    
  def get(self):
    # Alan degerine g�d� olusturur
    self.validate()
    i = 0
    tableID = self.parent.tableID

    # Essential alan mi
    if self.attr["reference"]:
      reference       = self.parent.groupID + self.attr["reference"]
      index           = string.rfind(reference,"_")
      reference_table = reference[:index]
      dic = {tableID:{} , reference_table:{} }  
      cont_essential = 1
    else:
      dic = { tableID:{} }
      cont_essential = 0

    # Alanlari tara  
    for name in self.names:
      # Listenin boyunu kontrol et  
      if (len(self.storage1)-1) < i:
        insert(self.storage1,i,"")
      value =  self.storage1[i] 
      # Bulunan degeri ekle    
      dic[tableID][self.tagid+name] = value
      if cont_essential:
        dic[reference_table][reference+name] = value
      i += 1

    return dic
  
    # Script Durumunu da aktar
    if self.attr["source"] == "script":
      if self.script_changed == 1:
        dic[tableID][self.tagid+"_s"] = "1"
      else:
        dic[tableID][self.tagid+"_s"] = "0"
      if cont_essential:
        if self.script_changed == 1:
          dic[reference_table][reference+"_s"] = "1"
        else:
          dic[reference_table][reference+"_s"] = "0"
          
    # Metodtan d�   return dic

  
  def calculate(self):
    eval("%s()" % (self.calculate_str) )
  
    
  def default(self):
    # Alanin hesaplama sonucu varsayilan degerini dondurur
    self.storage2 = []

    
  def selection(self):
    self.storage2 = []
    childs = self.parent.qref.getChilds(self.tagid,"select")
    for child in childs:
        self.storage2.append( (child["selectid"],child["text"]) )

        
  def script(self):
    if self.script_changed:
      setattr(self,"print_entry_str","self.print_storage1")
    else:  
      script       = kzScript(self.parent,self.tagid,"script")
      result       = script.calculate()
      if len(script.error):
        self.error.append( script.error )
      if type(result) in [type(()),type([])]:
        result,index = result[0],result[1]
        if index == -1:
          insert(self.storage1,0,str(result[0]) )
          setattr(self,"print_entry_str","self.print_storage1")
        elif index == 0: 
          for i in range(len(result)):
            insert(self.storage1,i,str(result[i]) )
          setattr(self,"print_entry_str","self.print_storage1")
        else:
          self.storage2 = result
          setattr(self,"print_entry_str","self.print_storage2")
      else:
        self.error.append( ("field message","unpack no sequence : %s" % result) )
        setattr(self,"print_entry_str","self.print_storage1")
      
        
  def get_names(self):
    temp = []
    for name in self.names:
      temp.append(self.tagid+name)
    return string.join(temp,",")  

  
  def get_value(self):
    return self.storage1
  
 
  def maxLengthCheck(self,ustring,length):
    try: 
      u_str_list = parse_utf8(ustring)
    except: 
      self.error.append( ("Bad UTF-8 Character Encoding",ustring) )
      u_str_list = []
      
    if len(u_str_list)>length:
      self.error.append( ("Too Long String",ustring) )
      
    return make_utf8(u_str_list[:length])
  
  
  def minMaxTest(self,ustring):
    min,max    = self.attr['min'],self.attr['max']
    val_length = len(ustring)
    min_length = len(min)
    max_length = len(max)
    sort_list,cont  = [] , 0

    if min_length:
      sort_list.append({'temp':min})
      cont += 1
    if max_length:  
      sort_list.append({'temp':max})
      cont += 2
    sort_list.append({'temp':ustring})
    if cont > 0:
      kzSort([sort_list,('temp','max')])
  
    if cont == 1 or cont == 3:
      if sort_list[1]['temp'] != ustring:
        self.error.append( ("Max Test Error",ustring) )
        ustring = ""
    elif cont == 2:
      if sort_list[0]['temp'] != ustring:
        self.error.append( ("Min Test Error",ustring) )
        ustring = ""
        
    return ustring    
  
  
  def validate(self,ustring,length,minMaxTest=0):
    ustring = self.maxLengthCheck(ustring,int(length))
    if minMaxTest:
      ustring = self.minMaxTest(ustring)
    return ustring
    
  
         
  
  
class kzField_s(kzField):
  # String 
  
  def validate(self):
    ustring = self.storage1[0]
    length  = int(self.attr["length"])
    self.storage1[0] = kzField.validate(self,ustring,length,minMaxTest=1)
        
  def getSearchableIds(self):
    return [self.tagid+self.names[0]]  
  
  
    
class kzField_i(kzField):
  # Sayi 
  
  def validate(self):
    ustring = self.storage1[0]
    length  = int(self.attr["length"])
    ustring = kzField.validate(self,ustring,length,minMaxTest=1)
    if ustring:
      if not number_test( ustring ):
        self.error.append( ("Number Test Error",ustring) )
        ustring = ""
    if not ustring: ustring = None
    self.storage1[0] = ustring

  def getSearchableIds(self):
    return [self.tagid+self.names[0]]  
  
  
class kzField_d(kzField):
  # Tarih
  
  def validate(self):
    ustring = self.storage1[0]
    length  = 10
    ustring = kzField.validate(self,ustring,length,minMaxTest=1)
    if len( ustring.split("/") ) != 3:
      ustring = ""
    self.storage1[0] = ustring  
      
  def getSearchableIds(self):
    return [self.tagid+self.names[0]]  
  
class kzField_dt(kzField):
  # Tarih
  
  def validate(self):
    ustring = self.storage1[0]
    length  = int(self.attr["length"])
    self.storage1[0] = kzField.validate(self,ustring,length,minMaxTest=1)
    try: DateTime(self.storage1[0])
    except: self.storage1[0] = ""
        
  def getSearchableIds(self):
    return [self.tagid+self.names[0]]  
    
  
   
class kzField_m(kzField):
  # Para
  
  def validate(self):
    ustring = str(self.storage1[0]).replace("," , "")
    length  = int(self.attr["length"])
    ustring = kzField.validate(self,ustring,length,minMaxTest=1)
    if ustring:
      if not number_test( ustring ):
        self.error.append( ("Number Test Error",ustring) )
        ustring = ""
    if not ustring: ustring = None
    self.storage1[0] = ustring
    
  def getSearchableIds(self):
    return [self.tagid+self.names[0]]      
  

class kzField_l(kzField):
  # Mantik
  
  def validate(self):
    ustring = self.storage1[0]
    length  = 1
    ustring = kzField.validate(self,ustring,length,minMaxTest=1)
    if not ( ustring in ["1","0"] ):
      ustring = "0"
    self.storage1[0] = ustring  
      
  def getSearchableIds(self):
    return [self.tagid+self.names[0]]        
  
 
class kzField_a(kzField):
  # Adres 50 20 20 10 20
  
  def validate(self):
    ustring0 = self.storage1[0]
    length0  = 50
    ustring1 = self.storage1[1]
    length1  = 20
    ustring2 = self.storage1[2]
    length2  = 20
    ustring3 = self.storage1[3]
    length3  = 10
    ustring4 = self.storage1[4]
    length4  = 20
    
    ustring0 = kzField.validate(self,ustring0,length0,minMaxTest=1)
    ustring1 = kzField.validate(self,ustring1,length1,minMaxTest=0)
    ustring2 = kzField.validate(self,ustring2,length2,minMaxTest=0)
    ustring3 = kzField.validate(self,ustring3,length3,minMaxTest=0)
    ustring4 = kzField.validate(self,ustring4,length4,minMaxTest=0)
    
    self.storage1[0] = ustring0  
    self.storage1[1] = ustring1  
    self.storage1[2] = ustring2  
    self.storage1[3] = ustring3  
    self.storage1[4] = ustring4 
    
    
  def getSearchableIds(self):
    return [self.tagid+self.names[0],self.tagid+self.names[1],
            self.tagid+self.names[2],self.tagid+self.names[3],
            self.tagid+self.names[4]]      


class kzField_t(kzField):
  # Telefon
  
  def validate(self):
    ustring0 = self.storage1[0]
    length0  = 3
    ustring1 = self.storage1[1]
    length1  = 3
    ustring2 = self.storage1[2]
    length2  = 7
    
    ustring0 = kzField.validate(self,ustring0,length0,minMaxTest=0)
    ustring1 = kzField.validate(self,ustring1,length1,minMaxTest=0)
    ustring2 = kzField.validate(self,ustring2,length2,minMaxTest=1)
   
    if ustring0:
      if not number_test( ustring0 ):
        self.error.append( ("Number Test Error",ustring0) )
        ustring0 = ""
    if ustring1:    
      if not number_test( ustring1 ):
        self.error.append( ("Number Test Error",ustring1) )
        ustring1 = ""
    if ustring2:    
      if not number_test( ustring2 ):
        self.error.append( ("Number Test Error",ustring2) )
        ustring2 = ""  
    
    self.storage1[0] = ustring0  
    self.storage1[1] = ustring1  
    self.storage1[2] = ustring2  

    
  def getSearchableIds(self):
    return [self.tagid+self.names[0],self.tagid+self.names[1],
            self.tagid+self.names[2]]    
    
  
  
class kzField_p(kzField):
  # Resim
  
  def validate(self):
    ustring = self.storage1[0]
    length  = 250
    self.storage1[0] = kzField.validate(self,ustring,length,minMaxTest=1)
            
  def getSearchableIds(self):
    return [self.tagid+self.names[0]]


class kzField_v(kzField):
  # Ses
  
  def validate(self):
    ustring = self.storage1[0]
    length  = 250
    self.storage1[0] = kzField.validate(self,ustring,length,minMaxTest=1)
    
  def getSearchableIds(self):
    return [self.tagid+self.names[0]] 
  

class kzField_w(kzField):
  # URL
  
  def validate(self):
    ustring = self.storage1[0]
    length  = int( self.attr["length"] )
    self.storage1[0] = kzField.validate(self,ustring,length,minMaxTest=1)
    
  def getSearchableIds(self):
    return [self.tagid+self.names[0]]      
  

class kzField_e(kzField):
  # E-Posta
  
  def validate(self):
    ustring = self.storage1[0]
    length  = int( self.attr["length"] )
    self.storage1[0] = kzField.validate(self,ustring,length,minMaxTest=1)
    
  def getSearchableIds(self):
    return [self.tagid+self.names[0]]      
  
 
  
  
def insert(list,index,value):
  for i in range( len(list)-1,index ):
    list.append("")
  list[index] = value

  
def conv_tuplelist(list1,list2):
  if len(list1) != len(list2):
    return None
  else:
    temp = []
    for i in range(len(list1)):
      temp.append( (list1[i],list2[i]) )
    return temp  
  
  
def number_test(number):
  # Sayi testi yapar.
  try:
    string.atof(number)  
    return 1
  except:
    return 0
    
    
