# -*- coding: utf-8 -*- 
########################################################################
#  Proje Ad          :Kuzgun IDE
#  Modl Ad           :Form Generator
#  Hedefleri         :Bir grup tablo uzerinde ilemler yapmaya yarar
#  Gelitiren         :Evrim Ozcelik
#  Copyright         :ANKA Bilgi Teknolojileri 2002
#  Kullanm Haklar    :Her Hakk Sakldr
#  Gerekenler        :formGenerator.zexp dosyas
#                     Referans ve Veri veritabanlar
#  Dosyalar          :kzFormGenerator.py
#                     __init__.py
#                     ./dtml/kzFormGeneratorAdd.dtml
#                     formgenerator.gif
#                    :readme.txt
#-----------------------------------------------------------------------
#  TARIH              : Versiyon        Gelitiren         Deiiklikler

########################################################################


from OFS import SimpleItem

from Globals import DTMLFile #,Acquisition

from AccessControl.Role  import RoleManager
from OFS.SimpleItem      import Item
from OFS.PropertyManager import PropertyManager
from OFS.FindSupport     import FindSupport
from OFS.ObjectManager   import ObjectManager

from Products.Kuzgun.kzSort import kzSort

from Products.ZSQLMethods.SQL import SQL

from kzTables       import *
from kzFields       import *
from kzScript       import *
from kzTabs         import *
from kzExtraModules import *
from kzTemplates    import *

from Products.kzDBDesign.kzDBDesign import get_parent

import time

from DateTime import DateTime

from AccessControl  import ClassSecurityInfo


class kzForm:
    
    security = ClassSecurityInfo()
    
    def __init__(self,id):
        " kzFormGenerator product'nn ozellikleri"
        self.id			= id
        self.title              = ""
        self.groupID		= ""
        self.qref		= ""
        self.qdata		= ""
        
        self.firstLoad          = 0
                                      
        self.tabs               = ""
        self.pick_tabs          = ""
                                      
        self.tables             = ""
        self.tableIndex         = -1

        self.pick_tableIndex    = -1
        self.pick_masterrecno   = -1
        
        self.qformPreferences   = None
        self.kzFormTemplates    = None
        self.open_recno         = None
	
	self.defaultConds       = {}
	self.defaultConsts      = {}
	

    def getMultirowFormData(self,container):
	active_table = self.tables[self.tableIndex]
	fields       = []
	for field in active_table.fields:
	    if field.attr.get("quickview","") in [1,"1"] or \
	       field.attr.get("required","") in [1,"1"]:
		fields.append(field.tagid)
	if not fields:
	    for field in active_table.fields[:5]:
		fields.append(field.tagid)
	return self.getFormData(container,definedfieldids=fields,getsubtable=0)
	
	
    def getFormData(self,container,definedfieldids=None,getsubtable=1,getmastersummary=1):
	active_table = self.tables[self.tableIndex]
	fields       = []
	Date,Time    = splitDate(active_table.dateFormat,active_table.essentials.date)    
	
	active_table.clearTempAttributes()
	active_table.setTempAttributes()
	
	for field in active_table.fields:
	    if definedfieldids is None:
		control = 1
	    elif field.tagid in definedfieldids:
		control = 1
	    else:
		control = 0
	    if control:
		field.clearTempAttributes()
		field.setTempAttributes()
		fields.append( field.getFieldData(container) )
	    
	if getsubtable:    
	    if active_table.subtable:
		self.addFields(active_table.subtable)
		
	
	formdata =  { "tableobj"      : active_table,
		      "groupid"       : self.groupID,
		      "tablelist"     : self.getTableTabs(),
		      "tableid"       : active_table.tableID,
		      "table"         : active_table.getTableInfo(),
		      "errors"        : active_table.getErrors(),
		      "messages"      : active_table.getMessages(),
		      "recno"         : active_table.essentials.recno,
		      "masterrecno"   : active_table.essentials.masterrecno,
		      "lastuser"      : active_table.essentials.lastuser,
		      "owner_name"    : active_table.essentials.owner_name,
		      "authority"     : active_table.essentials.authority ,
		      "userauth"      : active_table.essentials.userAuth,
		      "records"       : active_table.Records,
		      "recordslimit"  : active_table.Records.limit,
		      "recordsoffset" : active_table.Records.offset,
		      "sqlconds"      : active_table.Records.sqlCond,
		      "recordinfo"    : active_table.getRecordInfo(),
		      "date"          : Date,
		      "time"          : Time,
		      "fields"        : fields,
		      "menu"          : active_table.getTableMenu(),
		      "timediff"      : time.clock()-self.time1
		      }
	
	if getmastersummary:
	    mastersummary = {"masterfields":[],
			     "mastertable":{}}
	    if active_table.tableType != "m":
		if active_table.tableMasterSummary:
		    mastersummary = active_table.getMasterSummary(container)
	    formdata.update(mastersummary)

	if getsubtable:
	    formdata.update({"subrecords"    : active_table.getSubRecords(),
			     "subtable"      : active_table.getSubTableData(container)})
		 
	if active_table.tableType == "d":
	    formdata.update( {"unrelatedrecords":active_table.getUnRelatedRecords(),
			      "recordcaption" : active_table.getRecordCaption()} )
	    
	    
	return formdata    
	
#########################################################################
######################## FORMU YENI GRUP ICIN ###########################
###################### KULLANILACAK HALE GETIRIR ########################
#########################################################################

    def getUserID(self):
	return str(self.aq_parent.portal_membership.getAuthenticatedMember())

    def reset(self,groupID):
        # Form Productin yeni bir grup ile baslatmayi saglar
        self.userID   = self.getUserID()
        tables_auth   = []
	for table in self.qref.getChilds_auth(groupID,"table"):
	    obj = get_object(self.qref,self.qdata,table,self)
	    if obj.isEnabled():
		tables_auth.append(obj.getAttributes())
	
        tables       = []
        subTableList = []
        control      = 0

	kzSort([tables_auth,("order","max")])
	
        for table in tables_auth:
            # Tablonun alt tablosuna baklyor    
            subtable = self.qref.getChilds_auth(table["tagid"],"table")
            if len(subtable):
                subtable[0]["type"]  = "n"
                subtable             = subtable[0]
            else:
                subtable = None
		
            # ozet tabloysa basa ekle    
            if table["type"]=="m":   
                tables.insert( 0,(table,subtable) )
                control = control + 1
            else:    
                tables.append( (table,subtable) )
            
        self.tableIndex = 0
        self.tables     = []
        self.tabs       = kzTab()

        if control == 0:
            return (0,"no master")
        elif control == 2:
            return (0,"duplicate master")
        else:
            for table,subtable in tables:
                # Tablo objelerini yarat
                obj = self.addTables(table)
                self.tables.append(obj)
                obj.mastertable = self.tables[0]
                obj.subtable = subtable
                if subtable != None:
                    subobj = self.addTables(subtable)
                    self.tables.append(subobj)
                    subobj.mastertable = self.tables[0]
                    subobj.toptable    = obj
                    obj.subtable       = subobj
                # Tab gorunmesi icin objeleri diz
                if not (table["tagid"] in subTableList):
                    self.tabs.nodes.append( (table["tagid"],table["title"]) )

            # Ozet tablosunun alanlarini at        
            self.addFields(self.tables[0])        
            # Tab indexi ayarlanir
            self.tabs.nodeID = self.tables[0].tableID
            self.tables[0].setMasterRecNo(-1)
            self.tables[0].set_recno()
            return (1,"ok")
         
        
    def addTables(self,attr):
        # Istenilen tablonun objesi yaratilir ve verileri atanir
        id = attr["tagid"]
        if attr["type"] == "m":
            temp = kzTable_m(id)
        elif attr["type"] == "1":
            temp = kzTable_1(id)
        elif attr["type"] == "n":
            temp = kzTable_n(id)
        elif attr["type"] == "d":
            temp = kzTable_nn(id)
        elif attr["type"] == "s":
            temp = kzTable_nn(id)    
        # Tablonun temel ozellikleri veriliyor 
        setattr(temp,"tableType",attr["type"])
        setattr(temp,"tableCaption",attr["title"])
	setattr(temp,"tableDescription",attr.get("description","") )
	setattr(temp,"tableMasterSummary",attr.get("mastersummary","") in [1,"1"] )
        setattr(temp,"userID",self.userID)
        setattr(temp,"groupID",self.groupID)
        setattr(temp,"parent",self)
        setattr(temp,"qref",self.qref)
        setattr(temp,"qdata",self.qdata)
	standartformbuttons = self.aq_parent.kzDBObjectProperties.getKzTableStandartFormButtons(temp.tableType)
	setattr(temp,"standartformbuttons",[bid for bid,btitle in standartformbuttons])
	setattr(temp,"formbuttons",self.aq_parent.kzDBObjectProperties.getKzTableFormButtons(id))
        return temp
    
    def setTableGlobals(self,table):
	username = self.getUserID()
        auth,mode= self.qdata.getAuth(str(username),table.tableID,mode=1)
	if auth == 0: 
	    setattr(table,"customerMode",1)
	else: 
	    setattr(table,"customerMode",0)
        setattr(table.essentials,"userAuth",auth)
        setattr(table.essentials,"authMode",mode)        
        setattr(table.essentials,"userID"  ,str(username))
	setattr(table,"qref",self.qref)
        setattr(table,"qdata",self.qdata) 
	table.setDefaultConds()
	
    
    def addFields(self,table):
        " Aktif tablonun alanlarini al"
        if len(table.fields) == 0:
            fields = self.qref.getChilds_auth(table.tableID,"field")
            kzSort([fields,("order","max")])
            for field in fields:
                if field["enable"] == "1":
                    obj = eval("kzField_%s(table,field['tagid'],field)" % (field["type"]))
                    table.fields.append(obj)
	self.setTableGlobals(table)
        table.setFieldsForOrder()
            
	
#########################################################################
######################### DEFAULT CONDS    ##############################
#########################################################################	
	
    security.declarePublic("setDefaultConds")      
    def setDefaultConds(self,conddic):
	self.resetDefaultConds()
	try: conddic = eval(str(conddic))
	except: conddic = ""
	if type(conddic) is type({}): 
	    self.defaultConds = conddic
	
    security.declarePublic("getDefaultConds")     
    def getDefaultConds(self,tableid):
	return self.defaultConds.get(tableid,())
	    
    security.declarePublic("resetDefaultConds")     
    def resetDefaultConds(self):
	self.defaultConds = {}	
	
#########################################################################
######################### DEFAULT CONSTS    #############################
#########################################################################	
	
    security.declarePublic("setDefaultConsts")      
    def setDefaultConsts(self,constdic):
	self.resetDefaultConsts()
	try: constdic = eval(str(constdic))
	except: constdic = ""
	if type(constdic) is type({}): 
	    self.defaultConsts = constdic
	
    security.declarePublic("getDefaultConsts")     
    def getDefaultConsts(self):
	return self.defaultConsts
	    
    security.declarePublic("resetDefaultConsts")     
    def resetDefaultConsts(self):
	self.defaultConsts = {}		
        
            
#########################################################################
######################### GENERATE    ###################################
#########################################################################

    def generate(self,request):
        # Formu oluturan ve sekillendiren kisim
        self.time1 = time.clock()
        
        # Modul ilk acildiginda kullanicya gore temel degiskenleri ayarlar
        if request.has_key('group'):
	    group = request.get('group','')
	    if group:
		self.groupID=group
		self.firstLoad = 1
	    else:
		title    = "MODULE CONTROL"
		subtitle = "MODULE NOT FOUND"
		message  = "There is no such module in the application"
                self.aq_parent.setError(title,subtitle,message)
                return
	    
        if self.firstLoad:
            # Ilk Yuklenirken
	    defaultconds = request.get("defaultconds","")
	    self.resetDefaultConds()
	    if defaultconds:
		self.setDefaultConds(defaultconds)
		
	    defaultconsts = request.get("defaultconsts","")
	    self.resetDefaultConsts()
	    if defaultconsts:
		self.setDefaultConsts(defaultconsts)
	    # Reset
            ok,info = self.reset( self.groupID )
            # Acilistaki hatalar
            if not ok:
                if info == "no auth":
                    title    = "AUTHENTICATION CONTROL"
                    subtitle = "NO AUTH"
                    message  = "You Have not Authorization on Master Table"

                elif info == "no master": 
                    title    = "DATABASE CONTROL"
                    subtitle = "NO MASTER TABLE"
                    message  = "There is no Master Table for this group"
                            
                else:
                    title    = ""
                    subtitle = ""
                    message  = ""
                   
                self.aq_parent.setError(title,subtitle,message)
                return
            
            self.firstLoad     = 0
	    active_table = self.tables[self.tableIndex]  
	    active_table.Records.reload(self.qdata)

            
        if len(self.tables) < self.tableIndex:
            title     = "TABLE INDEX CONTROL",
            subtitle  = "NO TABLE",
            message   = "Restart the form"
                   
            self.aq_parent.setError(title,subtitle,message)
            return 
        
	# DEFAULT CONSTS ATAMALARI
	defaultconsts = self.getDefaultConsts()
	for key in defaultconsts.keys():
	    request.set(key,defaultconsts[key])
	
        # OBJE AYARLAMALARI
        active_table = self.tables[self.tableIndex]  
	self.setTableGlobals(active_table)
	##self.setUserPreferences()   

	# FORM UZERINDE YAPILAN ISLEMLER
        self.process(request) 
        
        # KAYIT KILITLEME ISLEMLERI
        active_table = self.tables[self.tableIndex]   
        recno = active_table.essentials.recno
        tableid = active_table.tableID
        if recno > 0 or not active_table.recordMode:
            if active_table.essentials.authMode=="Read":
                active_table.readonlyMode = 0
                active_table.releaseRecno(recno,tableid)
            elif active_table.lockRecno(recno,tableid):
                active_table.readonlyMode = 0
            else:
                active_table.readonlyMode = 1
        
        
#########################################################################
############################## GET ERRORS ###############################
#########################################################################

    def geterrors(self,request):
        if request.SESSION.has_key('Form'):
            Form = request.SESSION['Form']
            return Form.get('errors',[])
        return []
    
    
#########################################################################
########################### PREFERENCES #################################
#########################################################################        

    def getUserPreferences(self):
	tableid = self.tables[self.tableIndex].tableID
	type    = self.tables[self.tableIndex].tableType
        
	sqlobj = self.qdata.getsqlobject()
	cond   = (('userid',self.userID),'and',('tableid',tableid))
	sqlobj.selectrecords('form',cond=cond,auth=0)
	return self.qdata.results_qpref(sqlobj)

    
    def setUserPreferences(self):
        " Kullanci tercihleri yukleniyor"

        tableid = self.tables[self.tableIndex].tableID
	type    = self.tables[self.tableIndex].tableType
        
	rec    = self.getUserPreferences()
	        
        if not len(rec):
            self.rowCount = 1
            if type == "m" or type == "1":
                self.columnCount= 2
            else:
                self.columnCount= 1
                
        else:
            self.columnCount= int(rec[0]["col"]) # alanlarin sutun sayisi
            
#########################################################################
########################### METHODS #####################################
#########################################################################        
        
    def setTable(self):
        # Yeni tablonun instance'sini al
        active_table = self.tables[self.tableIndex]
        # Tablo alanlar acilmis mi?
        self.addFields(active_table)
        # Tab zelliklerini ayarla
        self.tabs.nodeID = active_table.tableID
        # Yeni tablonun kayt numarasn ayarla
        active_table.setMasterRecNo(active_table.essentials.masterrecno)
        
    def set_tableIndex(self,tableid):
        # Tablo id'sine gre tablo indeksini bulur
        for i in range(len(self.tables)):
            if self.tables[i].tableID == tableid:
                self.tableIndex = i
                return
        
        
#########################################################################
########################### PROCESS #####################################
#########################################################################

    def process(self,request):
        " Form zerinde yaplmak istenenleri dzenler"

        if request.has_key("buttonname"): 
	    
	    buttonname = request.get("buttonname","")
	    buttonvalue = request.get("buttonvalue","")
            
            if string.split(buttonname,"_")[0]=="table":
                # Yeni bir tabloya gecildiginde tableID ve recno'yu ayarlar
                tableid = buttonvalue
                masterrecno = self.tables[self.tableIndex].essentials.masterrecno
                recno = None
                if tableid == "RETURN":
                    subtable    = self.tables[self.tableIndex]
                    self.tabs   = self.pick_tabs
                    tableid     = subtable.toptable.tableID
                    masterrecno = subtable.toptable.essentials.masterrecno
                    recno       = subtable.essentials.masterrecno
                # Tablo indeksini ayarla
                self.set_tableIndex(tableid)
                # Yeni tablonun instance'sini al
                active_table = self.tables[self.tableIndex]
                active_table.essentials.masterrecno = masterrecno
                # Secilmis tabloyu hazirla
                self.setTable()
                # Belirlenmis ana kayda bagli kaydini ac
		if recno != None:
                    active_table.essentials.recno = recno
                if not active_table.recordMode:
                    active_table.set_recno()
                # Kullanici tercihlerini ykle
                self.setUserPreferences()
		active_table.Records.reload(self.qdata)

                self.searchMode        = 0
                self.searchRecord      = []
                self.searchIndex       = 0
                self.recordMode        = 0


	    elif string.split(buttonname,"_")[0]=='TAB':
                # Formda tab ve girdilerin satr sutun ayarlarn yapmak
		type = self.tables[self.tableIndex].tableType
		tableID = self.tables[self.tableIndex].tableID
		
		rec = self.getUserPreferences()

                if not len(rec):
                    if type in ["m","1"]:
                        columnCount= 2
                    else:
                        columnCount= 1
                else:
                    columnCount= int(rec[0]["col"])
                
                if buttonvalue == "TAB_DEC":
                    if columnCount > 1:
                        columnCount = columnCount - 1
                elif buttonvalue == "TAB_INC":
                    if type in ["m","1"]:
                        if columnCount < 3:
                            columnCount = columnCount + 1
                    else:
                        if columnCount < 2:
                            columnCount = columnCount + 1

                # Kullanci bilgilerini gncelle
                if not len(rec):
                    sql = "insert into form (userid,tableid,col) values "\
                        + "('%s','%s',%s)" % (self.userID,
					      active_table.tableID,
					      columnCount)
                    self.qformPreferences(query=sql)
                    
                else:
                    sql = "update form set col=%s where " \
			+ "userid='%s' and tableid='%s'" % (columnCount,
							  self.userID,
							  active_table.tableID)
                    self.qformPreferences(query=sql)
            
            
            # Alt tablonun istenilen kaydn a�r
            elif buttonname == "SUBREC":
                # Tableri ve eski tablo indeksini gncelle
                active_table         = self.tables[self.tableIndex]
                self.pick_tabs       = copy.deepcopy(self.tabs)
                self.pick_masterrecno= active_table.essentials.masterrecno
                # Alt tabloyu aktif yap
                subtable     = active_table.subtable
                self.set_tableIndex(subtable.tableID)
                subtable.essentials.masterrecno = active_table.essentials.recno
                # Tableri tekrar ayarla
                self.tabs.nodes = []
                caption = subtable.tableCaption
                self.tabs.nodes.append( ("RETURN",caption) )
                self.setTable()
                self.tabs.nodeID = "RETURN"
                subtable.essentials.recno = int(request.form["buttonvalue"])
                # Verileri tabloya yerletir
                subtable.set_recno()
                
               
            # Alt tabloya yeni kayt a�r
            elif buttonname == "NEWSUBREC":
                # Tableri ve eski tablo indeksini gncelle
                active_table         = self.tables[self.tableIndex]
                self.pick_tabs       = copy.deepcopy(self.tabs)
                self.pick_masterrecno= active_table.essentials.masterrecno
                # Tablo indexini ayarla
                subtable     = active_table.subtable
                self.set_tableIndex(subtable.tableID)
                subtable.essentials.masterrecno = active_table.essentials.recno
                self.tabs.nodes = []
                caption = active_table.tableCaption
                self.tabs.nodes.append( ("RETURN",caption) )
                self.setTable()
                self.tabs.nodeID = "RETURN"
                # Yeni kayt moduna getir
                subtable.set_new() 
		
	    elif buttonname == "NEXTPAGE":
		active_table = self.tables[self.tableIndex]
		if active_table.Records.setNextPage(self.qdata):
		    active_table.essentials.recno = active_table.Records.records[0]
		    active_table.set_recno()
	    
	    elif buttonname == "PREVPAGE":
		active_table = self.tables[self.tableIndex]
		if active_table.Records.setPrevPage(self.qdata):
		    active_table.essentials.recno = active_table.Records.records[0]
		    active_table.set_recno()
		    
	    elif buttonname == "RECORDSLIMIT":
		active_table = self.tables[self.tableIndex]	
		limit = buttonvalue
		active_table.Records.setLimit(limit,self.qdata,auth=1)
		
	    elif buttonname == "SETSQLCONDSTEP":
		active_table = self.tables[self.tableIndex]
		step = buttonvalue
		if active_table.Records.setCondStep(step):
		    active_table.Records.reload(self.qdata)
		    
	    elif buttonname == "START SEARCH":
		active_table = self.tables[self.tableIndex]
		active_table.prepareForSearching()
	    
	    elif buttonname == "SEARCH":
		active_table = self.tables[self.tableIndex]
		active_table.search(request)
	    
	    elif buttonname == "END SEARCH":
		active_table = self.tables[self.tableIndex]
		active_table.endSearching()
		active_table.set_recno(self.qdata)
		
	
            else:
                
                active_table = self.tables[self.tableIndex]
                
                # Ozet tablosuysa
                if active_table.tableType == "m":
		    
		    def recordSeek(table,destination):
			# M tipi tabloda kayit hareketi yapar
			if table.searchMode == 0:
			    table.navigation(destination)
			else:
			    if destination == "FIRST": table.search_first()
			    elif destination == "LAST": table.search_last()
			    elif destination == "NEXT": table.search_next()
			    elif destination == "PREV": table.search_prev()    
    
                    if buttonname=='FIRST':
                        recordSeek(active_table,'FIRST')
                            
                    elif buttonname=='LAST':
                        recordSeek(active_table,'LAST')

                    elif buttonname=='NEXT':
                        recordSeek(active_table,'NEXT')
                                
                    elif buttonname=='PREV':
                        recordSeek(active_table,'PREV')
                                            
                    elif buttonname=='NEW':
                        active_table.set_new()
                        
                    elif buttonname=='ADD':
                        active_table.add(request)
                        
                    elif buttonname=='SAVE':
                        active_table.save(request)
                        
                    elif buttonname=='DELETE':
                        active_table.delete()
                        
                    elif buttonname=='COPY':
                        pass
                        
                    elif buttonname=='START SEARCH':
                        active_table.clear()
                        
                    elif buttonname=='SEARCH':
                        active_table.search(request)
    
                    elif buttonname=='END SEARCH':
                        active_table.endsearch()
                        
                    elif buttonname=='RELOAD':
                        pass
                        
                    elif buttonname=='REFRESH':
                        active_table.refresh(request)
                                          
                # 1-1 tablosuysa
                elif active_table.tableType == "1":        
                
                    if buttonname=='SAVE':
                        active_table.save(request)                        
                        
                    elif buttonname=='REFRESH':
                        active_table.refresh(request)
            
            
                # 1-N ilikili tabloysa    
                elif active_table.tableType == "n":
                    
                    if buttonname=='SAVE':
                        active_table.save(request)   
                        
                    elif buttonname=='NEW':
                        active_table.set_new()
                
                    elif buttonname=='ADD':
                        active_table.add(request)
                    
                    elif buttonname=='DELETE':
                        active_table.delete()
                        
                    elif buttonname=='RECORDNO':
                        active_table.essentials.recno = int(buttonvalue)
                        active_table.set_mode(0,0)
                        active_table.set_recno()
                                        
                    elif buttonname=='REFRESH':
                        active_table.refresh(request)
                        
                        
                # N-N ilikili tabloysa    
                elif active_table.tableType == "d":    
                    
                    if buttonname=='NEW':
                        active_table.set_new()
                        
                    elif buttonname=='GET':
                        try:
                            recno = int(request.form['nnrecno'])
			    caption = request.get("_prompt_","caption")
                            if request.form['_confirm_'] == "true":
                                active_table.new(recno,caption)
                            else:
                                active_table.getrec(recno,caption)
                        except:
                            pass
                        
                    elif buttonname=='ADD':
                        active_table.add(request)
                        
                    elif buttonname=='SAVE':
                        if request.form['_confirm_'] == "true":
                            active_table.add(request)
                        else:
                            active_table.save(request)
                            
                    elif buttonname=='RECORDNO':
                        active_table.essentials.recno = int(request.form['buttonvalue'])
                        active_table.set_recno()
                        
                    elif buttonname=='DELETE':
                        if request.form['_confirm_'] == "true":
                            active_table.delete_from_db()
                        else:
                            active_table.delete()
                        
                    elif buttonname=='REFRESH':
                        active_table.refresh(request)
		            
	    # Tablo için tasarlanan dugmeleri kontrol et
	    self.checkDesignedButtons(buttonname)

########################################################################
########################################################################
############################ METHODS ###################################
########################################################################

    def checkDesignedButtons(self,buttonname):
	active_table = self.tables[self.tableIndex]
	setattr(active_table,"formbuttons",self.aq_parent.kzDBObjectProperties.getKzTableFormButtons(active_table.tableID))
	active_table.runDesignedButtonActions(buttonname)
	
	
    
    def openRecno(self,recno,Conds=[]):
        # Formun aktif tablosununistenen kaydi acilir
        active_table = self.tables[self.tableIndex]
        setattr(active_table,"qref",self.qref)
        setattr(active_table,"qdata",self.qdata) 

	active_table.Records.sqlCond = Conds
	
        if active_table.tableType=='m':
            active_table.setMasterRecNo(recno)
	    active_table.Records.reload(self.qdata)				
        else:
            active_table.essentials.recno=recno
            
        active_table.set_recno()	    


    def getTableNextRecno(self,tableid):
        # Belirtilen tablonun siradaki kayit numarasini dondurur
        tableobj=base_table(tableid)
	tableobj.qref = self.qref
        return tableobj.getnextrecno(tableid)

    
    def getFieldsInstance(self):
        # Aktif tablonun alanlarnn o anki durumunu alir
        return copy.deepcopy(self.tables[self.tableIndex].fields)
    
    def getField(self,fieldid):
        # Aktif tablonun istenen alaninin o anki durumunu alir
        for field in self.tables[self.tableIndex].fields:
            if field.tagid == fieldid:
                return field.print_field(self.aq_inner.aq_parent.messages_kuzgun)
        return "%s Field Not Found" % (fieldid)
    
    def getFieldValue(self,fieldid):
	for field in self.tables[self.tableIndex].fields:
            if field.tagid == fieldid:
                return (field.storage1,field.storage2 )
        return None
    
    def getTableTabs(self):
	templist = []
	subtablelist = []
	for table in self.tables:
	    if table.subtable:
		subtablelist.append(table.subtable.tableID)
	    if not table.tableID in subtablelist:
		tagid = table.tableID
		title = table.getTitle()
		if table.tableType == "m":
		    templist.insert(0, (tagid,title) )
		else:
		    templist.append( (tagid,title) )
	return templist
    
    def getActiveTable(self):
        return self.tables[self.tableIndex]    
    
    def getActiveTableID(self):
        return self.tables[self.tableIndex].tableID
    
    def getActiveTableTitle(self):
        return self.tables[self.tableIndex].tableCaption
    
    def getActiveTableType(self):
        return self.tables[self.tableIndex].tableType
    
    def getActiveTableConds(self):
	return self.tables[self.tableIndex].Records.sqlCond
    
    def getActiveTableDefaultConds(self):
	return self.tables[self.tableIndex].Records.defaultCond
    
    def getActiveTableMode(self):
        return self.tables[self.tableIndex].customerMode or \
               self.tables[self.tableIndex].readonlyMode

    def getFormTemplates(self):
	parentid = self.tables[self.tableIndex].tableID
	container = self.qref.getContainer(parentid)
	temp = FindSupport.ZopeFind(FindSupport(container), container, [],
				    ['kzTemplates','kzHtmlReport','kzRmlReport'],search_sub=0) 
	result = []
	for t in temp:
	  result.append( {'id':t[0],'title':getattr(t[1],'title','notitle'),
			  'viewhref':t[1].getTemplateOutputAction()} )
	return result    
    
    def get_container(self):
        return self.aq_inner.aq_parent

    def getMasterRecNo(self):
        # Aktif tablonun masterrecno'sunu dndrr
        if self.tableIndex < 0:
            return -1
        else:
            return self.tables[self.tableIndex].essentials.masterrecno
    
    def getRecNo(self):
        # Aktif tablonun recno'sunu dndrr
        if self.tableIndex < 0:
            return -1
        else:
            return self.tables[self.tableIndex].essentials.recno

	
    def set(self,fieldID,value,index=0):
	# Aktif tablonun bir alanini set eder
	if type(value) != type([]):
            raise "set error, value must be list : set(%s,%s,%s) " % (fieldID,value,index)
	else:
	    active_table = self.tables[self.tableIndex]
	    field = active_table.getFieldByTagid(fieldID)
	    if not field:
		raise "set error, field %s not found : set(%s,%s,%s) " % (fieldID,fieldID,value,index)
	    else:
		if index == 0:
		    field.setStorage1(value)
		elif index == 1:
		    field.setStorage2(value)
		else:
		    raise "set error, index must be 0 or 1 : set(%s,%s,%s) " % (fieldID,value,index)
        
########################################################################
########################################################################
############################ redirect_toForm ###########################
########################################################################

    def openFormSetRecord(self,tableid,recno,REQUEST,newrecord=None):
        # Tabloyu bir kayit numarasiyla acar
                                                                                                                             
        table = self.qref.getAttributes(tableid)
                                                                                                                             
        try: recno = int(recno)
        except: recno = -1
                                                                                                                             
        group = table
        while(group['tagname']!="group"):
            tagid = group['tagid']
            if tagid == "g0":
                return -1
            else:
                group = self.qref.getAttributes(get_parent(tagid))
                                                                                                                             
        if table['type'] == 'm':
            rec = self.qdata.sqlselectrecords(tableid,['recno'],cond=('recno',int(recno)) )
        elif table['type'] in ['n','1','s','d']:
            rec = self.qdata.sqlselectrecords(tableid,['recno','masterrecno'],cond=('recno',int(recno)) )
            # Alt tabloysa
            if table['type'] == "s" and len(rec):
                subtableid = tableid
                subrec     = rec
                tableid    = get_parent(tableid)
                masterrecno= rec[0].get('masterrecno',None)
                if masterrecno is not None:
                    rec = self.qdata.sqlselectrecords(tableid,['recno','masterrecno'],cond=('recno',int(masterrecno)) )
                else:
                    rec = []
                                                                                                                             
        if newrecord or recno == -1:
            rec = [{"recno":-1,"masterrecno":None}]
                                                                                                                             

        if len(rec) == 0:
            return -1
                                                                                                                             
        else:
            self.groupID = group["tagid"]
            ok,info = self.reset(self.groupID)
            if not ok:
                return -1
                                                                                                                             
            else:
                                                                                                                             
                firstrecno       = rec[0].get('recno',-1)
                firstmasterrecno = rec[0].get('masterrecno',None)
                                                                                                                             
                mastertable = self.getActiveTable()
                if firstmasterrecno is None:
                    mastertable.setMasterRecNo(int(firstrecno))
                    mastertable.set_recno()
                    self.process(REQUEST)
                else:
                    mastertable.setMasterRecNo(int(firstmasterrecno))
                    REQUEST.form['buttonname'] = 'table'
                    REQUEST.form['buttonvalue']= tableid
                    self.process(REQUEST)
                    activetable = self.getActiveTable()
                    activetable.essentials.recno = int(rec[0]['recno'])
                    if table['type'] != "s":
                        activetable.set_recno()
                                                                                                                             
                if table['type'] == "s":
                    REQUEST.form['buttonname'] = 'SUBREC'
                    REQUEST.form['buttonvalue']= int(subrec[0]['recno'])
                    self.process(REQUEST)
                                                                                                                             
        return 1
                                                                                                                             
                                                                                                                             
    def redirect_toRecord(self,REQUEST):
        recno     = REQUEST.get("recno",-1)
        tableid   = REQUEST.get("tableid","")
        newrecord = REQUEST.get("newrecord",None)
        successpage = REQUEST.get("successpage","formGen")
        failurepage = REQUEST.get("failurepage",REQUEST.get('history',''))
                                                                                                                             
        if self.openFormSetRecord(tableid,recno,REQUEST,newrecord):
            REQUEST.RESPONSE.redirect(successpage)
        else:
            REQUEST.RESPONSE.redirect(failurepage)
                                                                                                                             


########################################################################
########################################################################
####################### FORM GENERATOR #################################
########################################################################
            

addProductForm=DTMLFile('dtml/kzFormGeneratorAdd', globals())

class kzFormGenerator(kzForm, PropertyManager,SimpleItem.SimpleItem,ObjectManager):
    " kzFormGenerator nesnesi"
    
    meta_type="Kuzgun FormGenerator"

    _properties = (
                   {'id':'title'  , 'type':'string', 'mode':'w'},
                   {'id':'width'  , 'type':'int'   , 'mode':'w'},
                   {'id':'qrefID' , 'type':'string', 'mode':'r'},
                   {'id':'qdataID', 'type':'string', 'mode':'r'},

                   )
    
    manage_main=DTMLFile('dtml/kzFormGeneratorMain',  globals() )
        
    __ac_permissions__=(
    ('Change Database Methods', ('manage_main', 'manage_main')),
    )
                          
    manage_options=(
        PropertyManager.manage_options
        +RoleManager.manage_options
        +Item.manage_options
        +FindSupport.manage_options            
        )
    
    def getNewFormGenerator(self,groupID):
	obj = kzForm('form')
	obj.qref   = self.qref
	obj.qdata  = self.qdata
	obj.aq_parent = self.aq_parent
	obj.reset(groupID)
	return obj

    


# Administrative pages
def manage_addProduct(self, id, title, qref, qdata, RESPONSE=None):
    " Form Generator product' ekler"
    if (id=="") or (qref=="") or (qdata==""):
        RESPONSE.redirect('addFolderForm')
        
    else:
        temp  = kzFormGenerator(id)
                
        setattr(temp,'qdata',getattr(self,qdata))
        temp.qdataID = qdata
              
        setattr(temp,'qref',getattr(self,qref))
        temp.qrefID = qref  
              
        # Authorization Database
        methodID = "qformPreferences"
        DBName   = "Preferences"
        setattr(self,methodID,SQL(methodID,"",DBName,"query","<dtml-var query>"))      
        
        temp.title    = title
   
        self._setObject(id, temp)
        temp=self._getOb(id)
        
        
        if RESPONSE != None:
            RESPONSE.redirect('manage_workspace')        
        
        
        
 
