# -*- coding: utf-8 -*- 
from Products.Kuzgun.kzSort        import kzSort
import string

 
class kzTab:
  # Tablonun zorunlu alanlarini duzenler
  
  def __init__(self):
    # Tab init
    self.nodeID   = ""
    self.nodes    = []
    
  def getNodes(self):
    return self.nodes

  
  
class kzRecords:
  # Tablo kayitlarini tutmak i� 
  
  def __init__(self,tableID,fieldsForOrder,orderby):
    if tableID:
      self.records        = []
      self.dict           = []
      self.sqlCond        = []
      self.defaultCond    = ()
      
      self.tableID        = tableID
      self.fieldsForOrder = fieldsForOrder
      self.orderby        = orderby
      
      if not "recno" in self.fieldsForOrder:
        self.fieldsForOrder.append("recno")
      
      self.offset         = 0
      self.limit          = 100
      
    else:
       raise "Add kzRecords error"
    

  def __len__(self):
    return len(self.records)  
  
  def __str__(self):
    return str(self.records)

  
  def setOffsetLimit(self,offset,limit):
    self.offset = offset
    self.limit  = limit
    
  def setLimit(self,limit,qdata,auth=1):
    try: 
      self.limit = int(limit)
      self.reload(qdata,auth)
    except: 
      pass
    
  def clear(self):
    self.reset()
    self.dict = []
    self.resetCond()
    
    
  ####################################################################  
  
  def setNewCond(self,newCond):
    if newCond:
      if self.sqlCond:
        self.sqlCond.append( (self.sqlCond[-1],'and',newCond) )
      else:
        self.sqlCond.append(newCond)
        
        
  def getCond(self):
    if self.sqlCond:
      cond = self.sqlCond[-1]
    else:
      cond = ()
    if self.defaultCond:
      if cond:
        return (cond,'and',self.defaultCond)
      else:
        return self.defaultCond
    else:
      return cond
    
  def setCondStep(self,i):
    try: 
      i = int(i)
      self.sqlCond = self.sqlCond[:i]
      return 1
    except: 
      return 0
    
    
  def delCond(self):
    if self.sqlCond:
      return self.sqlCond.remove(self.sqlCond[-1])
    
    
  def resetCond(self):
    self.sqlCond = []
    
  ####################################################################    
  
  
  def getInfo(self,recno):
    index = self.getRecIndex( int(recno) )
    return index,len(self)
        
    
  def reset(self):
    self.records = []


  def refresh(self):
    self.reset()
    for r in self.dict:
      self.records.append(int(r["recno"]))
    

  def reload(self,qdata,auth=1):
    orderby = string.join(self.orderby,',')  
    if auth: fields = self.fieldsForOrder
    else: fields  = self.fieldsForOrder + ["authority"]
    self.dict = qdata.sqlselectrecords(self.tableID,fields,\
                                       cond=self.getCond(), \
                                       orderby=orderby,\
                                       offset=self.offset,\
                                       limit=self.limit,
                                       auth=auth)
    self.refresh()
    
    
  def sortRecords(self):
    tupleList    = []
    self.records = []
    for field in self.fieldsForOrder: 
      tupleList.append((field,"max"))
    kzSort( [self.dict] + tupleList )
    self.refresh()
    
    
  def getDict(self,dic,recno=None):
    temp = {}
    for fieldid in self.fieldsForOrder:
      if dic.has_key(fieldid): 
        temp[fieldid] = str(dic[fieldid])
    if recno is not None:
      temp.update({"recno":int(recno)})   
    return temp 
  
  
  def getRecIndex(self,recno):
    if recno in self.records:
      return self.records.index(recno)
    else:
      return -1
    

  def add(self,recno,dic):
    recno = int(recno)
    temp  = self.getDict(dic,recno)
    if len(temp):
      self.dict.append(temp)
      self.sortRecords()
    else: raise "kzRecords add error"
      
    
  def delete(self,recno):
    recno = int(recno)
    index = self.getRecIndex(recno)
    if index >= 0:
      self.records.remove(recno)
      self.dict.remove(self.dict[index])
      len_recs = len(self.records)
      if len_recs:
        if index < len_recs:
          return self.records[index]
        else:
          return self.records[index-1]
    return -1
  
  
  def update(self,recno,dic):
    recno = int(recno)
    index = self.getRecIndex(recno)
    if index >= 0:
      if self.dict[index] == dic:
        return
      else:
        for fieldid in self.fieldsForOrder:
          self.dict[index].update( { fieldid : dic.get(fieldid,'') } )
        self.dict[index].update({"recno" : int(recno)})     
    else:  
      self.add(recno,dic)
    self.sortRecords()
    
  
  ####################################################################        
    
    
  def navigation(self,recno,direction='FIRST'):
    recno = int(recno)
    if direction == 'FIRST':
      return self.first()
    elif direction == 'PREV':
      return self.prev(recno)
    elif direction == 'NEXT':
      return self.next(recno)
    else:
      return self.last()
    
  
  
  def first(self):
    if len(self):
      return self.records[0]
    else:
      return -1

  def prev(self,recno):
    index = self.getRecIndex(recno)
    if index < 0:
      if self.records:
        return self.records[0]
      else:
        return -1
    elif index == 0:
      return recno
    else:
      return self.records[index-1]
      
  
  def next(self,recno):
    index = self.getRecIndex(recno)
    if index < 0:
      if self.records:
        return self.records[0]
      else:
        return -1
    elif index == len(self)-1:
      return recno
    else:
      return self.records[index+1]
    
  
  def last(self):
    len_self = len(self)
    if len_self:
      return self.records[len_self-1]
    else:
      return -1
    
  ####################################################################        

  def pageNavigation(self,qdata,direction='NEXT',auth=1):
    offset  = self.offset
    records = self.records
    dict    = self.dict
    if direction == 'NEXT': 
      self.offset += self.limit
    else:
      if self.offset > self.limit:
        self.offset -= self.limit
      elif self.offset == 0:
        return 0
      else:
        self.offset = 0
    self.reload(qdata,auth)
    if len(self):
      return 1
    else: 
      self.offset = offset
      self.records = records
      self.dict = dict
      return 0
    
  def setNextPage(self,qdata,auth=1):
    if self.pageNavigation(qdata,'NEXT',auth):
      return 1
    else:
      return 0
    
  def setPrevPage(self,qdata,auth=1):
    if self.pageNavigation(qdata,'PREV',auth):
      return 1
    else:
      return 0
    
  
  
  
  
class kzRecordsNN(kzRecords):
  
  def __init__(self,tableID,RtableID,fieldsForOrder,orderby):
      
    kzRecords.__init__(self,tableID,fieldsForOrder,orderby)

    self.RsqlCond       = ()
    self.RtableID       = RtableID
    
    
  def setRCond(self,cond):
    self.RsqlCond = cond      
  
    
  def reload(self,qdata,auth=1):
    cond = ()
    if self.RsqlCond:
      sqlobj = qdata.getsqlobject()
      sqlobj.selectrecords(self.RtableID,["recno"],cond=self.RsqlCond,auth=0)    
      cond = ("recno","in", ["(%s)" % sqlobj.sql[0]] )
    self.resetCond()
    self.setNewCond(cond)
    
    kzRecords.reload(self,qdata,auth)
      
  
  

  
      
      
      
      