# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
#  Proje Ad?          : Kibele E-?? Platformu
#  Modl Ad?          : MenuCreator s?n?f?
#  Hedefleri          : Grup referans tablosunu kullanarak program
#                       mensn olu?turacak HTML ve javascript kodlar?n?
#                       yaratmak.
#  Geli?tiren         : A. Gkhan Gltekin
#  Haklar?            : ANKA Bilgi Teknolojileri 2002
#  Kullan?m Haklar?   : Her Hakk? Sakl?d?r
#  ?artlar?           : Referans tablolar?na eri?ebilecek ZSQLMethod
#                       id'sinin rn eklenirken seilmesi gerekmektedir.
#  Dosyalar?          : MenuCreator.py, __init__.py, menu.gif,
#                        dtml/MenuCreatorAddForm.dtml.
#------------------------------------------------------------------------
#  Tarih              :   Gn    Versiyon    Geli?tirici    De?i?iklikler
#
 
from OFS import SimpleItem
from Globals import DTMLFile

from AccessControl.Role import RoleManager
from OFS.SimpleItem import Item
from OFS.PropertyManager import PropertyManager
from OFS.FindSupport import FindSupport

import string

from Products.ZSQLMethods.SQL import SQL
 
from Products.Kuzgun.kzXMLSentence import kzXMLSentence
from Products.Kuzgun.kzString      import kzString
from Products.Kuzgun.kzSort        import kzSort

def getColumn(result,field):
    # Bir ZSQL Result objesinden istenilen kolonu bir diziye atar.
    # Geriye dizi dndrr.
    # Param: Result objesi, diziye at?lacak alan ad?.

    fieldnames = []
    i = 0
    while i<len(result):
        fieldnames.append(result[i][field])
        i = i + 1
    return fieldnames

class kzMenuCreator(PropertyManager,SimpleItem.SimpleItem):

    """
    MenuCreator sinifi.
    """

    meta_type = 'Kuzgun MenuCreator'

    _properties = (
                   {'id':'title', 'type':'string', 'mode':'w'},
                   {'id':'offset_X', 'type':'int', 'mode':'w'},
                   {'id':'offset_Y', 'type':'int', 'mode':'w'},
                   {'id':'foreColor', 'type':'string', 'mode':'r'},
                   {'id':'foreColorOn', 'type':'string', 'mode':'r'},
                   {'id':'backColor', 'type':'string', 'mode':'r'},
                   {'id':'backColorOn', 'type':'string', 'mode':'r'},
                   {'id':'fontSet', 'type':'string', 'mode':'r'},
                   )
        
    manage_options=(
        PropertyManager.manage_options
        +RoleManager.manage_options
        +Item.manage_options
        +FindSupport.manage_options
        )

    def __init__(self, id, title):
        "rne ilk de?erlerini atar"
        self.id = id
        self.title  = title
	
    def MenuMain(self, request):
        "Menu ana metodu. Grup referans tablosundan menu yarat?r."
	
        if request.has_key("targetparam"):
	    groupid = request['targetparam'] 
	    form_dict = self.kzUserManagement.getModuleObject('form')
	    error_type = form_dict["errtype"]
	    formobject = form_dict["object"]
	    if formobject:
		formobject.recordNo       = -1
		formobject.masterRecordNo = -1
		formobject.firstLoad      = 1
		formobject.groupID        = groupid
		defaultConds              = request.get('kzdefaultconds','{}')
		formobject.setDefaultConds(defaultConds)
		redirect_html = request.get('kzmenuredirect','formGen')
		request.RESPONSE.redirect(redirect_html)		
        
	
    def generate_menuScript(self,request):
	request.SESSION["Menu"] = {}
	SESSION = request.SESSION["Menu"]
	
	tmp                    = self.aq_parent.stylesheet_properties
	SESSION["foreColor"]   = tmp.mainLinkColor
	SESSION["foreColorOn"] = tmp.mainLinkColor
	SESSION["backColor"]   = tmp.mainBackground
	SESSION["backColorOn"] = tmp.mainTabBackground
	SESSION["fontSet"]     = '"%s"' % str(tmp.mainFont[4:]).replace('"',"")
	
	topID = "g0"
	try:
	    rec = self.aq_parent.RefData.getChilds_auth(topID,"group",restriction = ["activate","==","1"])
	except:
	    rec = [] 

	kzSort([rec,('order','max')])

	SESSION['scriptString'] = ""
	
	menuheads = []
	i = 0
	while i < len(rec):
	    menuheads.append(rec[i]["tagid"])
	    i = i + 1

	SESSION['menuheads'] = menuheads    
	# Her menu ba?l??? iin menu rekrsif olarak olu?turulur.
	for x in menuheads:
	    self.search(x,SESSION)
	    
	if len(menuheads):    
	    #return "\nfunction fwLoadMenus() {\nalert('fwLoadMenus');" + SESSION['scriptString'] + '\n' + 'menu_'+SESSION['menuheads'][0]+'.writeMenus(); }\n'    
	    return SESSION['scriptString'] + '\n' + 'menu_'+SESSION['menuheads'][0]+'.writeMenus(); '    
	
 
    def search(self,group,SESSION):
        """
        Men iin gerekli javascript kodunu olu?turan rekrsif fonksiyon.
        Parametre olarak bir yapraklar? veya alt gruplar? olan grup id si
        al?r ve bu grubun yapraklar? ve alt gruplar? iin kodu olu?turur.
        Tarama s?ras?nda alt grup'a rastlan?rsa fonksiyon tekrar kendini 
        a??rarak o grubun alt? iin i?lem yapmaya ba?lar.
        """

	rec    = self.aq_parent.RefData.getAttributes(group)
	childs = self.aq_parent.RefData.getChilds_auth(group,"group",restriction = ["activate","==","1"])
	kzSort([childs,('order','max')])
        s=''
	
	fontSet     = SESSION["fontSet"]
	foreColor   = SESSION["foreColor"]
	foreColorOn = SESSION["foreColorOn"]
	backColor   = SESSION["backColor"]
	backColorOn = SESSION["backColorOn"]

        s=s+'window.menu_'+group+' = new Menu("'\
        +rec["title"]\
        +'",200,20,'+ fontSet +',10,"' \
        + foreColor+ '","' + foreColorOn+ '","' \
        + backColor+ '","' + backColorOn+ '");\n'

        i = 0
        for child in childs:
            tagid = child["tagid"]
	    if child["isleaf"] == 'T':
                    
		s=s+'  menu_'+group+'.addMenuItem("'\
	       +child["title"]+'","' +tagid+'");\n'

            else:
		self.search(child["tagid"],SESSION)
		s=s+'  menu_'+group+'.addMenuItem(menu_'\
		+tagid+');\n'

            i = i + 1
        s=s+'  menu_'+group+'.hideOnMouseOut=true;\n'
        s=s+'  menu_'+group+'.childMenuIcon="kzpoint.gif";\n'
	s=s+'  menu_'+group+'.menuIcon="kzsmallfolder.gif";\n'
        SESSION['scriptString'] = SESSION['scriptString'] + "\n" + s

    def DrawMenu(self,request):
        """
        Men iin gerekli HTML kodunu olu?turur. En st seviyedeki grup
        id'lere gre men ba?l?klar?n? olu?turan d?meleri kay?kl???
        dikkate alarak yarat?r.
        """
        xml = kzXMLSentence()
	menuheads = request.SESSION['Menu']['menuheads']
	
        buttonWidth       = 200
        menuOffset        = 0
        word = kzString.kzString("","turkce")
	
	table = xml.append("table")

        for i in menuheads:
 	    rec = self.aq_parent.RefData.getAttributes(i)
 
            word.s=rec['title']
	    xml.setParent(table)
	    xml.setParent(xml.append("tr"))
	    xml.setParent(xml.append("td"))
            button = xml.append("button", {"class":"menu",
              "type":"button","style":"margin-right:5px; width:"\
              +str(buttonWidth-10), "href":"#","onMouseOut":"FW_start" \
              +"Timeout();","onMouseOver":"window.FW_showMenu(window." \
              +"menu_"+str(i)+",tempX,tempY);"}, 
              text = word.out())

            menuOffset = menuOffset + buttonWidth
	    
	request.SESSION["Menu"] = {}
	return xml.printOut()    


def manage_addProduct(self, id, title, RESPONSE=None):

    "MenuCreator'? ekle"

    if (id==""):
        RESPONSE.redirect('MenuCreatorAddForm')
            
    else:
        temp  = kzMenuCreator(id,title)		
	temp.title  = title
	self._setObject(id, temp)

    if RESPONSE!=None:
	RESPONSE.redirect('manage_workspace')

addProductForm = DTMLFile('dtml/MenuCreatorAddForm', globals())
