from Products.CMFCore.PortalFolder import PortalFolder
from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from OFS.FindSupport import FindSupport
import string


factory_type_information =  ({ 'id'             : 'Dimension',
                               'meta_type'      : 'Dimension',
                               'description'    : """\
                                objects can be embedded in Portal documents.""",
                               'icon'           : 'olap.gif',
                               'product'        : 'kzOlap',
                               'factory'        : 'addDimension',
                               'immediate_view' : 'dimension_edit_form',
                               'filter_content_types': 1,                              
                               'allowed_content_types':('Node',),
                               'actions'        :( 
                                   { 'id'            : 'view' 
                                     , 'name'          : 'View'
                                     , 'action'        : 'dimension_view'
                                     , 'permissions'   : (CMFCorePermissions.View,)
                                     , 'category'      : 'object'
                                     },
                                   { 'id'              : 'contents' 
                                     , 'name'          : 'Contents'
                                     , 'action'        : 'folder_contents'
                                     , 'permissions'   : (CMFCorePermissions.View,)
                                     , 'category'      : 'object'
                                     }
                                   , { 'id'            : 'edit'
                                       , 'name'          : 'Edit'
                                       , 'action'        : 'dimension_edit_form'
                                       , 'permissions'   : (CMFCorePermissions.ManageProperties,)
                                       , 'category'      : 'object'
                                       }
                                   )
                               }
                             ,
                             )


def addDimension(self,id,title='',description=''):    
    dimension = Dimension(id,title,description)
    self._setObject(id,dimension)
       
        
class Dimension(PortalFolder):
    "OLAP Cube dimension class"             
    meta_type = 'Dimension'
    portal_type = 'Dimension'
    content_meta_types = 'Dimension'
    manage_options = PortalFolder.manage_options
    

    def __init__(self,id,title,description):
        PortalFolder.__init__(self,id,title)
        self.description = description
        self.errors = {}
        self.field = None
        
    def index_html(self,RESPONSE):
        "return contents page"
        RESPONSE.redirect(self.absolute_url()+'/folder_contents')
        
    def setId(self):
        nameSpace = ['x','y','z']
        if not self.id in nameSpace:
            for id in nameSpace:
                try:
                    self._checkId(id)
                    #self.id = id
                    return 
                except:
                    pass
                    
            
            
    #def allowedContentTypes(self):
    #    return PortalFolder.allowedContentTypes(self)
    
    
    def edit(self,title,description,field,REQUEST=None):
        "edit title or field"
        #self.setId()        
        self.setTitle(title)
        self.setField(field)
        self.setDescription(description)
        if REQUEST is not None:
            if self.errors != {}:
                REQUEST['RESPONSE'].redirect(self.absolute_url()+'/dimension_edit_form')
            else:
                REQUEST['RESPONSE'].redirect(self.absolute_url()+'/folder_contents')
        
    def setField(self,field):
        "dfdf"
        self.validate_field(field)
        self.field = field
        #fi    
    
#----------------------------------------------------------------------#   
   
    
    def validate_field(self,field):
        try : del self.errors['field'] 
        except : pass
        for fld in self.getFields():
            if fld['id'] == field:
                return 1
            #fi
        #end for
        self.errors['field'] = 'error_message_has_no_field'
        return 0
#----------------------------------------------------------------------#   

    def type(self):
        "return field type"
        property = self.aq_inner.aq_parent.RefData.getAttributes(self.field)
        
        return property['type']

    def getSelections(self):
        "dimension hierarchy view"
        values = []        
        nodeObjects = self.objectValues('Node')
        if nodeObjects:
            values.append({'id':self.id,'title':self.title})
            for node in nodeObjects:
                values.append({'id':node.id_path(),'title':node.title_path()})
                values += node.getSelections()
            #endfor
        #fiTest
        return values
        
    def view(self):
        "return hierarchy"
        table = ''                
        objects = self.objectValues('Node')
        if objects == []:
            return ''
        for obj in objects:
            table += '<tr><td>%s</td><td>%s</td></tr>' %(obj.title,obj.view())            
        #end for        
        return '<div class="group"><table>%s</table></div>' %(table)
    
    def queries(self,path=''):
        "return query"
        if path == self.id or path == '':  # return all child nodes queries
            result = []
            for node in self.objectValues():
                result.append([node.queries()])
            #endfor       
            return result
        else: # return child queries
            
            path = string.split(path,'/')
            child = path[0]            
            path = string.join(path[1:],'/')
            #if child == self.id:
            #    result = self.queries()
            
            try:
                child = getattr(self,child)
                return child.queries(path)
            except: 
                raise AttributeError
            
    
    
    
    
InitializeClass(Dimension)        







