
__version__ = "0.1.0"

__doc__ = """ Install script to setup AnkaBT in CMF Site """

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.kzOlap import kzOlap_globals,factory_type_information



from cStringIO import StringIO
import string


def install(self):

    """Register kzOlap"""

    out = StringIO()
   
    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')
    
    if 'kzOlap' not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', kzOlap_globals)
        skins = skinstool.getSkinSelections()
        for skin in skins:
            path = skinstool.getSkinPath(skin)
            path = map(string.strip, string.split(path, ','))
            if 'kzOlap' not in path:
                try:
                    path.insert(path.index('content'), 'kzOlap')
                except ValueError:
                    path.append('kzOlap')
                path = string.join(path, ', ')
                skinstool.addSkinSelection(skin, path)
            out.write('Skin Setup Done\n')
   
    for f in factory_type_information:    
        if f['id'] in typestool.objectIds():
            out.write('*** Object "%s" already existed in the types tool => deleting\n' % (f['id']))
            typestool._delObject(f['id'])
            cfm = apply(ContentFactoryMetadata, (), f)
            typestool._setObject(f['id'], cfm)
            out.write('Type "%s" registered with the types tool\n' % (f['id']))
                    
    return out.getvalue()
