from Globals import InitializeClass   
from Products.CMFCore.PortalFolder import PortalFolder
from Products.CMFCore import CMFCorePermissions
import string
import copy

factory_type_information = ( { 'id'             : 'Node',
                               'meta_type'      : 'Node',
                               'description'    : """\
                               Olap objects can be embedded in Portal documents.""",
                               'icon'           : 'olap.gif',
                               'product'        : 'kzOlap',
                               'factory'        : 'addNode',
                               'immediate_view' : 'node_edit_form',
                               'filter_content_types': 1,                              
                               'allowed_content_types':('Node',),
                               'actions'        :( 
                                   { 'id'            : 'view' 
                                     , 'name'          : 'View'
                                     , 'action'        : 'node_view'
                                     , 'permissions'   : (CMFCorePermissions.View,)
                                     , 'category'      : 'object'
                                     },
                                   { 'id'              : 'contents' 
                                     , 'name'          : 'Node Contents'
                                     , 'action'        : 'folder_contents'
                                     , 'permissions'   : (CMFCorePermissions.View,)
                                     , 'category'      : 'object'
                                     }
                                   , { 'id'            : 'edit'
                                       , 'name'          : 'Edit'
                                       , 'action'        : 'node_edit_form'
                                       , 'permissions'   : (CMFCorePermissions.ManageProperties,)
                                       , 'category'      : 'object'
                                       }
                                   )
                               }
                             ,
                             )
#----------------------------------------------------------------------#        



def addNode(self,id,title='',description=''):
    node = Node(id,title,description)
    self._setObject(id,node)


#----------------------------------------------------------------------#        

class Node(PortalFolder):
    "level define class"
    meta_type = 'Node'
    portal_type = 'Node'
    content_meta_type = 'Node'
    manage_options = PortalFolder.manage_options
  
    def __init__(self,id,title,description):
        PortalFolder.__init__(self,id,title)
        self.description = description
        self.field_ext = None
        self.selection = None
        self.errors = {}
        
    def index_html(self,RESPONSE):
        "return content"
        RESPONSE.redirect(self.absolute_url()+'/folder_contents')
    def getQuery(self):
        "return SQL Query for require node data"
        import string
        selection = string.split(self.selection,',')
        query = 2
        
    def queries(self,path=None,queries=None):
        if path is None: # return self queries
            if self.field_ext is None or self.field_ext == 'None':
                field = self.aq_inner.aq_parent.field
                self.field_ext = None
            else:
                field = self.aq_inner.aq_parent.field + '_' + self.field_ext
            #fi
            query = {'field':field,'selections':self.selection}
            if queries is None:
                return query
            else:
                queries.append(query)
                return queries
            
        elif path == '': # return all child queries
            result = []
            if queries is None:
                queries = []
            #fi
            
            queries.append(self.queries())
            childs = self.objectValues()
            if childs:
                for child in childs:
                    cp_queries = copy.copy(queries)
                    result.append(child.queries(queries=cp_queries))
                #endfor
            else:
                result.append(queries)
            return result
        else:
            
            if queries is None:
                queries = []
            #fi
            queries.append(self.queries())
            path = string.split(path,'/')
            child = path[0]
            path = string.join(path[1:] , '/')            
            child = getattr(self,child)
            return child.queries(path,queries)
            
    
    def getSelections(self):
        "dimension hierarchy view"
        values = []              
        for node in self.objectValues('Node'):
            if node.objectValues() != []:
                values.append({'id':node.id_path(),'title':node.title_path()})                
                values += node.getSelections()
            #fi
        #endfor
        return values
    
    def id_path(self):
        path    = self.id
        context = self.aq_inner
        while context.aq_parent.meta_type != 'Olap':
            context = context.aq_parent
            path = context.id +'/'+path
        #end while
        return path
    
    def title_path(self):
        path = self.title
        context = self.aq_inner
        while context.aq_parent.meta_type != 'Olap':
            context = context.aq_parent
            path = context.title + '/' + path
        #end while
        return path
    
    def view(self):
        "return hierarchy"
        table = ''
        objects = self.objectValues('Node')
        if objects == []:
            return ''
        for obj in objects:
            table += '<tr><td>%s</td><td>%s</td></tr>' %(obj.title,obj.view())            
        #end for        
        return '<div class="group"><table>%s</table></div>' %(table)
    
    def setId(self,id):
        try: del self.errors['id']
        except: pass
        try:
            self._checkId(id)
            self.id = id
        except:
            self.errors['id'] = 'The id "%s" is reserved.' %(id)    
            
    def setTitle(self,title):
        self.validate_title(title)
        self.title = title
        
    def setField(self,field_ext):
        self.validate_field(field_ext)
        if not self.errors.has_key('field_ext'):
            self.field_ext = field_ext
        
    def setSelection(self,selection):
        self.validate_selection(selection)
        self.selection = selection
        
    def edit(self,title,description,selection,field_ext,RESPONSE=None):
        "ee"
        #self.setId(id)
        self.setTitle(title)
        self.setDescription(description)
        self.setSelection(selection)
        self.setField(field_ext)
        if RESPONSE is not None :
            if self.errors == {} :
                RESPONSE.redirect(self.absolute_url()+'/folder_contents')
            else:
                RESPONSE.redirect(self.absolute_url()+'/node_edit_form')
            #fi
        #fi
        
#----------------------------------------------------------------------# 
                       
                
    def getFields(self):
        "return sub field "
        type = self.aq_inner.type()
        if type == 'd':
            return [{'id':'0','title':'year'},
                    {'id':'2','title':'month'},
                    {'id':'3','title':'day'},
                    {'id':'1','title':'quarter'},
                    {'id':'4','title':'dayOfWeek'},
                    ]
        
        elif type == 'a':
            return [{'id':'0','title':'borough'},
                    {'id':'1','title':'Postal Code'},
                    {'id':'2','title':'City'},
                    {'id':'3','title':'Country'}
                    ]               
        else:
            return []
    def validate_title(self,title):
        self.del_err_msg('title')
        if title == '' : 
            self.errors['title'] = 'err_message_title_is_required'
            
    def validate_field(self,field_ext):
        self.del_err_msg('field_ext')
        for f in self.getFields():
            if f['id'] == field_ext:
                return
            #fi
        #endfor
        self.errors['field_ext'] = 'error_message_undefined_%s_extension' %(self.aq_inner.type)
        
    def validate_selection(self,selection):
        self.del_err_msg('selection')
        
        
    def del_err_msg(self,msg):
        try: del self.errors[msg]
        except: pass
        
    
        
InitializeClass(Node) 
