__doc__ = """Initialize OLAP into ZOPE"""

import Olap
import Dimension
import Node
from Products.CMFCore import utils,  CMFCorePermissions, DirectoryView
import sys
from Products.CMFDefault import Portal
from Products.CMFCore.DirectoryView import registerDirectory

factory_type_information = ( Olap.factory_type_information + \
                             Dimension.factory_type_information +\
                             Node.factory_type_information ) 

this_module = sys.modules[ __name__ ]

contentConstructors = (Olap.addOlap,Dimension.addDimension,Node.addNode,)
contentClasses = (Olap.Olap,Dimension.Dimension,Node.Node,)

# Make the skins available as DirectoryViews
registerDirectory('skins', globals())

kzOlap_globals=globals()      

z_bases = utils.initializeBasesPhase1(contentClasses, this_module)

def initialize(context):
    utils.initializeBasesPhase2(z_bases, context)    
    utils.ContentInit('Kuzgun Olap',
                      content_types = contentClasses,
                      permission = CMFCorePermissions.AddPortalContent,
                      extra_constructors = contentConstructors,
                      fti = factory_type_information,                      
                      ).initialize(context)
    utils.registerIcon(Olap.Olap, 'skins/olap.gif', globals())
