# -*- coding: utf-8 -*- 
from Products.CMFCore.utils             import UniqueObject
from OFS.SimpleItem                     import SimpleItem
from Globals                            import InitializeClass
from OFS.ObjectManager                  import ObjectManager
from Products.PageTemplates             import PageTemplateFile
from Products.Kuzgun.kzDate.kzDate      import kzDate
from Products.Kuzgun.kzString           import kzString
from Products.Kuzgun.kzSort             import kzSort
from Products.kzFormGenerator           import kzFields
import copy
import string

class Conditions:
	"""
	Select objelerinin verilerini i?ren snf.
	"""
	
	IntLength    = 8
	CharLength   = 10
	DateLength   = 8
	TypeArray = {
		                (1,1) : "Choices",	
				(1,2) : "equal to",
				(1,3) : "not equal to",
				(1,4) : "greater than",
				(1,5) : "greater or equal than",
				(1,6) : "less than",
				(1,7) : "less or equal than",
		                (2,1) : "Choices",
				(2,2) : "starting with",
				(2,3) : "same to",
				(2,4) : "differ to",
				(2,5) : "includes",
				(2,6) : "after than",
				(2,7) : "before than",
				(2,8) : "including and after than",
				(2,9) : "including and before than",
		                (3,1) : "Choices",  
				(3,2) : "same to",
				(3,3) : "differ to",
				(3,4) : "after than",
				(3,5) : "before than",
				(3,6) : "including and after than",
				(3,7) : "including and before than"
				}    
	


class kzQueryTool(SimpleItem):
        """Grid"""
   	id='kzQueryTool'
   	meta_type='kzQueryTool'
	plone_tool=1
	
	
	def GridMain(self,request):
		qdata = self.aq_inner.aq_parent.kzAuthSQL
		
		request.set('Types',Conditions.TypeArray)
		request.set('IntLen',Conditions.IntLength)
		request.set('CharLen',Conditions.CharLength)
		request.set('DateLen',Conditions.DateLength)
		
		sessionID= request.get('QuerySession','')
				
		if sessionID=='':
			title    = "SESSION ID CONTROL"
			subtitle = "NO SESSION ID VARIABLE"
			message  = "Hidden variable QuerySession is not found"
			self.aq_inner.aq_parent.setError(title,subtitle,message)
			return
		
		
		if not request.SESSION.has_key(sessionID):
			title    = "SESSION CONTROL"
			subtitle = "NO SESSION VARIABLE"
			message  = "Session time out"
			self.aq_inner.aq_parent.setError(title,subtitle,message)
			return
			
		if type(request.SESSION[sessionID]) != type({}):
			title    = "SESSION FORMAT CONTROL"
			subtitle = "SESSION VARIABLE HAS WRONG FORMAT"
			message  = "Bad Session kzQueryTool Format"
			self.aq_inner.aq_parent.setError(title,subtitle,message)
			return			
			
		if request.get('reset')=='1':
			
			qref  = self.getKuzgunReference()
			tableid=request.SESSION[sessionID]['tableid']				
			defaultConds = request.SESSION[sessionID].get('defaultConds',())
			Conds = request.SESSION[sessionID].get('Conditions',[])
			table_attr=qref.getAttributes(tableid)
			fields=qref.getChilds(tableid,'field')
			
			request.SESSION[sessionID]['table_attr']=table_attr
			request.SESSION[sessionID]['fields']=fields
			request.SESSION[sessionID]['masterrecno']=request.SESSION[sessionID].get('masterrecno',-1)
			request.SESSION[sessionID]['field_ids']={}										
			request.SESSION[sessionID]['mapped_fields']=self.field_mapping(fields,request)
			request.SESSION[sessionID]['Search_Way']='1'
			request.SESSION[sessionID]['Records']=[]
			request.SESSION[sessionID]['indexedFields']=[]
			request.SESSION[sessionID]['notIndexedFields']=[]
			request.SESSION[sessionID]['Conditions']=Conds
			request.SESSION[sessionID]['defaultConds']=defaultConds
			request.SESSION[sessionID]['View_Sum']=0
			request.SESSION[sessionID]['min_row'] = 0
			request.SESSION[sessionID]['min_col']=0
			request.SESSION[sessionID]['max_col']=5
			request.SESSION[sessionID]['ViewedRows'] = 0
			request.SESSION[sessionID]['totalList']={}
			request.SESSION[sessionID]['selectedPage']=1
			request.SESSION[sessionID]['recnum']=5
			request.SESSION[sessionID]['savedFields']=[]
			request.SESSION[sessionID]['defaultIndexed']=[]
			request.SESSION[sessionID]['defaultNotIndexed']=[]
			request.SESSION[sessionID]['flag']=0
			request.SESSION[sessionID]['selectedReport']=""
			request.SESSION[sessionID]['Groups']=[]
			request.SESSION[sessionID]['Tables']=[]
			
			
			for field in request.SESSION[sessionID]['mapped_fields']:				
				request.SESSION[sessionID]["field_ids"][field['tagid']]=(field['tagid'],field['type'],field['title'])								
				
			####parcalanmis alanlardan default indexlileri bul#####
				if field['indexed']=="1":
					request.SESSION[sessionID]['indexedFields'].append(field['tagid'])
					request.SESSION[sessionID]['defaultIndexed'].append(field['tagid'])
				else :
					request.SESSION[sessionID]['notIndexedFields'].append(field['tagid'])
					request.SESSION[sessionID]['defaultNotIndexed'].append(field['tagid'])

			#############recno varsa indexedFields in basina al######################
			ind=request.SESSION[sessionID]['indexedFields'].index('recno')
			if ind != 0:
				del request.SESSION[sessionID]['indexedFields'][ind]
				request.SESSION[sessionID]['indexedFields'].insert(0,'recno')
				del request.SESSION[sessionID]['defaultIndexed'][ind]
				request.SESSION[sessionID]['defaultIndexed'].insert(0,'recno')
				
				
		if not request.SESSION[sessionID].has_key('field_ids'):
                        request.set('reset','1')
                        return self.GridMain(request)

			
		###################################################################################
		
		buttonname=request.get('buttonname','')							
							
		if buttonname=='index':
			self.IndexedColumns(request)
			
		elif buttonname=='Inc_Col':
			ColNum=int(request.SESSION[sessionID]['max_col'])
			if ColNum!=len(request.SESSION[sessionID]['notIndexedFields']):
				ColNum += 1
			request.SESSION[sessionID]['max_col']=ColNum
			
		elif buttonname=='Decr_Col':
			ColNum=int(request.SESSION[sessionID]['max_col'])
			minCol=int(request.SESSION[sessionID]['min_col'])
			if ColNum != minCol+1:
				ColNum -= 1
			request.SESSION[sessionID]['max_col'] = ColNum
		elif buttonname=='Shift_R':
			max=int(request.SESSION[sessionID]['max_col'])
			min=int(request.SESSION[sessionID]['min_col'])
			ColNum=len(request.SESSION[sessionID]['notIndexedFields'])			
			
			if 2*max-min >  ColNum:
				if max!=ColNum:					
					for i in range(ColNum-max):
						tmp=request.SESSION[sessionID]['notIndexedFields'].pop()
						request.SESSION[sessionID]['notIndexedFields'].insert(0,tmp)
					max=max-min
					min=0
				else:
					max=max-min
					min=0
			else:
				tmp=max
				max=2*max-min
				min=tmp
			request.SESSION[sessionID]['max_col'] = max
			request.SESSION[sessionID]['min_col'] = min
			
					
		elif buttonname=='Shift_L':
			max=int(request.SESSION[sessionID]['max_col'])
			min=int(request.SESSION[sessionID]['min_col'])
			ColNum=len(request.SESSION[sessionID]['notIndexedFields'])
			if 2*min-max < 0:
				if min!=0:					
					for i in range(max-min):
						tmp=request.SESSION[sessionID]['notIndexedFields'].pop()
						request.SESSION[sessionID]['notIndexedFields'].insert(0,tmp)
					max=max-min
					min=0
				else:					
					min=ColNum-(max-min)
					max=ColNum
			else:
				tmp=min
				min=2*min-max
				max=tmp
			request.SESSION[sessionID]['max_col'] = max
			request.SESSION[sessionID]['min_col'] = min

		elif buttonname=='previous_page':
			page=request.SESSION[sessionID]['selectedPage']
			recnum=request.SESSION[sessionID]['recnum']
			request.SESSION[sessionID]['flag'] =0
			if page > 1:
				request.SESSION[sessionID]['selectedPage'] =page- 1
			else:
				pass
			
			
			request.SESSION[sessionID]['recnum']=recnum
			
		elif buttonname=='next_page':
			if request.SESSION[sessionID]['flag'] ==0:			
				request.SESSION[sessionID]['selectedPage'] += 1
			
		elif buttonname=='row_per_page':
			recnum=int(request.get('row_per_page','2'))			
			request.SESSION[sessionID]['recnum']=recnum
			request.SESSION[sessionID]['selectedPage']=1
		
		elif buttonname=='SearchWay':
			request.SESSION[sessionID]['Search_Way']=str(request.get('buttonvalue','1'))
			if request.SESSION[sessionID]['Search_Way']=='3':
				qref  = self.aq_inner.aq_parent.RefData
				groups=qref.getGroups('g0','T')
				request.SESSION[sessionID]['Groups']=groups
				
		elif buttonname=='Search':
			searchWay=request.SESSION[sessionID].get('Search_Way','1')
								
			if searchWay=="1" or searchWay=="4":
				self.SimpleSearch(request)
			elif searchWay=="2": 
				self.AdvancedSearch(request)
				
			elif searchWay=="3": 
				self.makeJoin(request)
				
                
                elif buttonname=='ext_search':
	                searchWay=request.SESSION[sessionID].get('Search_Way','1')
			if request['buttonvalue'] in ['Search','Ara']:
				self.ExternalSearch(request)
			else:
				pass
				

		elif buttonname.split("_")[0]=='ChangeStep':	
			ind=int(request.get('buttonvalue','-1'))
			if ind < len(request.SESSION[sessionID]['Conditions']):
				Cond=request.SESSION[sessionID]['Conditions'][ind]
				del request.SESSION[sessionID]['Conditions'][ind+1:]
			
			len_ind=len(request.SESSION[sessionID]['indexedFields'])
			len_not=len(request.SESSION[sessionID]['notIndexedFields'])
			len_D_ind=len(request.SESSION[sessionID]['defaultIndexed'])
			len_D_not=len(request.SESSION[sessionID]['defaultNotIndexed'])
			
			if len_ind != len_D_ind:
				request.SESSION[sessionID]['indexedFields']=[]
				request.SESSION[sessionID]['notIndexedFields']=[]
				for i in range(len_D_ind):
					request.SESSION[sessionID]['indexedFields'].append(request.SESSION[sessionID]['defaultIndexed'][i])
								
				request.SESSION[sessionID]['notIndexedFields']
				for i in range(len_D_not):
					request.SESSION[sessionID]['notIndexedFields'].append(request.SESSION[sessionID]['defaultNotIndexed'][i])
				request.SESSION[sessionID]['min_col']=0
				request.SESSION[sessionID]['max_col']=5	
				
		elif buttonname=='Add_Rem_Sum':
			if request.SESSION[sessionID]['View_Sum']:
				request.SESSION[sessionID]['View_Sum'] = 0
			else:
				request.SESSION[sessionID]['View_Sum'] = 1

		elif buttonname=='PDF':
			if request.SESSION[sessionID]['Records']!=[]:				
				self.printAction(request)
			else:
				return
										
				
		elif buttonname=='Openrecno':
			recno      = int(request.form['buttonvalue'])
			tempresult = self.aq_parent.kzUserManagement.getModuleObject('form')
			formobj    = tempresult["object"]
			if formobj is not None:
				Conds = request.SESSION[sessionID]['Conditions']
				formobj.openRecno(recno,Conds)
				request.SESSION[sessionID]['openform'] = 1
		
		elif buttonname=='Shift_Up':
			minrow=request.SESSION[sessionID]['min_row']
			RowCount=request.SESSION[sessionID]['ViewedRows']
			leng=len(request.SESSION[sessionID]['Records'])
			if leng==0:
				return
			if minrow-RowCount>=0:
				minrow=minrow-RowCount
			else:
				minrow=leng-(RowCount-minrow)
			
			request.SESSION[sessionID]['min_row']=minrow
		
		elif buttonname=='Shift_Down':
			minrow=request.SESSION[sessionID]['min_row']
			RowCount=request.SESSION[sessionID]['ViewedRows']
			leng=len(request.SESSION[sessionID]['Records'])
			if leng==0:
				return
			if minrow+RowCount<leng:
				minrow=minrow+RowCount
			else:
				minrow=(minrow+RowCount)%leng
			request.SESSION[sessionID]['min_row']=minrow
		
		elif buttonname=='Inc_Row':
			request.SESSION[sessionID]['recnum']+=1
			
		elif buttonname=='Dec_Row':
			row_count = request.SESSION[sessionID]['ViewedRows']
			if row_count > 1:
				request.SESSION[sessionID]['ViewedRows'] = row_count - 1
				if request.SESSION[sessionID]['recnum'] == row_count:
					request.SESSION[sessionID]['recnum']-=1
				elif request.SESSION[sessionID]['recnum'] > row_count:
					request.SESSION[sessionID]['recnum']=row_count-1
				else:
					pass
				
			
		elif buttonname=='apply_query':
			Tableid = request.SESSION[sessionID]['table_attr']['tagid']
			Reportid= request.get("report_id","")
			Reports = self.getDefinedQueries(request)
			Report  = None
			for i in range(len(Reports)):
				if int(Reportid) == Reports[i][0]:
					Report=Reports[i]

			if Report is not None:
				
				request.SESSION[sessionID]['selectedReport']=Report[1]		
				
				if len(Report[2]):
					Conds = request.SESSION[sessionID]['Conditions']
					if len(Conds):
						Cond  = Conds[len(Conds)-1]
						request.SESSION[sessionID]['Conditions'].append((Cond,'and',Report[2]))
					else:
						request.SESSION[sessionID]['Conditions'].append(Report[2])
					
				request.SESSION[sessionID]['indexedFields'] = Report[3]
				request.SESSION[sessionID]['savedFields'] = Report[4]
					
				for i in range(len(request.SESSION[sessionID]['indexedFields'])):
					if request.SESSION[sessionID]['indexedFields'][i] in request.SESSION[sessionID]['notIndexedFields']:
						hold=request.SESSION[sessionID]['notIndexedFields'].index(request.SESSION[sessionID]['indexedFields'][i])
						request.SESSION[sessionID]['notIndexedFields'].pop(hold)
							
				for i in range(len(request.SESSION[sessionID]['savedFields'])):
					if request.SESSION[sessionID]['savedFields'][i] in request.SESSION[sessionID]['notIndexedFields']:							
						
						tag=request.SESSION[sessionID]['savedFields'][i]
						ind=request.SESSION[sessionID]['notIndexedFields'].index(tag)
						request.SESSION[sessionID]['notIndexedFields'].pop(ind)
						
						
					if request.SESSION[sessionID]['savedFields'][i] in request.SESSION[sessionID]['indexedFields']:	
						hold= request.SESSION[sessionID]['indexedFields'].index(request.SESSION[sessionID]['savedFields'][i])
						request.SESSION[sessionID]['indexedFields'].pop(hold)	
				
				leng=len(request.SESSION[sessionID]['savedFields'])
				for i in range(leng):
					request.SESSION[sessionID]['notIndexedFields'].insert(0,request.SESSION[sessionID]['savedFields'][leng-i-1])
				
				request.SESSION[sessionID]['min_col']=0  
				request.SESSION[sessionID]['max_col']=leng
					
					
		elif buttonname=='add_query':
			name = request.get("_prompt_",'')
			request.SESSION[sessionID]['selectedReport']=name
			if len(name):
				Conds = request.SESSION[sessionID]['Conditions']
				indexedFields = request.SESSION[sessionID]['indexedFields']
				notIndexedFields = request.SESSION[sessionID]['notIndexedFields']
				if len(Conds):
					Cond    = Conds[len(Conds)-1]
				else:
					Cond    = ()

				Tableid = request.SESSION[sessionID]['table_attr']['tagid']
				self.add_report(Tableid,name,Cond,indexedFields,notIndexedFields,request)
		
		elif buttonname=='save_query':
			name = request.get("_prompt_",'')
			request.SESSION[sessionID]['selectedReport']=name
			if len(name):
				Reportid= request.get("report_id","")
				if len(Reportid):
					Conds = request.SESSION[sessionID]['Conditions']
					indexedFields = request.SESSION[sessionID]['indexedFields']
					minCol=int(request.SESSION[sessionID]['min_col'])
					maxCol=int(request.SESSION[sessionID]['max_col'])
		
					savingFields=copy.deepcopy(request.SESSION[sessionID]['notIndexedFields'][minCol:maxCol])
							
					if len(Conds):
						Cond  = Conds[len(Conds)-1]
					else:
						Cond  = ()

					Tableid = request.SESSION[sessionID]['table_attr']['tagid']
					self.save_report(Tableid,Reportid,name,Cond,indexedFields,savingFields)
				
				
		
		elif buttonname=='delete_query':
			Tableid = request.SESSION[sessionID]['table_attr']['tagid']
			Reportid= request.get("report_id","")
			self.delete_report(Tableid,Reportid)
				
		elif buttonname=="drop_field":
			field=request.get('drop_field','0')
			maxCol=request.SESSION[sessionID]['max_col']
			
			ind=request.SESSION[sessionID]['notIndexedFields'].index(field)
			request.SESSION[sessionID]['notIndexedFields'].pop(ind)
			request.SESSION[sessionID]['notIndexedFields'].append(field)
			request.SESSION[sessionID]['max_col']=maxCol-1
			
			
		
		elif buttonname=="add_field":
			field=request.get('add_field','0')
			maxCol=request.SESSION[sessionID]['max_col']
				
			ind=request.SESSION[sessionID]['notIndexedFields'].index(field)
			request.SESSION[sessionID]['notIndexedFields'].pop(ind)
			request.SESSION[sessionID]['notIndexedFields'].insert(maxCol,field)
			request.SESSION[sessionID]['max_col']=maxCol+1

		elif buttonname=='selectedGroup':	
			qref  = self.aq_inner.aq_parent.RefData
			group=request.get('selectedGroup','')			
			if group != '':
				request.set('selectedGroup',group)
				tablesOfgr=qref.getChilds(group,'table')
				for i in range(len(tablesOfgr)):
					request.SESSION[sessionID]['Tables'].append((tablesOfgr[0]['tagid'],tablesOfgr[0]['title']))
				
		
		###################################################################################
		########## - sorgulama yap - ####################################################
		if request.SESSION.has_key(sessionID):        
			tableid = request.SESSION[sessionID]['tableid']
			fields  = request.SESSION[sessionID]['field_ids'].keys()
			orderby = string.join(request.SESSION[sessionID]['indexedFields'],',')
			leng = len(request.SESSION[sessionID]['Conditions'])
			if leng:
				cond = request.SESSION[sessionID]['Conditions'][leng-1]
			else:
				cond = ()
				
			if request.SESSION[sessionID]['masterrecno_flag']==1:						
				if request.SESSION[sessionID]['table_attr']['type']=='m':
					request.SESSION[sessionID]['masterrecno_flag']=0
				else:
					if len(cond):
						cond = (cond,'and',('masterrecno',request.SESSION[sessionID]['masterrecno']))
					else:
						cond = ('masterrecno',request.SESSION[sessionID]['masterrecno'])
			
			page=request.SESSION[sessionID]['selectedPage']
			recnum=request.SESSION[sessionID]['recnum']
			
			defaultconds = request.SESSION[sessionID]['defaultConds']
			if defaultconds:
				if cond:
					cond = (cond,'and',defaultconds)
				else:
					cond = defaultconds

			request.SESSION[sessionID]['Records'] = qdata.sqlselectrecords(tableid,fields,cond,orderby,offset=(page-1)*(recnum),limit=recnum)
			
			len_records = len(request.SESSION[sessionID]['Records'])

			if len_records==0 and request.SESSION[sessionID]['recnum'] >1 and request.SESSION[sessionID]['flag'] ==0:
				request.SESSION[sessionID]['flag']=1
				
			
			
				
			if len_records <= request.SESSION[sessionID]['ViewedRows']:
				request.SESSION[sessionID]['ViewedRows']=len_records
			elif len_records <= request.SESSION[sessionID]['recnum']:
				request.SESSION[sessionID]['ViewedRows']=len_records
			elif len_records > request.SESSION[sessionID]['recnum']:
				request.SESSION[sessionID]['ViewedRows']=request.SESSION[sessionID]['recnum']
			else:
				request.SESSION[sessionID]['ViewedRows']=0

		else:
			title    = "SESSION CONTROL"
			subtitle = "NO SESSION VARIABLE"
			message  = "Session time out"
			self.aq_inner.aq_parent.setError(title,subtitle,message)
			return
		
		
		
		
		if request.has_key("reset"):
			#######################################
			#####default sayfalama#################			
			request.SESSION[sessionID]['recnum']=5
			leng=len(request.SESSION[sessionID]['Records'])												
			
			
			if request.SESSION[sessionID]['max_col'] > len(request.SESSION[sessionID]['notIndexedFields']):
				request.SESSION[sessionID]['max_col'] = len(request.SESSION[sessionID]['notIndexedFields'])
			
			if leng <= request.SESSION[sessionID]['recnum']:
				request.SESSION[sessionID]['ViewedRows']=leng
				request.SESSION[sessionID]['pagecount']=1
			else:
				pgCount=leng/request.SESSION[sessionID]['recnum']
				if leng % request.SESSION[sessionID]['recnum']==0:					
					request.SESSION[sessionID]['pagecount']=pgCount
				else:
					request.SESSION[sessionID]['pagecount']=pgCount+1
					
				request.SESSION[sessionID]['ViewedRows']=request.SESSION[sessionID]['recnum']
			request.SESSION[sessionID]['min_row']=0
			
			
		
		###################################################################################
		##########-integer alanlarin toplam degerlerini hesapla-###########################
		if request.SESSION[sessionID]['View_Sum']:
			min_row=request.SESSION[sessionID]['min_row']
			Row_Count=request.SESSION[sessionID]['ViewedRows']
			Columns=request.SESSION[sessionID]['indexedFields']+request.SESSION[sessionID]['notIndexedFields']
			request.SESSION[sessionID]['totalList']={}
			leng=len(request.SESSION[sessionID]['Records'])
			Records = request.SESSION[sessionID]['Records']
			if request.SESSION[sessionID]['Records']!=[]:						
				for j in range(len(Columns)):
					total=0
					if request.SESSION[sessionID]['field_ids'][Columns[j]][1] in ('i','m'):				         
						for i in range(min_row,min_row+Row_Count):
							x = Records[i%leng][Columns[j]]
							try:
								x = float(x)
							except:
								x = 0
								request.SESSION[sessionID]['totalList'][Columns[j]]=''
							total += x
						request.SESSION[sessionID]['totalList'][Columns[j]]=total	
					else:
						request.SESSION[sessionID]['totalList'][Columns[j]]=''
						
					
					
		request.SESSION[sessionID] =  request.SESSION[sessionID]		
																						
		
###################################################################
###################################################################
	def field_mapping(self,unmapped_fields,request):
		sessionID = request["QuerySession"]
		cols=[]
		
		for field in unmapped_fields:	
			word = kzString.kzString(field['title'])
			field['title'] = word.out()
			
			if field["type"]=="a":
				for j in range(len(kzFields.mapping[field["type"]])):
					tmp=copy.deepcopy(field)
					tmp["tagid"]=tmp["tagid"]+kzFields.mapping[field["type"]][j]
					tmp["title"]=tmp["title"]+"("+kzFields.address_parts[j][0]+")"
					tmp["length"]=kzFields.address_parts[j][1]
					if kzFields.data_types['a'][j]=='numeric':
						tmp['type']='i'
					else:
						tmp['type']='s'					
					cols.append(tmp)
			elif field["type"]=="t":
				for j in range(len(kzFields.mapping[field["type"]])):
					tmp=copy.deepcopy(field)
					tmp["tagid"]=tmp["tagid"]+kzFields.mapping[field["type"]][j]
					tmp["title"]=tmp["title"]+"("+kzFields.telephone_parts[j][0]+")"
					tmp["length"]=kzFields.telephone_parts[j][1]
					if kzFields.data_types['t'][j]=='numeric':
						tmp['type']='i'
					else:
						tmp['type']='s'
					cols.append(tmp)
			
			
			elif field["type"] == "d" or \
	                     field["type"] == "i" or \
	                     field["type"] == "m" or \
	                     field["type"] == "p":
				for j in range(len(kzFields.mapping[field["type"]])):
					tmp=copy.deepcopy(field)
					tmp["tagid"]=tmp["tagid"]+kzFields.mapping[field["type"]][j]
					if field["type"]=="m":
						tmp["title"]=tmp["title"]+"("+kzFields.money_parts[j][0]+")"
						if kzFields.data_types['m'][j]=='numeric':
							tmp['type']='i'
						else:
							tmp['type']='s'
					elif field["type"]=="i":
						tmp["title"]=tmp["title"]+"("+kzFields.integer_parts[j][0]+")"
						if kzFields.data_types['i'][j]=='numeric':
							tmp['type']='i'
						else:
							tmp['type']='s'
					elif field["type"]=="d":
						tmp["title"]=tmp["title"]+"("+kzFields.date_parts[j][0]+")"
						if kzFields.data_types['d'][j]=='numeric':
							tmp['type']='i'
						else:
							tmp['type']='s'
					elif field["type"]=="p":
						tmp["title"]=tmp["title"]+"("+kzFields.picture_parts[j][0]+")"
						if kzFields.data_types['p'][j]=='numeric':
							tmp['type']='i'
						else:
							tmp['type']='s'
						
					cols.append(tmp)
				
			else:
				tmp = copy.deepcopy(field)
				cols.append(tmp)
			
		if request.SESSION[sessionID]['table_attr']['type']=='m':
			tmp=[{"tagid":"recno","title":"Recno","type":"integer","indexed":"1"},{"tagid":"lastuser","title":"LastUser","type":"string","indexed":"0"},
			     {"tagid":"date","title":"Date","type":"string","indexed":"0"},{"tagid":"owner_name","title":"Owner","type":"string","indexed":"0"},
			     {"tagid":"state","title":"State","type":"string","indexed":"0"},{"tagid":"authority","title":"Auth","type":"integer","indexed":"0"}]
			for field in tmp:
				cols.append(field)
		elif request.SESSION[sessionID]['table_attr']['type']=='d':
			tmp=[{"tagid":"recno","title":"Recno","type":"integer","indexed":"1"},{"tagid":"lastuser","title":"LastUser","type":"string","indexed":"0"},
			     {"tagid":"date","title":"Date","type":"string","indexed":"0"},{"tagid":"owner_name","title":"Owner","type":"string","indexed":"0"},
			     {"tagid":"state","title":"State","type":"string","indexed":"0"},{"tagid":"authority","title":"Auth","type":"integer","indexed":"0"},
			     {"tagid":"caption","title":"Caption","type":"integer","indexed":"0"}]
			
			if request.SESSION[sessionID]['masterrecno_flag']==0:
				tmp.append({"tagid":"masterrecno","title":"MasterRecno","type":"integer","indexed":"0"})			
				
			for field in tmp:
				cols.append(field)
		else:
			tmp=[{"tagid":"recno","title":"Recno","type":"integer","indexed":"1"},{"tagid":"lastuser","title":"LastUser","type":"string","indexed":"0"},
			     {"tagid":"date","title":"Date","type":"string","indexed":"0"},{"tagid":"owner_name","title":"Owner","type":"string","indexed":"0"},
			     {"tagid":"state","title":"State","type":"string","indexed":"0"},{"tagid":"authority","title":"Auth","type":"integer","indexed":"0"}]
			
			if request.SESSION[sessionID]['masterrecno_flag']==0:
				tmp.append({"tagid":"masterrecno","title":"MasterRecno","type":"integer","indexed":"1"})
			for field in tmp:
				cols.append(field)
				
		return cols

###########################################################################
###########################################################################
	def IndexedColumns(self,request):
		sessionID = request["QuerySession"]		
		chosedIndexs=request.get('chosed_col',[])
		max = int(request.SESSION[sessionID]['max_col'])
		min = int(request.SESSION[sessionID]['min_col'])
		leng=len(request.SESSION[sessionID]['indexedFields'])+max-min
		if chosedIndexs != []: 
								
			if type(chosedIndexs) != type([]):
				tmp=[]
				tmp.append(chosedIndexs)
				chosedIndexs=copy.deepcopy(tmp)
			request.SESSION[sessionID]['notIndexedFields']=request.SESSION[sessionID]['notIndexedFields']+request.SESSION[sessionID]['indexedFields']
			request.SESSION[sessionID]['indexedFields']=[]
			for i in range(len(chosedIndexs)):
				request.SESSION[sessionID]['indexedFields'].append(request.SESSION[sessionID]['field_ids'][chosedIndexs[i]][0])
				request.SESSION[sessionID]['notIndexedFields'].remove(request.SESSION[sessionID]['field_ids'][chosedIndexs[i]][0])
		
		
		request.SESSION[sessionID]['max_col'] = leng-len(request.SESSION[sessionID]['indexedFields'])
		request.SESSION[sessionID]['min_col'] = 0
		
############################################################################
############################################################################
        def ExternalSearch(self,request):
		sessionID = request["QuerySession"]
		
		indexedCols=request.SESSION[sessionID]['indexedFields']
                for i in ['lastuser','owner_name','state','date','authority']:
			if i in request.SESSION[sessionID]['notIndexedFields']:
                                request.SESSION[sessionID]['notIndexedFields'].remove(i) 
 
			
		if request.SESSION[sessionID].has_key('ext_fields')==1:
			Cols=request.SESSION[sessionID]['ext_fields']
			value=request.SESSION[sessionID]['ext_values']
			if request.SESSION[sessionID].has_key('ext_retfields')==1:
				
				if type(request.SESSION[sessionID]['ext_retfields'])==type('str'):
					temp=request.SESSION[sessionID]['ext_retfields']
					request.SESSION[sessionID]['ext_retfields']=[]
					request.SESSION[sessionID].set('ext_fields',eval(temp))
					
				request.SESSION[sessionID]['indexedFields']=[]
				request.SESSION[sessionID]['indexedFields'].append(request.SESSION[sessionID]['ext_retfields'][0])
                                
                                for item in request.SESSION[sessionID]['indexedFields']:
                                    if item in request.SESSION[sessionID]['notIndexedFields']:
                                       request.SESSION[sessionID]['notIndexedFields'].remove(item)
                
                                request.SESSION[sessionID]['max_col']=len(request.SESSION[sessionID]['ext_retfields'][1:])

				if request.SESSION[sessionID]['ext_retfields']==[None] or request.SESSION[sessionID]['ext_retfields']==[""]:
					pass
				else:
			                for item in request.SESSION[sessionID]['ext_retfields'][1:]:
                                            if item in request.SESSION[sessionID]['notIndexedFields']:
                                               request.SESSION[sessionID]['notIndexedFields'].remove(item)
                                               request.SESSION[sessionID]['notIndexedFields'].insert(0,item)
                                                 		
					#request.SESSION[sessionID]['notIndexedFields']=request.SESSION[sessionID]['ext_retfields'][1:]
				
		else:
			return
			
			
		Search_Dic={}
	
		if value=='':
			return
			
		
		if request.SESSION[sessionID].has_key('ext_fields')==1 and type(value)==list:
			for i in range(len(Cols)):
				if Cols[i]=='recno':
					try:
						Search_Dic[Cols[i]]=int(value[i])
					except:
						pass
				elif Cols[i]=='masterrecno':
					try:
						Search_Dic[Cols[i]]=int(value[i])
					except:
						pass
				elif Cols[i]=='authority':
					try:
						Search_Dic[Cols[i]]=int(value[i])
					except:
						pass
				else:
					Search_Dic[Cols[i]]=value[i]
	
		
		if Search_Dic !={}:
			Cond=[]
                       
			for key in Search_Dic.keys():
				if request.SESSION[sessionID]['field_ids'][key][1] in ('i','m','l','t','integer'):
					try:
						float(Search_Dic[key])
						value_numeric=float(Search_Dic[key])
					except:
						value_numeric=None
					
					if value_numeric is None:
						tmp = value_numeric
					elif Search_Dic[key]=='':
						tmp=None
					elif type(value_numeric)==type(1.0):
						tmp=(key,value_numeric)
					else:	
						tmp=(key,Search_Dic[key])

				elif request.SESSION[sessionID]['field_ids'][key][1] in ('a','p','s','d','w','v','e','string'):
					if Search_Dic[key]!='':					
						tmp=(key,"like","%s" % (Search_Dic[key]))						
					else:
						tmp=None
					
				if tmp is not None:
					if(len(Cond)):
						Cond=(Cond,'and',tmp)
					else:
						Cond=tmp
						
			
			
			#########Yeni Sorgulama Sartlarini SESSION a ekle#####
			if Cond!=[]:
                               
				if request.SESSION[sessionID]['Conditions']!=[]:	
					length = len(request.SESSION[sessionID]['Conditions'])
					temp=request.SESSION[sessionID]['Conditions'][length-1]
					request.SESSION[sessionID]['Conditions'].append((temp,'and',Cond))	
				else:
				
					request.SESSION[sessionID]['Conditions'].append(Cond)
		

############################################################################
############################################################################

        def SimpleSearch(self,request):
		sessionID = request["QuerySession"]
		
		min=int(request.SESSION[sessionID]['min_col'])
		max=int(request.SESSION[sessionID]['max_col'])
	
		indexedCols=request.SESSION[sessionID]['indexedFields']
		otherCols=request.SESSION[sessionID]['notIndexedFields'][min:max]
			
		Cols=indexedCols+otherCols
		value=request.get('search_value','')		
		
			
			
		Search_Dic={}
	
		if value=='':
			return
		
		try:
			float(value)
			value_numeric = value
		except:
			value_numeric = None
			
		for i in range(len(Cols)):
			if Cols[i]=='recno':
				try:
					Search_Dic[Cols[i]]=int(value)
				except:
					pass
			elif Cols[i]=='masterrecno':
				try:
					Search_Dic[Cols[i]]=int(value)
				except:
					pass
			elif Cols[i]=='authority':
				try:
					Search_Dic[Cols[i]]=int(value)
				except:
					pass
			else:
				Search_Dic[Cols[i]]=value

		if Search_Dic !={}:
			Cond=[]
			for key in Search_Dic.keys():
				if request.SESSION[sessionID]['field_ids'][key][1] in ('i','m','l','t','integer'):
					if value_numeric is None:
						tmp = value_numeric
					else:	
						tmp=(key,Search_Dic[key])
				elif request.SESSION[sessionID]['field_ids'][key][1] in ('a','p','s','d','w','v','e','string'):
					
					tmp=(key,"like","%s%s%s" % (chr(37),Search_Dic[key],chr(37)))
				
				
				if tmp is not None:
					if(len(Cond)):	
						Cond=(Cond,'or',tmp)
					else:
						Cond=tmp
						
			
			
			#########Yeni Sorgulama Sartlarini SESSION a ekle#####
			if Cond!=[]:
				if request.SESSION[sessionID]['Conditions']!=[]:	
					length = len(request.SESSION[sessionID]['Conditions'])
					temp=request.SESSION[sessionID]['Conditions'][length-1]
					request.SESSION[sessionID]['Conditions'].append((temp,'and',Cond))	
				else:
				
					request.SESSION[sessionID]['Conditions'].append(Cond)
										
		
	
		
	
############################################################################
        def AdvancedSearch(self,request):
		sessionID = request["QuerySession"]
		Search_Dic={}
		Search_operators=request.get('operator',[()])
		for i in range(len(Search_operators)):
			Search_operators[i]=(int(tuple(Search_operators[i])[1]),int(tuple(Search_operators[i])[4]))

		Search_values=request.get('chosed_value',[])
		min=int(request.SESSION[sessionID]['min_col'])
		max=int(request.SESSION[sessionID]['max_col'])		
		Cols=request.SESSION[sessionID]['notIndexedFields'][min:max]
		x=0
		for j in range(len(Search_values)):
			if Search_values[j] != '':
				x=1
				break
		if x != 1:
			return
	
		else:
			if type(Search_operators) != type([]):
				Search_operators=[Search_operators]
			if type(Search_values) != type([]):
				Search_values=[Search_values]
			if type(Cols) != type([]):
				Cols=[Cols]
		
			for i in range(len(request.SESSION[sessionID]['indexedFields'])+len(Cols)):
				if i < len(request.SESSION[sessionID]['indexedFields']):
					if Conditions.TypeArray[Search_operators[i]]=='Choises':
						continue
					else:
						Search_Dic[request.SESSION[sessionID]['indexedFields'][i]]=[Search_values[i],Conditions.TypeArray[Search_operators[i]]]
				else:
					if Conditions.TypeArray[Search_operators[i]]=='Choises':
						continue
					else:						
						Search_Dic[Cols[i-len(request.SESSION[sessionID]['indexedFields'])]]=[Search_values[i],Conditions.TypeArray[Search_operators[i]]]
	
			if Search_Dic.has_key('recno'):				
				try:
					a=int(Search_Dic['recno'][0])
					Search_Dic['recno'].insert(0,a)
					del Search_Dic['recno'][1]
				except:
					del Search_Dic['recno']
			if Search_Dic.has_key('masterrecno'):				
				try:
					a=int(Search_Dic['masterrecno'][0])
					Search_Dic['masterrecno'].insert(0,a)
					del Search_Dic['masterrecno'][1]
				except:
					del Search_Dic['masterrecno']
				
			if Search_Dic.has_key('authority'):				
				try:
					a=int(Search_Dic['authority'][0])
					Search_Dic['authority'].insert(0,a)
					del Search_Dic['authority'][1]
				except:
					del Search_Dic['authority']
		

			#SQL Cumlelerini olustur
		
			if Search_Dic != {}:
				Cond=[]
				for key in Search_Dic.keys():										
			
					if request.SESSION[sessionID]['field_ids'][key][1] in ('i','m','l','t','integer'):
						if Search_Dic[key][1]=='Choices':
							tmp=()
						elif Search_Dic[key][1]=='equal to':
							tmp=(key,Search_Dic[key][0])
						elif Search_Dic[key][1]=='not equal to':
							tmp=(key,'!=',Search_Dic[key][0])
						elif Search_Dic[key][1]=='greater than':
							tmp=(key,'>',Search_Dic[key][0])
						elif Search_Dic[key][1]=='greater or equal than':
							tmp=(key,'>=',Search_Dic[key][0])
						elif Search_Dic[key][1]=='less than':
							tmp=(key,'<',Search_Dic[key][0])
						elif Search_Dic[key][1]=='less or than':
							tmp=(key,'<=',Search_Dic[key][0])
				
					elif request.SESSION[sessionID]['field_ids'][key][1] in ('a','p','s','w','v','e','string'):
						if Search_Dic[key][1]=='Choices':
							tmp=()
						elif Search_Dic[key][1]=='starting with':
							tmp=(key,"like","%s" % Search_Dic[key][0]+"%s" % chr(37) )
						elif Search_Dic[key][1]=='same to':
							tmp=(key,"=","%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='differ to':
							tmp=(key,'!=',"%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='includes':
							tmp=(key,'like',"%s" % chr(37)+"%s" % Search_Dic[key][0]+"%s" % chr(37))
						elif Search_Dic[key][1]=='after than':
							tmp=(key,'>',"%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='before than':
							tmp=(key,'<',"%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='including and after than':
							tmp=(key,'>=',"%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='including and before than':
							tmp=(key,'<=',"%s" % Search_Dic[key][0])
			
					elif request.SESSION[sessionID]['field_ids'][key][1]=='d':
						if Search_Dic[key][1]=='Choices':
							tmp=()
						elif Search_Dic[key][1]=='same to':
							tmp=(key,"=","%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='differ to':
							tmp=(key,'!=',"%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='includes':
							tmp=(key,'like',"%s" % chr(37)+"%s" % Search_Dic[key][0]+"%s" % chr(37))
						elif Search_Dic[key][1]=='after than':
							tmp=(key,'>',"%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='before than':
							tmp=(key,'<',"%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='including and after than':
							tmp=(key,'>=',"%s" % Search_Dic[key][0])
						elif Search_Dic[key][1]=='including and before than':
							tmp=(key,'<=',"%s" % Search_Dic[key][0])
					if tmp !=():		
						if len(Cond):
							Cond=(Cond,'and',tmp)
						else :
							Cond=tmp
																				
			        if Cond !=[]:
					
					if request.SESSION[sessionID]['Conditions']!=[]:	
						length = len(request.SESSION[sessionID]['Conditions'])
						temp=request.SESSION[sessionID]['Conditions'][length-1]
						request.SESSION[sessionID]['Conditions'].append((temp,'and',Cond))	
						
					else:
						request.SESSION[sessionID]['Conditions'].append(Cond)
					############
					############
					
	def SeeQuerySteps(self,request)	:
		sessionID = request["QuerySession"]
		ln=len(request.SESSION[sessionID]['Conditions'])
		lastCond=[]
		for i in range(ln):
			if i==0:
				lastCond.append(request.SESSION[sessionID]['Conditions'][i])
			else:
				lastCond.append(request.SESSION[sessionID]['Conditions'][i][2])
				
		if len(lastCond)==1 and lastCond[0][1] in ('and','or'):
			tmp=[]
			tmp.append(lastCond[0][0])
			tmp.append(lastCond[0][2])
			lastCond=[]
			lastCond.append(tmp[0])
			lastCond.append(tmp[1])
		
			
		translate=[]		
		for i in range(len(lastCond)):
			if type(lastCond[i][0])==type(''):
				try: title=request.SESSION[sessionID]['field_ids'][lastCond[i][0]][2]
				except: title=lastCond[i][0]
				if len(lastCond[i])<3 :								
					val=lastCond[i][1]
					opr='='
				elif lastCond[i][1]=='like':
					val=lastCond[i][2]
					opr='='
				else:
					val=lastCond[i][2]
					opr=lastCond[i][1]
				if type(val)!=type(''):
					val=str(val)
				translate.append((title+' '+opr+' '+val))
			else:
				temp=[]
				cond=lastCond[i]
				x=0
				while cond[1] in ('or','and'):
					
					tmp=cond[2]
					title=request.SESSION[sessionID]['field_ids'][tmp[0]][2]
					if len(tmp)<3 :
						val=tmp[1]
						opr='='
					elif tmp[1]=='like':
						val=tmp[2]
						opr='='
					else:
						val=tmp[2]
						opr=tmp[1]
					if type(val)!=type(''):
						val=str(val)
					if cond[1]=='or':
						x=1
						cond=cond[0]
						continue
					
					else:
						temp.append(title+' '+opr+' '+val+' ' +cond[1])					
						cond=cond[0]
					
				title=request.SESSION[sessionID]['field_ids'][cond[0]][2]
				if len(cond)<3 :								
					val=cond[1]
					opr='='
				elif cond[1]=='like':
					val=cond[2]
					opr='='
				else:
					val=cond[2]
					opr=cond[1]
				if type(val)!=type(''):
					val=str(val)
				if x==1:
					temp.append(('value='+val))
				else:
					temp.append((title+' '+opr+' '+val))
					
				translate.append(temp)
					
		return translate

	#################################################################################
	#################################################################################

	def makeJoin(self,request):
		sessionID = request["QuerySession"]
		tableid   =request.SESSION[sessionID]['table_attr']['tagid']
		chosedCols=request.get('chosed_col',[])
		indexedFields=request.SESSION[sessionID]['indexedFields']
		
		
		
		pass
		
																	
	##################################################################################
	##################################################################################
        def getPDF(self,request):
                """
                Grntlenen grid'den pdf uretir.
                """
		from cStringIO import StringIO
                from Products.Kuzgun import kzPDF
		from OFS.Image import File
                from reportlab.platypus import SimpleDocTemplate
                from DateTime import DateTime
                import tempfile            
		import os
                                                                                                                                 
                sessionID = request["QuerySession"]
                                                                                                                                                             
		pdfFile = StringIO()
		#tmpfile = tempfile.mktemp()
		#pdfFile = open(tmpfile,"w+b")

                StringType = type('string')                                                                                                                                                                                                                                                                                                                
                viewedHeads=copy.deepcopy(request.SESSION[sessionID]['indexedFields'])
                init_row=request.SESSION[sessionID]['min_row']
                rowcount=request.SESSION[sessionID]['ViewedRows']
                minCol=int(request.SESSION[sessionID]['min_col'])
                maxCol=int(request.SESSION[sessionID]['max_col'])
                                                                                                                                                             
                viewedHeads+=copy.deepcopy(request.SESSION[sessionID]['notIndexedFields'][minCol:maxCol])
                                                                                                                                                             
                head=[]
                for i in range(len(viewedHeads)):
                        head.append(request.SESSION[sessionID]["field_ids"][viewedHeads[i]][2])
                                                                                                                                                             
                leng=len(request.SESSION[sessionID]['Records'])
                rows=[]
                for row in range(init_row,init_row+rowcount):
                        data=''
                        index=[]
                        for tagid in viewedHeads:
                                data=request.SESSION[sessionID]['Records'][row%leng][tagid]
                                if data != '' and data != None:
                                        index.append(data)
                                else:
                                        index.append('-')
                        rows.append(index)
                                                                                                                                                             
                doc = SimpleDocTemplate(pdfFile)
		lst = []
                t ,sum = kzPDF.createTable(head,rows)
                lst.append(t)
                if sum > 590 : #sayfayi cevir
                        doc.pagesize = (doc.height,doc.width)
                #fi
                doc.build(lst)
		#pdfFile.close()
                #pdfFile = open(tmpfile,'r+b')
		#pdf = pdfFile.read()
		#pdfFile.close()
		pdf = File(id='print.pdf',title="Grid Auto Generate",file=pdfFile,content_type="application/pdf")
		#os.remove(tmpfile)
		return pdf



	def printAction(self,request):
		"""
		Grntlenen grid'den pdf uretir.
		"""		
		from cStringIO import StringIO
		from reportlab.platypus import SimpleDocTemplate
		from DateTime import DateTime
		import os
		
		sessionID = request["QuerySession"]
		
		#oluturulacak PDF in yolu ve adi
		fileName = 'grid%s.pdf' %(str(float(DateTime())).replace('.','_'))		
		pdfFile = StringIO()
		#tmpFolder        = os.path.join('/','tmp',fileName)
		StringType = type('string')	
				
		
		viewedHeads=copy.deepcopy(request.SESSION[sessionID]['indexedFields'])
		init_row=request.SESSION[sessionID]['min_row']
		rowcount=request.SESSION[sessionID]['ViewedRows']
		minCol=int(request.SESSION[sessionID]['min_col'])
		maxCol=int(request.SESSION[sessionID]['max_col'])
		
		viewedHeads+=copy.deepcopy(request.SESSION[sessionID]['notIndexedFields'][minCol:maxCol])
			
		head=[]
		for i in range(len(viewedHeads)):
			head.append(request.SESSION[sessionID]["field_ids"][viewedHeads[i]][2])
		
		leng=len(request.SESSION[sessionID]['Records'])
		rows=[]
		for row in range(init_row,init_row+rowcount):
			data=''  
			index=[]
			for tagid in viewedHeads:
				data=request.SESSION[sessionID]['Records'][row%leng][tagid]
				if data != '' and data != None:
					index.append(data)
				else:
					index.append('-')
			rows.append(index)
		
		doc = SimpleDocTemplate(pdfFile)		
		lst = []
		from Products.Kuzgun import kzPDF
		t ,sum = kzPDF.createTable(head,rows)
		lst.append(t)
		if sum > 590 : #sayfayi cevir
			doc.pagesize = (doc.height,doc.width)
		#fi			
		doc.build(lst)
		#pdfFile = open(fileName,'rb')#tmpFolder)	
		self.aq_parent.temp_folder.manage_addFile(id=fileName,title='grid auto generate',file=pdfFile)
		request.set('PDF', fileName)
		request.set('PDF_flag', 1)		
		
		
		
		
	def GetColor(styleFile,className,attr):
		color1 = GetFromFile(styleFile,className,attr)
		red = color1[0:2]
		green = color1[2:4]
		blue = color1[4:6]
		red = float("0x"+red)/255
		green = float("0x"+green)/255
		blue = float("0x"+blue)/255
		return (red,green,blue)
	
	def resetpdf_flag(self,request):
		sessionID = request["QuerySession"]
		request.SESSION[sessionID]["/usr/lib/kuzgun/lib/python/App/RefreshFuncs.py",'PDF_flag'] = 0	
		
	def getMemberData(self):
		username = self.aq_parent.portal_membership.getAuthenticatedMember()
		Members  = getattr(self.aq_parent,'Members')
		userfolder = getattr(Members,str(username))
		objects = userfolder.objectIds()
		if not 'kzMemberData' in objects:
			userfolder.manage_addProduct['kzMemberData'].manage_addkzMemberData('kzMemberData','')
		return getattr(userfolder,'kzMemberData')
		
	
	def createQueryTable(self):
		qdata = self.aq_inner.aq_parent.kzAuthSQL
		sqlobj = qdata.getsqlobject()
		fields = [{'name':'id'        ,'type':'auto'},
			  {'name':'username'  ,'type':'varchar(30)'},
			  {'name':'tableid'   ,'type':'varchar(50)'},
			  {'name':'name'      ,'type':'varchar(30)'},
			  {'name':'cond'      ,'type':'text'},
			  {'name':'indexed'   ,'type':'text'},
			  {'name':'viewed'    ,'type':'text'}]
		sqlobj.create_table("querytool",fields)
		qdata.results_qpref(sqlobj)
		
	def getUserName(self):
		return str(self.aq_inner.aq_parent.portal_membership.getAuthenticatedMember())
		
	def getDefinedQueries(self,request):
		sessionID = request["QuerySession"]
		tableid = request.SESSION[sessionID]['table_attr']['tagid']
		username = self.getUserName()
		cond = (("tableid",tableid),"and",("username",username))
		qdata = self.aq_inner.aq_parent.kzAuthSQL
		sqlobj = qdata.getsqlobject()
		sqlobj.selectrecords("querytool",["*"],cond=cond,auth=0)
		try:			
			rec = qdata.results_qpref(sqlobj)
		except:
			self.createQueryTable()
			rec = qdata.results_qpref(sqlobj)
		defqueries=[]
		for r in rec:
			id   = r["id"]
			name = r["name"]
			cond = eval(r["cond"])
			indexed = eval(r["indexed"])
			viewed = eval(r["viewed"])
			defqueries.append((id,name,cond,indexed,viewed))
		return defqueries
	
	def add_report(self,Tableid,name,Cond,indexedFields,viewedFields,request):
		sessionID = request["QuerySession"]
		minCol=int(request.SESSION[sessionID]['min_col'])
		maxCol=int(request.SESSION[sessionID]['max_col'])
		viewedHeads=copy.deepcopy(request.SESSION[sessionID]['notIndexedFields'][minCol:maxCol])
		
		tableid = request.SESSION[sessionID]['table_attr']['tagid']
		username = self.getUserName()
		qdata = self.aq_inner.aq_parent.kzAuthSQL
		sqlobj = qdata.getsqlobject()
		dic = {"tableid" : str(Tableid),
		       "username": username,
		       "name"    : str(name),
		       "cond"    : str(Cond),
		       "indexed" : str(indexedFields),
		       "viewed"  : str(viewedHeads)
			}
		sqlobj.insertrecords("querytool",dic)
		try:			
			rec = qdata.results_qpref(sqlobj)
		except:
			self.createQueryTable()
			rec = qdata.results_qpref(sqlobj)
	def save_report(self,Tableid,Reportid,name,Cond,indexedFields,savingFields):
		username = self.getUserName()
		qdata = self.aq_inner.aq_parent.kzAuthSQL
		sqlobj = qdata.getsqlobject()
		dic = {"tableid" : str(Tableid),
		       "username": username, 
		       "name"    : str(name), 
		       "cond"    : str(Cond), 
		       "indexed" : str(indexedFields),
		       "viewed"  : str(savingFields) 
			}
		sqlobj.updaterecords("querytool",dic,cond=("id","=",str(Reportid)),auth=0)
		rec = qdata.results_qpref(sqlobj)

	def delete_report(self,Tableid,Reportid):
		if Reportid:
			qdata = self.aq_inner.aq_parent.kzAuthSQL
			sqlobj = qdata.getsqlobject()
			username = self.getUserName()
			
			sqlobj.deleterecords("querytool",cond=(("tableid","like",str(Tableid)),"and",("id","=",str(Reportid))),auth=0)
			rec = qdata.results_qpref(sqlobj)
		
		
		
		
		
	
	

InitializeClass(kzQueryTool)
