# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
###############################################3

## 


###############################################

from Acquisition import aq_base, aq_inner, aq_parent
from OFS import SimpleItem,Moniker
from Globals import DTMLFile
from OFS.Application import Application
from AccessControl import ClassSecurityInfo
from AccessControl.Role import RoleManager
from OFS.SimpleItem import Item
from OFS.PropertyManager import PropertyManager
from OFS.FindSupport import FindSupport
import types
import string
import time
import sys

addProductForm=DTMLFile('dtml/kzReferenceAdd', globals()) 


class kzReference(PropertyManager,SimpleItem.SimpleItem,Application):
  " kzXMLDatabase nesnesi"
  
  meta_type="Kuzgun Reference Plone"
  
  _properties = ({'id':'id'     , 'type':'string', 'mode':'w'},)
  
  manage_main=DTMLFile('dtml/kzReferenceMain',  globals() )
  
  __ac_permissions__=(('Change Database Methods', ('manage_main', 'manage_main')),)
  
  manage_options=(PropertyManager.manage_options +RoleManager.manage_options +Item.manage_options +FindSupport.manage_options)
  
  security = ClassSecurityInfo()
  
  
  def __init__(self, id, title):
    self.id             = id
    self.title          = title
    self.BasePath       = ""  
    self.parent         = ""
  
  def set_parent(self,cnt=None):
    if cnt == None:
      self.parent = self.aq_parent
    else:  
      self.parent = cnt
    
  
  def addFolder(self,container,folderName): # return path
    container.manage_addProduct['CMFPlone'].addPloneFolder\
             (folderName,'')
    return  eval("container."+folderName)
    
    
    
  def addFile(self,folderContainer,fileName,fileContent):# * * * * * *  *
    folderContainer.invokeFactory(type_name="Document",
                                  id=fileName,
                                  title='',
                                  text_format='html',
                                  text=fileContent)
    
    return  eval("folderContainer."+fileName)
   
    
  
  def updateContent(self,fileContainer,fileContent):
    if self.isFile(fileContainer):
      fileContainer.cooked_text  = fileContent
    else:
      raise "kzReference.updateContent: ge�siz container"    
    
  def addProperty(self,container,id,value,type="string"):
    "yen bir property ekler var ise sadece degerini degistirir"
    
    if not container.hasProperty(id): #manage_addProperty(id,value,type)
      container._properties += ({'id':id,'type':type},) # property ekle
    #fi    
    container._setPropValue(id,value) # eklenen property nin degerini ata
    
  
  def getPropertyItems(self,container,path):
    #container    = self.getContainer(path)
    propertyList = container.propertyItems()
    map = {}
    for ids,value in propertyList:
      map[ids] = value
    #endfor 
    map["tagid"] = path
    return map

  def delProperties(self,container,ids=None): #ids=[id1,id2,...]
    "bir veya birden � property siler ids verilmezse hepsi silinir"    
    if ids is None:
      ids = container.propertyIds()
    #fi
    for id in ids:      
      try:
        container._delProperty(id)
      except ValueError:
        pass # property yoksa silinemez
    #endfor      
  
  def changeProperties(self,container,dicProperties): 
    """bir objenin belli property' lerini degistiri eger property yoksa\
    yaratir.\
    dicProperties = {id1:value,id2,value,..}"""
    #dicProperties = {"type":"m","size":"n","boyut":"6"}
    for id,value in dicProperties.items(): # degisecek property listesi
      if container.hasProperty(id):
        container._setPropValue(id,value)
      else:
        # olmayan property yaratilir
        self.addProperty(container,id,value)  # * * * * * * 
      #fi
      if id == 'title' and self.isDocument(container):
        container.setTitle(value)
    #fi   
    #endfor
    
  def listFolderIds(self,container):
   
    if self.isFolder(container):
      return container.objectIds()
  
  def isFolder(self,container):
    return container.meta_type == 'Plone Folder' 
  
  
  def isDocument(self,container):
    return  container.meta_type == "Document"
     
  
  def isFile(self,container):
    return container.meta_type == "Document"

  
  def uniq_id(self,container,tagName):
    id_head = tagName[0]
    id_list = container.objectIds()    
    i = 0
    while (1):
      new_id = id_head + str(i)
      if new_id in id_list:
        i += 1
      else:
        break
    #endWhile
    return new_id
  
  def uniq_file_id(self,container,tagName):
    id_list = container.objectIds()
    i = 0
    while(1):
      new_id = tagName + str(i)
      if new_id in id_list:
        i +=1
      else:
        break
      #fi
    #endWhile
    return new_id
  
  
  
  def sanity_check(self, c, ob):
    # This is called on cut/paste operations to make sure that
    # an object is not cut and pasted into itself or one of its
    # subobjects, which is an undefined situation.
    ob = aq_base(ob)
    while 1:
      if aq_base(c) is ob:
        return 0
      inner = aq_inner(c)
      if aq_parent(inner) is None:
        return 1
      c = aq_parent(inner)
  
      
  
    
########################################################################
# path'e g�islem yapanlar
########################################################################

    
  security.declarePublic('getContainer')
  def getContainer(self,tagid):

    base_path = self.BasePath.replace('/','.')
    container  = eval('self.aq_parent.' + base_path)
    if tagid != '':
      #tagid = tagid.replace('_','.')
      #container = eval('container.'+tagid)
      for id in tagid.split("_"):
        if not id in container.objectIds():
          raise "kzReference.getContainer(%s)" % tagid
        container = getattr(container,id)
    #fi
    return container
  
   
  def copy(self,copyPath,pastePath,new_id=None):
    "path1'i path2'ye kopyalar"
   
    #path1 , id = self.parentSplit(path1)
    copyContainer   =  self.getContainer(copyPath)
    pasteContainer  =  self.getContainer(pastePath)
    tagName         =  copyContainer.getProperty("tagname")

    if (new_id == None and  not pasteContainer.hasProperty(new_id)):

      if self.isFolder(copyContainer):
        new_id = self.uniq_id(pasteContainer,tagName)
      elif self.isFile(copyContainer):
        new_id = self.uniq_file_id(pasteContainer,tagName)
      else:
        pass
      
    try:
      id             = copyContainer.id()  # file'in ismini almak i�
    except:
      id             = copyContainer.id    # folder'in ismini almak i�    
      
    copyContainer   = copyContainer.aq_parent    
    
    
    cp             =  copyContainer.manage_copyObjects(id)
    result         =  pasteContainer.manage_pasteObjects(cp)    # result ={'id':orig_id, 'new_id':id }
    copy_id        =  result[0]["new_id"]
    if copy_id != new_id:
      pasteContainer.manage_renameObject(copy_id,new_id)
    #fi  
    
    if pastePath == "":
      return new_id
    else:
      return pastePath + "_" + new_id
   
  
  def move(self,cutPath,pastePath,new_id=None):# evrim new_id verme
        
    cutContainer     = self.getContainer(cutPath)
    pasteContainer   = self.getContainer(pastePath)    
    tagName          = cutContainer.getProperty("tagname")
    
    if (new_id == None and  not pasteContainer.hasProperty(new_id)):
      
      if self.isFolder(cutContainer):
        new_id = self.uniq_id(pasteContainer,tagName)
      elif self.isFile(copyContainer):
        new_id = self.uniq_file_id(pasteContainer,tagName)
      else:
        pass
    
    try:
      id             = cutContainer.id()  # file'in ismini almak i�
    except:
      id             = cutContainer.id    # folder'in ismini almak i�
      
    cutContainer     = cutContainer.aq_parent
    
    cp               = cutContainer.manage_cutObjects(id)
    result           = pasteContainer.manage_pasteObjects(cp) # {'id':orig_id, 'new_id':id }
    moved_id         = result[0]["new_id"]
    if moved_id != new_id:
      self.manage_renameObject(moved_id,new_id)
    #fi  
    if pastePath == "":
      return new_id
    else:
      return pastePath + "_" + new_id
  
  def delete(self,path,soft=1):
    "path'i verilen objeyi siler soft = 1 ise isaretler"
    container = self.getContainer(path)        
    
    if soft == 1 :
      self.changeProperties(container,{'deleted':'1'})      
    else:         
      try:
        id      = container.id()   # file idsi i�        
      except:
        id      = container.id # folder id'si i� 
        
      container = container.aq_parent     
      container._delObject(id)
  
  def undelete(self,path):
    "fgf"
    container = self.getContainer(path)
    self.changeProperties(container,{'deleted':'0'})
    
  def getFileContent(self,filePath):
    "path'i verilen dosya i�igini getirir"
    container = self.getContainer(filePath)
    if container.meta_type =="Document":
      return container.cooked_text
    

    
########################################################################
# XML' Producti ile uyumluluk saglayan fonksiyonlar 
########################################################################

  def getAttributes(self,tagid):  # tagid : path
    container  = self.getContainer(tagid)
    if hasattr(container,"_properties"):
      return self.getPropertyItems(container,tagid)
    else:
      return {}
  
  def getChilds(self,parentid,tagName="*",attrList="*",restriction=None):
    container  = self.getContainer(parentid)
    childs_id  = container.objectIds()
    result     = []
    for id in childs_id :
      #childContainer  = eval("container."+id) -- evrim
      childContainer  = getattr(container,id)
      path = parentid + "_" + id 
      if hasattr(childContainer,"_properties"):
        properties      = self.getPropertyItems(childContainer,path)
        if Test(properties,tagName,restriction):        
          result.append(properties)
        
    #endfor  
    return result  
  
  def getChilds_auth(self,parentid,tagName='*',attrList='*',restriction=None):
    result = self.getChilds(parentid,tagName,attrList,restriction)
    #container = self.getContainer(parentid)
    #childs_id = []
    #result = []
    #
    #for child_path in self.getChildsId(parentid):
    #  id = child_path.split('_')[-1]
    #  childContainer = eval('container.'+id)
    #  properties     = self.getPropertyItems(childContainer,child_path)
    #  if Test(properties,tagName,restriction):
    #    if attrList == '*':
    #      result.append(properties)
    #      childs_id.append(properties["tagid"])
    #    else:
    #      new_dic = {}
    #      for attr in attrList:
    #        try:
    #          new_dic[attr] = properties[attr]
    #        except:
    #          new_dic[attr] = ''
    #      #endfor
    #      result.append(new_dic)
    #      childs_id.append(new_dic["tagid"])
    #    #fi
    #  #fi
    #endfor
    childs_id = []
    for res in result:
      childs_id.append(res['tagid'])
    
    childs_id.append(parentid)
    auth_childs_id = self.aq_parent.kzAuthSQL.getAuthList(childs_id)
    auth_result = []
    for res in result:
      if res["tagid"] in auth_childs_id:
        auth_result.append(res)

    return auth_result
                
  def getChildsId(self,parentid):
    container = self.getContainer(parentid)
    childs_id = container.objectIds()
    result    = []
    for id in childs_id :
      tagid   = parentid + "_" +id
      result.append(tagid)
    #endfor
    return result

  
  def insertNode(self,parentid,tagName,dAttributes,new_id=None):
    container   = self.getContainer(parentid)
    if new_id == None:
      new_id      = self.uniq_id(container,tagName)
    f_container = self.addFolder(container,new_id)
    dAttributes['tagname'] = tagName
    dAttributes['deleted'] = '0'
    self.changeProperties(f_container,dAttributes)
    if parentid == "":
      return new_id
    return parentid + "_" + new_id  
  
  
   
  def updateNode(self,path,dAttributes):
    try:
      del dAttributes['deleted']
    except:
      pass
    container   = self.getContainer(path)
    self.changeProperties(container,dAttributes)          
   
  def getAllGroups(self,parentid='',restriction=None):
    "return all childs with recursion"
    # restrictions = [restrtiction1,restriction2]
    # restriction = ['attr','operator','value']
    result = []
    for child in self.getChilds(parentid,'group'):
      if Test(child,'group',restriction):
        result.append(child)
      #fi
      result += self.getAllGroups(child['tagid'],restriction)
    #endfor
    return result
  
  def getAllTables(self,parentid='',restriction=None):
    result = []
    leaf_groups = self.getAllGroups(parentid,restriction=['isleaf','==','T'])
    parent = self.getAttributes(parentid)
    try:
      if parent['tagname']=='group' and parent['isleaf'] == 'T':
        leaf_groups.append(parent)
    except:
      pass
                                                                                
    for group in leaf_groups:
      for table in self.getChilds(group['tagid'],'table'):
        if Test(table,'table',restriction):
          result.append(table)
        #fi
        for subTable in self.getChilds(table['tagid'],'table'):
          if Test(subTable,'table',restriction):
            result.append(subTable)
          #fi
        # endfor
      #endfor
    #endfor
    return result


  def insertFile(self,parentid,tagName,content,dAttributes):
    folderContainer = self.getContainer(parentid)
    fileName        = self.uniq_file_id(folderContainer,tagName)
    fileContainer   = self.addFile(folderContainer,fileName,content)
    dAttributes['tagname'] = tagName
    dAttributes['deleted'] = '0'
    self.changeProperties(fileContainer,dAttributes)
    if parentid == "":
      return fileName
    return parentid + "_" +fileName
    
  def updateFile(self,tagid,content=None,dAttributes=None):
    fileContainer  = self.getContainer(tagid)
    if self.isFile(fileContainer):
      if content is not None :
        fileContainer.cooked_text = content
      #fi
      if dAttributes is not None :
        try:
          del dAttributes['deleted']
        except:
          pass
        self.changeProperties(fileContainer,dAttributes)
      #fi
    #fi  
  

#########################################################################        
# Product zelliklerini EDIT etmeye yarar
#########################################################################      
  def manage_editAction(self,BasePath, RESPONSE=None):
    " Product zelliklerini gncellemeye yarar"
    
    pass
      
 
def Test(properties,tagName,restriction):

  test_tagname     = 0
  test_restriction = 0
  
  if tagName == "*":
    test_tagname = 1
  elif properties["tagname"] == tagName:
    test_tagname = 1
  else :
    return 0
  if restriction == None:
    try:
      if properties['deleted'] == '1':
        return 0
    except:
      pass
    test_restriction = 1
  else:    
    test_restriction = 0
    # silinmisleri gosterme
    try:
      if restriction[0] != 'deleted' and properties['deleted'] == '1':
        return 0
      #fi 
    except:
      pass
      
    try:
      value1   = '"' + properties[restriction[0]] + '"'
    except KeyError:
      return 0  # test edileck �lik yoksa
    
    operator = restriction[1]
    try:
      value2 = properties[restriction[2]]
    except KeyError:
      value2 = '"' + restriction[2] + '"'
    test_string = "test_restriction = "+ value1 + operator + value2 
    exec(test_string)
    
  #fi  
  return test_restriction and test_tagname
    
    
#########################################################################        
# Yeni bir Product eklemeye yarar
#########################################################################   
   
def manage_addProduct(self, id, title, BasePath, RESPONSE=None):
  "product ekler"
   
  if (id==""):# or context.user_reference.BasePath(BasePath==""):
    RESPONSE.redirect('addFolderForm')
  
  else:
    temp  = kzReference(id, title)
    if BasePath[0]=='/':
      BasePath = BasePath[1:]
    temp.BasePath = BasePath
    self._setObject(id, temp)
   
  if RESPONSE!=None:
    RESPONSE.redirect('manage_workspace')
  
    
    
    
    
    

    
    
