# -*- coding: utf-8 -*-
from config import *
from AccessControl import ClassSecurityInfo
from Translateable import Translateable
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate
from Products.PythonScripts.PythonScript import PythonScript
import string
import sys

class kzHtmlReport(BaseFolder,Translateable):
    """kzHtmlReport """
    
    schema = schema
    
    meta_type = 'kzHtmlReport'
    archetype_name = "Kuzgun Html Report"
    tagname="templates"
    
    actions = (
        {
                'id': 'output',
                'action':'string:$object_url/kzreport_output',
                },
        )
    
    global_allow = 1
    filter_content_types = 1
    allowed_content_types = []
    
    security = ClassSecurityInfo()
    
    def __init__(self, oid, tableid="", **kwargs):
        BaseFolder.__init__(self,oid,**kwargs)
	self.setTableid(tableid)
    
	
    def manage_afterAdd(self, item, container):
	BaseFolder.manage_afterAdd(self, item, container)
	self.setPythonScript()
	self.setReportTemplate()
    
    
    def setTemplatetext(self, value, **kwargs):
        self.getField('templatetext').set(self, value, **kwargs)
        self.setReportTemplate()
            
         
    def setScriptparams(self, value, **kwargs):
        self.getField('scriptparams').set(self, value, **kwargs)
        self.setPythonScript()
        
     
    def setScripttext(self, value, **kwargs):
        self.getField('scripttext').set(self, value, **kwargs)
        self.setPythonScript()
	
    def setTemplateData(self,dic):
	self.setTitle(dic.get('title',''))
	self.setSysparams(dic.get('sysparams','').split(','))
        self.setTemplatetext(dic.get('templatetext',''))
	self.setScriptparams(dic.get('scriptparams','').split(','))
	self.setScripttext(dic.get('scripttext',''))
	
    def getTemplateData(self):
        return {"id"          : self.getId(),
	        "title"       : self.Title(),
                "tableid"     : self.getTableid(),
                "sysparams"   : string.join(self.getSysparams(),','),
                "templatetext": self.getTemplatetext(),
                "scriptparams": string.join(self.getScriptparams(),','),
                "scripttext"  : self.getScripttext()
                }
	
    def getScriptErrors(self):
	if not 'script' in self.objectIds():
	    return ""
	else:
	    errors = getattr(self.script,"errors","")
	    if errors:
		return str(errors)
	    else:
		return ""
	
	
    def getTemplateErrors(self):
	if not 'template' in self.objectIds():
	    return ""
	else:
	    if len(self.template._v_errors):
		return "%s:%s" % (self.template._v_errors[0],self.template._v_errors[1])
	    else: 
		return ""
	
	
    def getTemplateOutput(self):
	templateErrors = self.getTemplateErrors()
	if templateErrors:
	    return templateErrors
	else:
	    try:
		self.setParameters()
		result = self.template._exec(bound_names={"traverse_subpath":[]},
					     args = (),
					     kw = {"error_message":'', "error_tb":'',
						   "error_type":'', "error_value":''})
            except:
                result = "%s:%s" % (sys.exc_type,sys.exc_value)

	    return result
	
    def getTemplateOutputAction(self):
	return "%s/kzreport_output" % self.absolute_url()
	
        
    def Schemata(self):
	schemata = BaseFolder.Schemata(self)
	controller_state = self.REQUEST["controller_state"]
	templateErrors = self.getTemplateErrors()
	if templateErrors:
	    controller_state.errors.update({"templatetext":str(templateErrors)})
	scriptErrors   = self.getScriptErrors()
	if scriptErrors:
	    controller_state.errors.update({"scripttext":str(scriptErrors)})
	if controller_state.errors:
	    controller_state.status = 'failure'
	return schemata
    
    def view(self):
	pass    
            
    def setReportTemplate(self):
        templatetext = self.getField("templatetext").get(self) 
        # Set Template Object
        if not 'template' in self.objectIds():
            self._setObject('template',ZopePageTemplate(id='template',text=templatetext))
        else:    
            self.template.pt_edit(templatetext,None)
                  
        
    def setPythonScript(self):
        scriptparams = self.getField("scriptparams").get(self) 
	scriptparams = string.join(scriptparams,",")
        scripttext = self.getField("scripttext").get(self)     
        # Set Python Script    
        if not 'script' in self.objectIds():
            self._setObject('script', PythonScript(id='script'))
        self.script.ZPythonScript_edit(scriptparams, scripttext)
        
        
    def setParameters(self):
	paramlist = self.getSysparams()
        if paramlist:
	    paramdic  = self.getAllParameters()
	    for param in paramlist:
		tempparam = str(param).strip()
		if tempparam:
		    if paramdic.has_key(tempparam):
			self.REQUEST.set(tempparam,paramdic[tempparam])
        
        
    def getAllParameters(self):
        qref = self.getKuzgunReference()
        dic     = {}
        for param in qref.getChilds(self.getTableid(),"param"):
            paramid  = param.get("paramid","")
            fieldrel = param.get("fieldrelation","")
            if paramid:
                dic[paramid] = fieldrel
        return dic
        
        
    
registerType(kzHtmlReport, PROJECTNAME)
