# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
from OFS.SimpleItem import SimpleItem
from Globals import DTMLFile
from ZODB import Persistent
import thread
from time import time

manage_addProductForm=DTMLFile("dtml/addProduct",globals())


def manage_addProduct(self,id,title,REQUEST=None):
        "Add Product"
        new=kzSharedResource(id,title)
        self._setObject(id,new)
        if REQUEST is not None:
                return self.manage_main(self,REQUEST)
        

class kzSharedResource(SimpleItem,Persistent):
        "Shared Resource"
        
        _storage_lock = thread.allocate_lock()
        _lock_storage = {}
        
        meta_type='Kuzgun SharedResource'  
        
        def __init__(self,id,title=""):
                self.id=id
                self.title=title
                self._time_to_release = 120
                
                
        def getuser(self):
                return str(self.aq_inner.aq_parent.portal_membership.getAuthenticatedMember())
        
                        
        def get_lock(self,file_id):
                self._storage_lock.acquire()
                
                file_lock = self._lock_storage.get(file_id)
                if not file_lock: 
                        self._lock_storage[file_id]=(time(),self.getuser())
                        control = 1
                else:
                        now      = time()
                        locktime = file_lock[0]
                        who      = file_lock[1] 
                        if ( (now-locktime) > self._time_to_release ) or \
                           ( who == self.getuser() ):
                                self._lock_storage[file_id]=(time(),self.getuser())
                                control = 1
                        else :
                                control = 0
                        
                self._storage_lock.release()
                return control
            

        
        def release_lock(self,file_id):
                self._storage_lock.acquire()
                file_lock = self._lock_storage.get(file_id)
                if file_lock: 
                        if file_lock[1] == self.getuser():
                                del self._lock_storage[file_id]
                self._storage_lock.release()
                
                
                
        def is_locked(self,file_id):
                self._storage_lock.acquire()
                file_lock = self._lock_storage.get(file_id)
                self._storage_lock.release()
                if not file_lock: 
                        return 0
                else:
                        now      = time()
                        locktime = file_lock[0]
                        who      = file_lock[1] 
                        if who == self.getuser():
                                return 0
                        elif (now-locktime) > self._time_to_release:
                                return 0
                        else:
                                return 1


                
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        