

__version__ = "0.1.0"

__doc__ = """ Install script to setup kzTask in CMF Site """

from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.kzTask import kzTask ,task_globals


from cStringIO import StringIO
import string

def install(self):
        
        """Register CMFTutorial with the necessary tools"""

        out = StringIO()
        
        typestool = getToolByName(self, 'portal_types')
        skinstool = getToolByName(self, 'portal_skins')

        ## Setup the type
        type = 'kzTask'  #t['meta_type']
        if type not in skinstool.objectIds():
                addDirectoryViews(skinstool, 'skins',task_globals)
                out.write('Added "%s" directory view to portal_skins\n' %type)
        else:
                out.write('Directory view "%s" already added to portal_skins\n' %type)

        
        ## Setup the skins
        skins = skinstool.getSkinSelections()
        for skin in skins:
                path = skinstool.getSkinPath(skin)
                path = map(string.strip, string.split(path,','))
                if type not in path:
                        try: 
                                path.insert(path.index('content'), type)
                        except ValueError:
                                path.append(type)
                        path = string.join(path, ', ')
                        skinstool.addSkinSelection(skin, path)
                        out.write('Added "%s" to "%s" skin\n' %(type, skin))
                else:
                        out.write('Skipping "%s" skin, "%s" is already set up\n' %(skin, type))

        ## Ends
        return out.getvalue()

