# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
from Products.CMFCore.utils             import UniqueObject
from OFS.SimpleItem                     import SimpleItem
from Globals                            import InitializeClass
from AccessControl                      import ClassSecurityInfo
from DateTime                           import DateTime

class kzTask(SimpleItem,UniqueObject):
    """Task Manager"""
    id='kzTaskManager'
    meta_type='kzTaskManager'
    plone_tool=1
    SQLName="kzAuthSQL"
    SQLTable="tasks" # 
    
    security = ClassSecurityInfo()
  
  
    def getTime(self):
        id = str(DateTime())
        list = id.split(" ")
        return "%s-%s" % (list[0],list[1])
    
    def getTaskObject(self,TaskID):
        sqlobj = self.kzAuthSQL.getsqlobject()
        sqlobj.selectrecords("tasks",cond=('id',TaskID),auth=0)
        rec = self.kzAuthSQL.results_qtask(sqlobj)   
        if len(rec):
            return rec[0]
        else:
            return None
        
   
    
    def get(self,TaskID,template=''):
        # Kullaniciyi bul
        userid = str(self.portal_membership.getAuthenticatedMember())
        grouplist = self.kzUserManagement.get_top_groups(userid)
        grouplist.append(userid)
        # Grevi listeden al
        task = self.getTaskObject(TaskID)
        if task is not None:
            # Waiting - Arrived gecisi
            if template == 'detail':
                if len(filterlist(grouplist,task['destination'].split(','))) and \
                   not task['owner'] == userid:
                    if task['mode'] == 'waiting':
                        dic = {"mode":"arrived"}
                        task['mode'] = "arrived"
                        sqlobj = self.kzAuthSQL.getsqlobject()
                        sqlobj.updaterecords("tasks",dic,cond=('id',TaskID),auth=0)
                        self.kzAuthSQL.results_qtask(sqlobj)  
            return task
        else:
            return {}
    
    
    def control_task_destination(self,username="-",destination=""):
        return destination
        sub_users_groups = self.kzUserManagement.get_sub_users_groups(username)
        userslist = []
        for users_groups in sub_users_groups:
            userslist.append(users_groups[0])
        userslist.append(username)    
        dest = str(destination).split(",")
        list = filterlist(userslist , dest)
        return string.join(list,",")
        
    
    def add(self,REQUEST):
        # Yeni bir grev ekler
        if REQUEST.get('owner','') is None:
            username = "_ontime_"
        else:
            username  = str(self.portal_membership.getAuthenticatedMember())

        TaskTime = self.getTime()  
        
        dic = {}
        dic["id"]           = "Task%s" % (TaskTime.replace(':','.').replace('/','.'))
        dic["title"]        = REQUEST.get('title','')
        dic["description"]  = REQUEST.get('description','')
        dic["priority"]     = int(REQUEST.get('priority',''))
        dic["starttime"]    = TaskTime
        dic["deadtime"]     = str(REQUEST.get('deadtime',''))
        # Grev kime atlyor
        dic["destination"]  = self.control_task_destination( username, REQUEST.get('destination',''))
        dic["owner"]        = username
        dic["mode"]         = "waiting"
        dic["relatedtable"] = REQUEST.get('relatedtable','')
        dic["relatedrecno"] = REQUEST.get('relatedrecno','')
        
        if len(dic["destination"]):
            sqlobj = self.kzAuthSQL.getsqlobject()
            sqlobj.insertrecords("tasks",dic)
            self.kzAuthSQL.results_qtask(sqlobj)
        
        
    def update(self,REQUEST):
        # Belirtilen grevi gnceller
        username = str(self.portal_membership.getAuthenticatedMember())
        TaskID = REQUEST.get('id','')
        
        dic = {}
        if REQUEST.has_key('detail'):
            dic["mode"]         = REQUEST.get('mode','waiting')
        else:    
            dic["title"]        = REQUEST.get('title','')
            dic["description"]  = REQUEST.get('description','')
            dic["priority"]     = int(REQUEST.get('priority',0))
            dic["deadtime"]     = str(REQUEST.get('deadtime',''))
            # Grev kime atlyor
            dic["destination"]  = self.control_task_destination( username, REQUEST.get('destination',''))
            dic["owner"]        = username
        
        if len(dic.get("destination",'')) or REQUEST.has_key('detail'):
            sqlobj = self.kzAuthSQL.getsqlobject()
            sqlobj.updaterecords("tasks",dic,cond=('id',TaskID),auth=0)
            self.kzAuthSQL.results_qtask(sqlobj)    
    

    def delete(self,request):
        # Belirtilen grevi siler
        TaskID = request.get('id','')
        sqlobj = self.kzAuthSQL.getsqlobject()
        sqlobj.deleterecords("tasks",cond=('id',TaskID),auth=0)
        self.kzAuthSQL.results_qtask(sqlobj)    
   
            
    def setMode(self,TaskID,mode='waiting'):
        # Grevin durumunu deitirir
        ## mode : waiting , arrived , rejected , accepted , completed , hidden 
        sqlobj = self.kzAuthSQL.getsqlobject()
        dic = {"mode":mode}
        sqlobj.updaterecords("tasks",dic,cond=('id',TaskID),auth=0)
        self.kzAuthSQL.results_qtask(sqlobj) 
        
   
    def swap_by_mode(self,owner=[],mode=[]):
        sqlobj = self.kzAuthSQL.getsqlobject()
        ownercond = ()
        modecond = ()
        if owner != "_all_":
            if type(owner) == type([]):
                for o in owner:
                    if len(ownercond):
                        ownercond = ( ownercond,'or',('owner',str(o).strip()) )
                    else:
                        ownercond = ('owner',str(o).strip())
            elif type(owner) == type(""):
                ownercond = ('owner',str(owner).strip())
            
        if mode != "_all_":
            if type(mode) == type([]):
                for m in mode:
                    if len(modecond):
                        modecond = (modecond,'or',('mode',str(m).strip()))
                    else:
                        modecond = ('mode',str(m).strip())
            elif type(mode) == type(""):
                modecond = ('mode',str(mode).strip() )
                
        if len(ownercond) and len(modecond):
            cond = (ownercond,'and',modecond)
        elif len(ownercond):
            cond = ownercond
        elif len(modecond):  
            cond = modecond
        else:
            cond = ()
            
        sqlobj.selectrecords("tasks",cond=cond,auth=0)    
        return self.kzAuthSQL.results_qtask(sqlobj) 
        
        
            
            
    def view(self, mode=[]):
        # Kii Grevlerini Grr
        if not self.portal_membership.isAnonymousUser():
            userid    = str(self.portal_membership.getAuthenticatedMember())
            grouplist = self.kzUserManagement.get_top_groups(userid)
            grouplist.append(userid)
            
            # Sorgu oluturulur
            
            if mode == 'advanced':
                cond = ()
            else:
                destcond = ()
                for group in grouplist:
                    if len(destcond):
                        destcond = ( destcond,'or',('destination','like','%s%s%s' % ('%',group,'%') ))
                    else:
                        destcond = ('destination','like','%s%s%s' % ('%',group,'%') )
                modecond = ()
                for taskmode in mode:
                    if len(modecond):
                        modecond = ( modecond,'or',('mode',str(taskmode)))
                    else:
                        modecond = ('mode',taskmode)
                cond = (( modecond,'and',destcond ),'and',('mode','!=','hidden'))
                                    
            sqlobj = self.kzAuthSQL.getsqlobject()
            sqlobj.selectrecords("tasks",cond=cond,auth=0)
            inboxtasks = self.kzAuthSQL.results_qtask(sqlobj)           
                             
            cond = (('owner',userid),'and',('mode','!=','hidden'))
            sqlobj = self.kzAuthSQL.getsqlobject()
            sqlobj.selectrecords("tasks",cond=cond,auth=0)
            outboxtasks = self.kzAuthSQL.results_qtask(sqlobj)  
            
            return {'inbox':inboxtasks,'outbox':outboxtasks}
        else:
            return {'inbox':{},'outbox':{} }
    
   
    
def filterlist(list1,list2):
    # list2'nin elemanlarindan hangileri list1'de var
    list = []
    for x in list2:
        if x in list1:
            list.append(x)
    return list        
            
        
        
        
        
InitializeClass(kzTask)

