# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
from config import *
from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions

from OFS.ObjectManager   import ObjectManager
from OFS.PropertyManager import PropertyManager
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate
from Products.PythonScripts.PythonScript import PythonScript

import sys


schema = BaseSchema +  Schema((
   StringField('Table ID',
                searchable=1,
                widget=StringWidget,
                ),   
    
    StringField('System Parameters',
                searchable=1,
                widget=StringWidget,
                ),        
                               
   TextField('TAL Template',
              searchable=1,
              required=1,
              allowable_content_types=('text/plain',
                                       'text/structured',
                                       'text/html',),
              widget=TextAreaWidget(rows=40,cols=60),
              ),
                               
   StringField('Script Parameters',
                searchable=0,
                widget=StringWidget,
                ),
                               
   TextField('Python Script',
              searchable=1,
              required=0,
              allowable_content_types=('text/plain',
                                       'text/structured',
                                       'text/html',),
              widget=TextAreaWidget(rows=40,cols=60),
              ),
                               
            
    ))

       




class kzTemplates(BaseContent,PropertyManager,ObjectManager):
    # Kuzgun Template Document

    schema = schema
    
    _properties = ({'id':'id' , 'type':'string', 'mode':'w'},
                   {'id':'title' , 'type':'string', 'mode':'w'},
                   {'id':'tagname' , 'type':'string', 'mode':'w'},)

    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'kzTemplates_view',
        'permissions': (CMFCorePermissions.View,) 
        },
    )
    
    def setTableid(self,tableid):
        setattr(self,'Table ID',tableid)
    
    def getTemplateData(self):
        title     = str(getattr(self,'title',""))
        tableid   = str(getattr(self,'Table ID',""))
        sysparams = str(getattr(self,'System Parameters',""))
        if hasattr(getattr(self,'TAL Template'),'data'):
            tal = str(getattr(self,'TAL Template',"").data)
        else:    
            tal = str(getattr(self,'TAL Template',""))
        params    = str(getattr(self,'Script Parameters',""))
        if hasattr(getattr(self,'Python Script'),'data'):
            script = str(getattr(self,'Python Script',"").data)
        else:    
            script = str(getattr(self,'Python Script',""))
            
        return {"id"          : self.getId(),
                "title"       : title,
                "tableid"     : tableid,
                "sysparams"   : sysparams,
                "templatetext": tal,
                "scriptparams": params,
                "scripttext"  : script
                }
    

    def setTemplateData(self,dic):
        self.setTitle(dic.get('title',''))
        setattr(self,'System Parameters',dic.get('sysparams',''))
        talobj = getattr(self,'TAL Template')
        if hasattr(talobj,'data'):
            setattr(talobj,'data',dic.get('templatetext',''))
        else:
            setattr(talobj,'raw',dic.get('templatetext',''))
        setattr(self,'Script Parameters',dic.get('scriptparams',''))
        scrobj = getattr(self,'Python Script')
        if hasattr(scrobj,'data'):
            setattr(scrobj,'data',dic.get('scripttext',''))
        else:
            setattr(scrobj,'raw',dic.get('scripttext',''))
            
            
    def getScriptErrors(self):
	if not 'script' in self.objectIds():
	    return ""
	else:
	    errors = getattr(self.script,"errors","")
	    if errors:
		return str(errors)
	    else:
		return ""
	
	
    def getTemplateErrors(self):
	if not 'tal' in self.objectIds():
	    return ""
	else:
	    if len(self.tal._v_errors):
		return "%s:%s" % (self.tal._v_errors[0],self.tal._v_errors[1])
	    else: 
		return ""        
        
    def getTemplateOutput(self):
	return view()
    
    def getTemplateOutputAction(self):
	return "%s/kzTemplates_view" % self.absolute_url()
        
    def view(self):
        tempdata  = self.getTemplateData()
        tableid   = tempdata['tableid']
        sysparams = tempdata['sysparams']
        tal       = tempdata['templatetext']
        params    = tempdata['scriptparams']
        script    = tempdata['scripttext']
        
        # Set Parameters
        self.setParameters(sysparams)
        self.sysparams=sysparams
        # Set Belong Table
        self.tableid = tableid
        # Set TAL Template
        if not hasattr(self,'tal'):
            self._setObject('tal',ZopePageTemplate(id='tal',text=tal))
        else:    
            self.tal.pt_edit(tal,None)
        if hasattr(self,'script'):
            self._delObject('script')    
        # Set Python Script    
        if not hasattr(self,'script'):
            self._setObject('script', PythonScript(id='script'))
        self.script.ZPythonScript_edit(params, script)
                
        if len(self.tal._v_errors):
            result = "%s:%s" % (self.tal._v_errors[0],self.tal._v_errors[1])
        else:    
            try:
                result = self.tal._exec(bound_names={"traverse_subpath":[]},
                          args = (),
                          kw={"error_message":'',
                              "error_tb":'',
                              "error_type":'',
                              "error_value":''})
            except:
                result = "%s:%s" % (sys.exc_type,sys.exc_value)
                
        return str(result)
    
    def setParameters(self,sysparams):
        if str(sysparams).strip():
            paramlist = str(sysparams).strip().split(",")
            paramdic  = self.getAllParameters()
            REQUEST   = self.aq_parent.REQUEST
            for param in paramlist:
                if str(param).strip():
                    if param[0] == "$" and param[-1] == "$":
                        temp = param[1:-1]
                        if paramdic.has_key(temp):
                            REQUEST.set(temp,paramdic[temp])
        
        
        
    def getAllParameters(self):
        objects = self.aq_inner.aq_parent.objectValues()
        dic     = {}
        for object in objects:
            if getattr(object,"tagname","") == "param":
                paramid  = getattr(object,"paramid","")
                fieldrel = getattr(object,"fieldrelation","")
                if len(paramid):
                    dic[paramid] = fieldrel
        return dic
        
        
        
        
        
    
    
registerType(kzTemplates)
