

__version__ = "0.1.0"

__doc__ = """ Install script to setup kzTask in CMF Site """

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.kzUserManagement import kzUserManagement ,user_management_globals


from cStringIO import StringIO
import string

def install(self):
        
        """Register CMFTutorial with the necessary tools"""

        out = StringIO()
        
        typestool = getToolByName(self, 'portal_types')
        skinstool = getToolByName(self, 'portal_skins')


        type_list = ['KuzgunUserManagement']  #t['meta_type']
	for type in type_list:
                if type not in skinstool.objectIds():
                        addDirectoryViews(skinstool, 'skins',user_management_globals)
                        out.write('Added "%s" directory view to portal_skins\n' %type)
                else:
                        out.write('Directory view "%s" already added to portal_skins\n' %type)

        ## Setup the skins
        skins = skinstool.getSkinSelections()
        for skin in skins:
                path = skinstool.getSkinPath(skin)
                path = map(string.strip, string.split(path,','))
		for type in type_list:
                        if type not in path:
                                try:
                                        path.insert(1, type)
                                except ValueError:
                                        path.append(type)
                                out.write('Added "%s" to "%s" skin\n' %(type, skin))
                        else:
                                out.write('Skipping "%s" skin, "%s" is already set up\n' %(skin, type))
				
		path = string.join(path,",")		
		skinstool.addSkinSelection(skin, path)		

        ## Ends
        return out.getvalue()
