# kzManageUsers
from kzManageProducts import kzManageProducts
from Products.CMFCore.utils import _limitGrantedRoles
from Products.CMFCore.utils import getToolByName
import string

class kzUsers:
  # Manages Users
  
  def __init__(self,container,tagid):
    self.username  = tagid.strip()
    self.password  = ""
    self.fullname  = "--"
    self.email     = "none@none.com"
    self.mailpasswd= 1
    self.acl       = {'users':0,'desicion':0,'application':0,'report':0}
           
    try: self.container = container.Members.Objects
    except: raise "kzUsers:Members.Objects not found"
    
    
  def set(self,dic={}):
    # Kullanc zelliklerini ayarlar
    self.fullname = str(dic.get('fullname','-')).strip()
    self.email    = str(dic.get('email','none@none.com')).strip()
    if dic.has_key("password"):
      self.password = str(dic["password"]).strip()
      
   
  def set_auth(self,users,desicion,application,report):
    # Kullanabilecei modller ayarlanr
    self.acl = {'users':0,'desicion':0,'application':0,'report':0}
    if users:
      self.acl['users']    = 1
    if desicion:
      self.acl['desicion'] = 1
    if application:
      self.acl['application'] = 1
    if report:
      self.acl['report']   = 1
      
  def insert(self):
    self.insert_user()
    self.insert_products()
      
  
  def insert_user(self):
    portal_properties   = getattr(self.container,'portal_properties')
    portal_registration = getattr(self.container,'portal_registration')
    control             = 0
    # Kullanici iin ifre ret
    if str(self.password) == "":
      self.password = portal_registration.generatePassword()
      control = 1
    elif len(self.password)<5:
      self.password = string.zfill(self.password.strip(),5)
      
    # Kullancy sisteme ekle 
    properties = {'email':self.email,'username':self.username,
                  'fullname':self.fullname}
    
    msg = portal_registration.testPropertiesValidity(properties)
    if msg is not None:
      self.email = "none@none.com"
      properties['email'] = self.email
    
    # ADD MEMBER
    portal_registration.addMember(id=self.username,password=self.password,properties=properties) 
    
  
  def insert_products(self):
    obj = kzManageProducts(self.container,self.username)
    # Hangi modller aylacak
    obj.set(self.acl['users'],
            self.acl['desicion'],
            self.acl['application'],
            self.acl['report'])
    obj.main()
    
    
  def update(self):
    self.update_user()
    self.update_products()
 
  def update_user(self):
    # Kisisel bilgiler
    memberData          = self.container.portal_memberdata._members[self.username]
    memberData.email    = self.email
    memberData.fullname = self.fullname
    # Acl bilgileri
    portal_registration = getattr(self.container,'portal_registration')
    if str(self.password) == "":
      self.password = portal_registration.generatePassword()
    elif len(self.password)<5:
      self.password = string.zfill(self.password.strip(),5)
    acldata    = self.container.acl_users
    acldata._updateUser(self.username, self.password)
      
  def update_products(self):
    obj = kzManageProducts(self.container,self.username)
    # Hangi modller aylacak
    obj.set(self.acl['users'],
            self.acl['desicion'],
            self.acl['application'],
            self.acl['report'])
    obj.main()
  
  
  def delete(self):
    try: self.delete_products()
    except: pass
    try: self.delete_user()    
    except: pass
  
  def delete_user(self):
    # delete home folder
    callobj = eval("self.container.Members")
    callobj._delObject(self.username) 
    # delete from acl_users
    self.container.acl_users.userFolderDelUsers([self.username]) 
  
  def delete_products(self):
    objectsFolder = eval("self.container.Objects")
    objectsFolder._delObject(self.username)
    
  
  
    